<?php

class Addoldcolumns extends Controller {

    function Addoldcolumns() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->model('configmodel');
    }

    function listcolumns() {
        $plotID = $this->session->userdata('configPlotID');
        $plotName = $this->session->userdata('plotName');
        //$plotName = $this->configmodel->getPlotNameByID($plotID);
        $formType = $this->session->userdata('formType');
        $formName = $this->_getFormName($formType);
        $this->table->set_empty("&nbsp;");
        $this->table->add_row(anchor('addoldcolumns/subquadrat', 'Subquadrat', array('class' => 'add')));
        $this->table->add_row(anchor('addoldcolumns/treetag', 'Tree Tag', array('class' => 'add')));
        $this->table->add_row(anchor('addoldcolumns/stemtag', 'Stem Tag', array('class' => 'add')));
        $this->table->add_row(anchor('addoldcolumns/species', 'Species', array('class' => 'add')));
        $this->table->add_row(anchor('addoldcolumns/dbh', 'DBH', array('class' => 'add')));
        $this->table->add_row(anchor('addoldcolumns/code', 'Codes', array('class' => 'add')));
        $this->table->add_row(anchor('addoldcolumns/hom', 'HOM', array('class' => 'add')));
        $this->table->add_row(anchor('addoldcolumns/qx', 'QX', array('class' => 'add')));
        $this->table->add_row(anchor('addoldcolumns/qy', 'QY', array('class' => 'add')));
        $this->table->add_row("");
        $this->table->add_row(
                             '<span style="color:#FF0000;">Incase there is no Subquadrat column in form - Add following Tree Tag with Subquarat Info</span>'
                             );
        $this->table->add_row(anchor('addoldcolumns/nosubtreetag', 'Tree Tag', array('class' => 'add')));
        $this->table->add_row("");
        $this->table->add_row(
                             '<span style="color:#454545;"><b>Add column from \'ViewFullTable\' to display on entry form.</b></span>'
                             );
        $this->table->add_row(anchor('addoldcolumns/viewfullextra', 'Old Column - From ViewFullTable', array('class' =>
                             'add')));
        $data['table'] = $this->table->generate();
        $data['backLink'] = anchor('forms/addcolumn/', 'Back', array('class' => 'back'));
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Select to add an Old Column - ".$plotName." - ".$formName;
        $data['formHeading'] = "";
        $this->load->view('forms/selectcolumntype', $data);
    }

    function selectcolumntype() {
        $plotID = $this->session->userdata('configPlotID');
        $plotName = $this->session->userdata('plotName');
        //$plotName = $this->configmodel->getPlotNameByID($plotID);
        $formType = $this->session->userdata('formType');
        $formName = $this->_getFormName($formType);
        $this->table->set_empty("&nbsp;");
        $this->table->add_row(anchor('addoldcolumns/textform',
                             'Simple textbox with text, integer or decimal values without limits', array('class' =>
                             'add')));
        $this->table->add_row(anchor('addoldcolumns/limitform', 'Simple textbox with numeric value with limits', array(
                             'class' => 'add')));
        $data['table'] = $this->table->generate();
        $data['backLink'] = anchor('forms/addcolumn/', 'Back', array('class' => 'back'));
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Select to add an Old Column - ".$plotName." - ".$formName;
        $data['formHeading'] = "";
        $this->load->view('forms/selectcolumntype', $data);
    }

    ///////////////////////////////////////////////////////
    function subquadrat() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Subquadrat";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/subquadratvalidate");
        $data['table'] = $this->_subquadFormTable();
        $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function subquadratvalidate() {
        $this->_validatesubquadqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Subquadrat";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/subquadratvalidate");
            $data['table'] = $this->_subquadFormTable();
            $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "oldcolumn";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $startsWith = $this->input->post('startsWith');
            $maxX = $this->input->post('maxX');
            $maxY = $this->input->post('maxY');
            //$subquadQuery = $this->input->post('subquadQuery');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize, $startsWith, $maxX, $maxY));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _subquadFormTable() {
        $plotID = $this->session->userdata('configPlotID');
        $columnHeader = set_value('columnHeader');
        $columnName = 'subquadrat';
        $maxX = set_value('maxX');
        $maxY = set_value('maxY');
        /*$subquadQuery = set_value('subquadQuery');
        if($subquadQuery == "")
        {
        $subquadQuery = "SELECT QDimX as DimX, QDimY as DimY FROM Site WHERE PlotID = $plotID";
        }*/
        if ($maxX == '') {
            $maxX = 5;
        }
        if ($maxY == '') {
            $maxY = 5;
        }
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName,
                            'readonly' => 'readonly', 'style' => 'background:#CCCCCC;');
        $maxXA = array('name' => 'maxX', 'id' => 'maxX', 'size' => '9', 'value' => $maxX);
        $maxYA = array('name' => 'maxY', 'id' => 'maxY', 'size' => '9', 'value' => $maxY);
        $startsWithA = array('0' => '0', '1' => '1', 'A'=>'A');
        //$subquadQueryA = array('name'=>'subquadQuery','id'=>'subquadQuery','value'=>$subquadQuery,'class'=>'textarea1');
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $startsWithDD = form_dropdown('startsWith', $startsWithA);
        $maxXTbx = form_input($maxXA);
        $maxYTbx = form_input($maxYA);
        $columnSizeTbx = form_input($columnSizeA);
        //$subquadQueryTarea = form_textarea($subquadQueryA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $maxXErr = form_error('maxX');
        $maxYErr = form_error('maxY');
        $columnSizeErr = form_error('columnSize');
        //$subquadQueryErr = form_error('subquadQuery');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx,$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx,$columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array('Starts With : ', $startsWithDD), array('Max X: ', 'DimX / '.$maxXTbx, $maxXErr),
                           array('Max Y: ', 'DimY / '.$maxYTbx, $maxYErr),
        //array('Subquadrat Query : ',$subquadQueryTarea),
        //array('',$subquadQueryErr),
        array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatesubquadqueryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_rules('maxX', 'Max X', 'trim|required');
        $this->form_validation->set_rules('maxY', 'Max Y', 'trim|required');
        //$this->form_validation->set_rules('subquadQuery','Subquadrat Query','required');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    //////////////////////////////////////////////////////
    /////////////////////////////////////////////////////
    function treetag() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Tree Tag";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/treetagvalidate");
        $data['table'] = $this->_treetagFormTable();
        $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function treetagvalidate() {
        $this->_validatetreetagqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Tree Tag";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/treetagvalidate");
            $data['table'] = $this->_treetagFormTable();
            $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "oldcolumn";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _treetagFormTable() {
        $plotID = $this->session->userdata('configPlotID');
        $columnHeader = set_value('columnHeader');
        $columnName = 'tag';
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName,
                            'readonly' => 'readonly', 'style' => 'background:#CCCCCC;');
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $columnSizeTbx = form_input($columnSizeA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx,$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx,$columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatetreetagqueryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ///////////////////////////////////////////////////////
    /////////////////////////////////////////////////////
    function nosubtreetag() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Tree Tag - No Subquadrat";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/nosubtreetagvalidate");
        $data['table'] = $this->_nosubTreetagFormTable();
        $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function nosubtreetagvalidate() {
        $this->_validatenosubtreetagqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Tree Tag - No Subquadra";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/nosubtreetagvalidate");
            $data['table'] = $this->_nosubTreetagFormTable();
            $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "oldcolumn";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $maxX = $this->input->post('maxX');
            $maxY = $this->input->post('maxY');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize, $maxX, $maxY));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _nosubTreetagFormTable() {
        $plotID = $this->session->userdata('configPlotID');
        $columnHeader = set_value('columnHeader');
        $columnName = 'nosubTag';
        $columnSize = set_value('columnSize');
        $maxX = set_value('maxX');
        $maxY = set_value('maxY');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        if ($maxX == '') {
            $maxX = 5;
        }
        if ($maxY == '') {
            $maxY = 5;
        }
        $maxXA = array('name' => 'maxX', 'id' => 'maxX', 'size' => '9', 'value' => $maxX);
        $maxYA = array('name' => 'maxY', 'id' => 'maxY', 'size' => '9', 'value' => $maxY);
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName,
                            'readonly' => 'readonly', 'style' => 'background:#CCCCCC;');
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $columnSizeTbx = form_input($columnSizeA);
        $maxXTbx = form_input($maxXA);
        $maxYTbx = form_input($maxYA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $columnSizeErr = form_error('columnSize');
        $maxXErr = form_error('maxX');
        $maxYErr = form_error('maxY');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx,$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx,$columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array('Max X: ', 'DimX / '.$maxXTbx, $maxXErr), array('Max Y: ', 'DimY / '.$maxYTbx, $maxYErr
                           ), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatenosubtreetagqueryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_rules('maxX', 'Max X', 'trim|required');
        $this->form_validation->set_rules('maxY', 'Max Y', 'trim|required');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ///////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////
    function stemtag() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Stem Tag";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/stemtagtvalidate");
        $data['table'] = $this->_stemtagFormTable();
        $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function stemtagtvalidate() {
        $this->_validatestemtagqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Stem Tag";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/stemtagvalidate");
            $data['table'] = $this->_stemtagFormTable();
            $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "oldcolumn";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $readOnly = $this->input->post('readOnly');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize, $readOnly));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _stemtagFormTable() {
        $plotID = $this->session->userdata('configPlotID');
        $columnHeader = set_value('columnHeader');
        $columnName = 'stemTag';
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $readOnly = set_value('readOnly');
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName,
                            'readonly' => 'readonly', 'style' => 'background:#CCCCCC;');
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $readOnlyA = array('yes' => 'Yes', 'no' => 'No');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $columnSizeTbx = form_input($columnSizeA);
        $readOnlyDD = form_dropdown('readOnly', $readOnlyA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx,$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx,$columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array('Read Only : ', $readOnlyDD), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatestemtagqueryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    //////////////////////////////////////////////////////
    /////////////////////////////////////////////////////
    function species() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Species";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/speciesvalidate");
        $data['table'] = $this->_speciesFormTable();
        $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function speciesvalidate() {
        $this->_validatespeciesqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Species";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/speciesvalidate");
            $data['table'] = $this->_speciesFormTable();
            $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "oldcolumn";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _speciesFormTable() {
        $plotID = $this->session->userdata('configPlotID');
        $columnHeader = set_value('columnHeader');
        $columnName = 'species';
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName,
                            'readonly' => 'readonly', 'style' => 'background:#CCCCCC;');
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $columnSizeTbx = form_input($columnSizeA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx,$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx,$columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatespeciesqueryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ///////////////////////////////////////////////////////
    /////////////////////////////////////////////////////
    function dbh() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "DBH";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/dbhvalidate");
        $data['table'] = $this->_dbhFormTable();
        $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function dbhvalidate() {
        $this->_validatedbhqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "DBH";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/dbhvalidate");
            $data['table'] = $this->_dbhFormTable();
            $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "oldcolumn";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _dbhFormTable() {
        $plotID = $this->session->userdata('configPlotID');
        $columnHeader = set_value('columnHeader');
        $columnName = 'olddbh';
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName,
                            'readonly' => 'readonly', 'style' => 'background:#CCCCCC;');
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $columnSizeTbx = form_input($columnSizeA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx,$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx,$columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatedbhqueryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ///////////////////////////////////////////////////////
    /////////////////////////////////////////////////////
    function code() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Codes";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/codevalidate");
        $data['table'] = $this->_codeFormTable();
        $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function codevalidate() {
        $this->_validatecodequeryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Codes";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/codevalidate");
            $data['table'] = $this->_codeFormTable();
            $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "oldcolumn";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _codeFormTable() {
        $plotID = $this->session->userdata('configPlotID');
        $columnHeader = set_value('columnHeader');
        $columnName = 'oldcodes';
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName,
                            'readonly' => 'readonly', 'style' => 'background:#CCCCCC;');
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $columnSizeTbx = form_input($columnSizeA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx,$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx,$columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatecodequeryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ///////////////////////////////////////////////////////
    /////////////////////////////////////////////////////
    function hom() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "HOM";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/homvalidate");
        $data['table'] = $this->_homFormTable();
        $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function homvalidate() {
        $this->_validatehomqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "HOM";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/homvalidate");
            $data['table'] = $this->_homFormTable();
            $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "oldcolumn";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _homFormTable() {
        $plotID = $this->session->userdata('configPlotID');
        $columnHeader = set_value('columnHeader');
        $columnName = 'oldhom';
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName,
                            'readonly' => 'readonly', 'style' => 'background:#CCCCCC;');
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $columnSizeTbx = form_input($columnSizeA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx,$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx,$columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatehomqueryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ///////////////////////////////////////////////////////
    /////////////////////////////////////////////////////
    function qx() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "QX";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/qxvalidate");
        $data['table'] = $this->_qxFormTable();
        $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function qxvalidate() {
        $this->_validateqxqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "QX";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/qxvalidate");
            $data['table'] = $this->_qxFormTable();
            $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "oldcolumn";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _qxFormTable() {
        $plotID = $this->session->userdata('configPlotID');
        $columnHeader = set_value('columnHeader');
        $columnName = 'x';
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName,
                            'readonly' => 'readonly', 'style' => 'background:#CCCCCC;');
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $columnSizeTbx = form_input($columnSizeA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx,$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx,$columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateqxqueryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ///////////////////////////////////////////////////////
    /////////////////////////////////////////////////////
    function qy() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "QY";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/qyvalidate");
        $data['table'] = $this->_qyFormTable();
        $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function qyvalidate() {
        $this->_validateqyqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "QY";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/qyvalidate");
            $data['table'] = $this->_qyFormTable();
            $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "oldcolumn";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _qyFormTable() {
        $plotID = $this->session->userdata('configPlotID');
        $columnHeader = set_value('columnHeader');
        $columnName = 'y';
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName,
                            'readonly' => 'readonly', 'style' => 'background:#CCCCCC;');
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $columnSizeTbx = form_input($columnSizeA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx,$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx,$columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateqyqueryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ///////////////////////////////////////////////////////
    //////////////////Simple textbox with text,integer or decimal values with no limits///////////////////
    function textform() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Simple Text Form";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/textformvalidate");
        $data['table'] = $this->_textFormTable();
        $data['backLink'] = anchor('addoldcolumns/selectcolumntype/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function textformvalidate() {
        $this->_validatetextform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Simple Text Form";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/textformvalidate");
            $data['table'] = $this->_textFormTable();
            $data['backLink'] = anchor('addoldcolumns/selectcolumntype/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "text";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $dataType = $this->input->post('dataType');
            $defaultValue = $this->input->post('defaultValue');
            $columnSize = $this->input->post('columnSize');
            $allowNull = $this->input->post('allowNull');
            $attributes = join("\t", array($columnHeader, $columnName, $dataType, $defaultValue, $columnSize, $allowNull
                              ));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _textFormTable() {
        $columnHeader = set_value('columnHeader');
        $columnName = set_value('columnName');
        $dataType = set_value('dataType');
        $defaultValue = set_value('defaultValue');
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        //$columnNameA = array('name'=>'columnName','id'=>'columnName','size'=>'16','value'=>$columnName);
        $columnNameA = array('default' => 'Select', 'tag' => 'Tag, TreeTag', 'stemTag' => 'StemTag, MultiStem',
                            'quadratName' => 'QuadratName', 'subquadrat' => 'Subquadrat', 'species' =>
                            'Species, Mnemonic', 'plotCensusNumber' => 'PlotCensus', 'primaryStem' => 'PrimaryStem', 'x'
                            => 'X, QX', 'y' => 'Y, QY', 'dbh' => 'DBH, Diameter', 'hom' => 'HOM, Height', 'codes' =>
                            'codes', 'comments' => 'Comments', 'errors' => 'Errors', 'extra1' => 'Extra1', 'extra2' =>
                            'Extra2', 'extra3' => 'Extra3', 'extra4' => 'Extra4', 'extra5' => 'Extra5');
        $dataTypeA = array('default' => 'Select', 'varchar' => 'varchar', 'integer' => 'integer', 'float' => 'float',
                          'decimal' => 'decimal');
        $defaultValueA = array('name' => 'defaultValue', 'id' => 'defaultValue', 'size' => '16', 'value' => $defaultValue
                              );
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $allowNullA = array('no' => 'No', 'yes' => 'Yes');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        //$columnNameTbx = form_input($columnNameA);
        $columnNameDD = form_dropdown('columnName', $columnNameA);
        $dataTypeDD = form_dropdown('dataType', $dataTypeA);
        $defaultValueTbx = form_input($defaultValueA);
        $columnSizeTbx = form_input($columnSizeA);
        $allowNullDD = form_dropdown('allowNull', $allowNullA, 'yes');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $dataTypeErr = form_error('dataType');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx, $columnHeaderErr), array(
                           'Column Name : ', $columnNameDD, $columnNameErr), array('Data Type : ', $dataTypeDD, $dataTypeErr
                           ), array('Default Value : ', $defaultValueTbx), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array('Null Value Allowed: ', $allowNullDD), array(), array('', $submitButton."\t".$resetButton
                           ));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatetextform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'callback_dropdown_check');
        $this->form_validation->set_rules('dataType', 'Data Type', 'callback_dropdown_check');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ///////////////////////////////////////////////////////
    //////Simple text box with interger values and a limit check//////////
    function limitform() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Limit Form";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/limitformvalidate");
        $data['table'] = $this->_limitFormTable();
        $data['backLink'] = anchor('addoldcolumns/selectcolumntype/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function limitformvalidate() {
        $this->_validatelimitform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Simple Text Form";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/limitformvalidate");
            $data['table'] = $this->_limitFormTable();
            $data['backLink'] = anchor('addoldcolumns/selectcolumntype/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "limit";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $dataType = $this->input->post('dataType');
            $upperLimit = $this->input->post('upperLimit');
            $lowerLimit = $this->input->post('lowerLimit');
            $defaultValue = $this->input->post('defaultValue');
            $columnSize = $this->input->post('columnSize');
            $allowNull = $this->input->post('allowNull');
            $attributes = join("\t", array($columnHeader, $columnName, $dataType, $upperLimit, $lowerLimit, $defaultValue,
                              $columnSize, $allowNull));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _limitFormTable() {
        $columnHeader = set_value('columnHeader');
        $columnName = set_value('columnName');
        $dataType = set_value('dataType');
        $upperLimit = set_value('upperLimit');
        $lowerLimit = set_value('lowerLimit');
        $defaultValue = set_value('defaultValue');
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        //$columnNameA = array('name'=>'columnName','id'=>'columnName','size'=>'16','value'=>$columnName);
        $columnNameA = array('default' => 'Select', 'tag' => 'Tag, TreeTag', 'stemTag' => 'StemTag, MultiStem',
                            'quadratName' => 'QuadratName', 'subquadrat' => 'Subquadrat', 'species' =>
                            'Species, Mnemonic', 'plotCensusNumber' => 'PlotCensus', 'primaryStem' => 'PrimaryStem', 'x'
                            => 'X, QX', 'y' => 'Y, QY', 'dbh' => 'DBH, Diameter', 'hom' => 'HOM, Height', 'codes' =>
                            'codes', 'comments' => 'Comments', 'errors' => 'Errors', 'extra1' => 'Extra1', 'extra2' =>
                            'Extra2', 'extra3' => 'Extra3', 'extra4' => 'Extra4', 'extra5' => 'Extra5');
        $dataTypeA = array('default' => 'Select', 'integer' => 'integer', 'float' => 'float', 'decimal' => 'decimal');
        $upperLimitA = array('name' => 'upperLimit', 'id' => 'upperLimit', 'size' => '16', 'value' => $upperLimit);
        $lowerLimitA = array('name' => 'lowerLimit', 'id' => 'lowerLimit', 'size' => '16', 'value' => $lowerLimit);
        $defaultValueA = array('name' => 'defaultValue', 'id' => 'defaultValue', 'size' => '16', 'value' => $defaultValue
                              );
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $allowNullA = array('no' => 'No', 'yes' => 'Yes');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        //$columnNameTbx = form_input($columnNameA);
        $columnNameDD = form_dropdown('columnName', $columnNameA);
        $dataTypeDD = form_dropdown('dataType', $dataTypeA);
        $defaultValueTbx = form_input($defaultValueA);
        $upperLimitTbx = form_input($upperLimitA);
        $lowerLimitTbx = form_input($lowerLimitA);
        $columnSizeTbx = form_input($columnSizeA);
        $allowNullDD = form_dropdown('allowNull', $allowNullA, 'yes');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $dataTypeErr = form_error('dataType');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx, $columnHeaderErr), array(
                           'Column Name : ', $columnNameDD, $columnNameErr), array('Data Type : ', $dataTypeDD, $dataTypeErr
                           ), array('Upper Limit : ', $upperLimitTbx), array('Lower Limit : ', $lowerLimitTbx), array(
                           'Default Value : ', $defaultValueTbx), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array('Null Value Allowed: ', $allowNullDD), array(), array('', $submitButton."\t".$resetButton
                           ));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatelimitform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'callback_dropdown_check');
        $this->form_validation->set_rules('dataType', 'Data Type', 'callback_dropdown_check');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ////////////*******************///////////////////////


    ////////Select another column from viewfulltable to display on old data entry form////////////
    function viewfullextra() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Extra Column From ViewFullTable";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/viewfullvalidate");
        $data['table'] = $this->_viewfullFormTable();
        $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function viewfullvalidate() {
        $this->_validatetreetagqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Extra Column From ViewFullTable";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/viewfullvalidate");
            $data['table'] = $this->_viewfullFormTable();
            $data['backLink'] = anchor('addoldcolumns/listcolumns/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $plotID = $this->session->userdata('configPlotID');
            $formType = $this->session->userdata('formType');
            $columnType = "oldcolumn";
            $columnNumber = $this->configmodel->getColumnNumber($plotID, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize));
            $this->configmodel->insertFormData($plotID, $formType, $columnNumber, $columnType, $attributes);
            redirect('forms/addcolumn');
        }
    }

    function _viewfullFormTable() {
        $plotID = $this->session->userdata('configPlotID');
        $columnHeader = set_value('columnHeader');
        $columnName = set_value('columnName');
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }

        $tableName = 'ViewFullTable';
        $this->load->model('formmodel');
        $tableColumnList = $this->formmodel->getTableColumns($tableName);

        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = $tableColumnList;

        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameDD = form_dropdown('columnName',$columnNameA,$columnName);
        $columnSizeTbx = form_input($columnSizeA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx, $columnHeaderErr), array(
                           'Column Name : ', $columnNameDD, $columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateviewfullform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'callback_dropdown_check');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function _getFormName($formType) {
        if ($formType == 'newform') {
            $formName = "New Plants Form";
        }
        elseif ($formType == 'oldform') {
            $formName = "Old Trees Form";
        }
        elseif ($formType == 'multiform') {
            $formName = "Multi Stem Form";
        }
        return $formName;
    }

    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }

}
