<?php

class Appwriteolddatafile extends Controller {

  function Appwriteolddatafile()
  {
    parent::Controller();
    if($this->session->userdata('loggedin') !== '1')
    {
      redirect('main','location');
    }
    $this->load->model('appfilesmodel');

    set_time_limit(0);
    ini_set('memory_limit', '-1');
  }

  function index()
  {
    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotID = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $selectedPlotName = $this->session->userdata('selectedPlotName');
    //$plotActualName = $plotCensusArray['plotActualName'];

    //$formType = $this->session->userdata('formType');
    $formType = 'oldform';
    $plotName = $this->appfilesmodel->getPlotNameByID($plotID);

    $this->load->library('formlibrary');

    $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
    $fileName = str_replace(" ","",$fileName);
    $formDetailResult = $this->formlibrary->readConfigFile($fileName);

    if($formDetailResult == "Not Found")
    {
      echo "Configuration File Not Found  :  ".$fileName;
      die();
    }
      $this->load->library('oldplantlibrary');
      $processData = $this->oldplantlibrary->processData($formDetailResult);
      $headerListA = $processData['headerListA'];
      $columnNameA = $processData['columnNameA'];
      $columnTypeA = $processData['columnTypeA'];

      $recordsNum = $this->input->post('row_count');


    $quadrat = $this->input->post('quadratName'); // different then new and multi form quadratname is hidden value because of quadrat form


    $plotName = $this->appfilesmodel->getPlotNameByID($plotID);

///////////////////////////////////////
     $namesA = $this->appfilesmodel->getPersonnelNames();


     $linetab = "\t";
     $nextline = "\r\n";
     $mainFolderName = $plotName;
     $fileFolderName = 'oldform_data';
     $filename = 'OldTreeForm_'.$plotName.'_'.$censusNumber.'_'.$quadrat;

     if (!file_exists('appfiles/'.$mainFolderName))
     {
       mkdir('appfiles/'.$mainFolderName, 0777, true);
     }
     if (!file_exists('appfiles/'.$mainFolderName.'/'.$fileFolderName))
     {
       mkdir('appfiles/'.$mainFolderName.'/'.$fileFolderName, 0777, true);
     }
///////////////////////////////////////



    $this->load->helper('file');

    /////////column names//////////
    //$stemIDColumnName = 'stemID'; //add header for old StemID
    $dataJoin = join("\t",$columnNameA);
    //$dataJoin = $dataJoin."\t".$stemIDColumnName;
    write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $dataJoin,'w');
    //////////////////////////////

    write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $nextline,'a');

    ///////column data//////////
    for($i = 1; $i <= $recordsNum; $i++)
    {
      $columnCount = count($columnNameA); //columnNameA keys are columnNumber
      for($x = 1; $x <= $columnCount; $x++)
      {
        $columnName = $columnNameA[$x];
        $columnType = $columnTypeA[$x];
        if($columnType == 'twotext')
        {
          $columnValue1 = $this->input->post($columnName."prefix_".$i);
          $columnValue2 = $this->input->post($columnName."_".$i);
          $columnValue = $columnValue1.$columnValue2;
        }
        else
        {
          $columnValue = $this->input->post($columnName."_".$i);
        }
        write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $columnValue,'a');
        if($x < $columnCount)
        {
          write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $linetab,'a');
        }
      }
      if($i < $recordsNum)
      {
        write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $nextline,'a');
      }
    }

    $filepath = base_url().'appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt';

    if($this->fileExists($filepath))
    {
      $fileLink = anchor($filepath, $filename.'.txt', array('title'=>'View Text File', 'target'=>'_blank'));
      $backLink = anchor('appolddatafile/createform', 'Back To Form', array('title'=>'Back to Select Form Type', 'class'=>'back'));
      $data['formTable'] = '<div class="success">The File Created Successfully - '.$fileLink.'</div><br /><br />'.$backLink;
    }
    else
    {
      $data['formTable'] = '<div class="error">Error Occured while Creating File.</div>';
    }
    $data['formOpen'] = "";

    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotName = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];
    $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
    $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
    $data['backLink'] = "";
    $this->load->view('user/dataentry/simpleform',$data);
  }

  function fileExists($path)
  {
    return (@fopen($path,"r")==true);
  }

  function removeAccents($str)
  {
    $a = array('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', '', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', '?', '?', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', '?', '?', 'L', 'l', 'N', 'n', 'N', 'n', 'N', 'n', '?', 'O', 'o', 'O', 'o', 'O', 'o', '', '', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', '', '', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', '', 'Z', 'z', 'Z', 'z', '', '', '?', '', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', '?', '?', '?', '?', '?', '?');
    $b = array('A', 'A', 'A', 'A', 'A', 'A', 'AE', 'C', 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I', 'D', 'N', 'O', 'O', 'O', 'O', 'O', 'O', 'U', 'U', 'U', 'U', 'Y', 's', 'a', 'a', 'a', 'a', 'a', 'a', 'ae', 'c', 'e', 'e', 'e', 'e', 'i', 'i', 'i', 'i', 'n', 'o', 'o', 'o', 'o', 'o', 'o', 'u', 'u', 'u', 'u', 'y', 'y', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', 'D', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'IJ', 'ij', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', 'L', 'l', 'l', 'l', 'N', 'n', 'N', 'n', 'N', 'n', 'n', 'O', 'o', 'O', 'o', 'O', 'o', 'OE', 'oe', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', 'S', 's', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', 'Y', 'Z', 'z', 'Z', 'z', 'Z', 'z', 's', 'f', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'A', 'a', 'AE', 'ae', 'O', 'o');
    $str = str_replace($a, $b, $str);
    return $str;
  }

}