<?php

class Auth extends Controller{

    function Auth()
    {
      parent::Controller();
      $this->load->model('authmodel');

    }

//Login Start
    function login()
    {
      if($this->session->userdata('loggedin') == '1')
      {
         redirect('main');
      }
      elseif(isset($_POST) AND !empty($_POST))
      {
         $username = $this->input->post('username');
         $password = $this->input->post('password');
         $plotID = $this->input->post('plotName');

         $selectedPlotInfo = $this->authmodel->getDatabaseName($plotID);
         $selectedPlotName = $selectedPlotInfo['plotName'];  // Using plot name to use in AGB Database to determine the TableName
         $selectedDatabaseName = $selectedPlotInfo['databaseName']; // Used at many places in controller and in model.
         $selectedDatabaseVersion = $selectedPlotInfo['databaseVersion'];

         if($username != 'admin')
         {
           $loginQuery = $this->authmodel->validateLogin($username,$password);

           if($loginQuery->num_rows() !== 0)
           {
               $loginRow = $loginQuery->row();
               //$userPlotID = $loginRow->Plots_ID;
               $databaseName = $loginRow->DatabaseName;

               if($selectedDatabaseName == $databaseName)
               {
                 $this->session->set_userdata('loggedin','1');
                 $this->session->set_userdata('initialPlot',$selectedPlotName);
                 $this->session->set_userdata('databaseName',$databaseName);
                 $this->session->set_userdata('databaseVersion',$selectedDatabaseVersion);
                 $this->session->set_userdata('selectedPlotName',$selectedPlotName);
                 redirect('main');
               }
               else
               {
                $data = array('title'=>'CTFS/ForestGEO Forest Plot Census Data',
                            'contentTitle'=> 'Welcome to CTFS DataEntry and Reporting System',
                            'detail1'=>'<p>Please Login to Continue.<p>');
                $data['loginerror'] = '<p class="errorblock">'.'No Privileges To Selected Plot'.'<p>';
                $data['loginTable'] = $this->_generateLoginForm();
                $this->load->view('login/loginview',$data);
               }
           }
           else
           {
              $data = array('title'=>'CTFS/ForestGEO Forest Plot Census Data',
                            'contentTitle'=> 'Welcome to CTFS DataEntry and Reporting System',
                            'detail1'=>'<p>Please Login to Continue.<p>');
              $data['loginerror'] = '<p class="errorblock">'.'Invalid Username or Password'.'<p>';
              $data['loginTable'] = $this->_generateLoginForm();
              $this->load->view('login/loginview',$data);
           }
         }
         elseif($username === 'admin' && md5($password) === 'b11f562b3e89e1e4c5ab82f3dd3055fd')
         {
           $this->session->set_userdata('loggedin','1');
           $this->session->set_userdata('initialPlot',$selectedPlotName);
           $this->session->set_userdata('databaseName',$selectedDatabaseName);
           $this->session->set_userdata('databaseVersion',$selectedDatabaseVersion);
           redirect('main');
         }
      }
      else
      {
        $data = array('title'=>'CTFS/ForestGEO Forest Plot Census Data',
                      'contentTitle'=> 'Welcome to CTFS DataEntry and Reporting System',
                      'detail1'=>'<p>Please Login to Continue.<p>');
        $data['loginerror'] = '';
        $data['loginTable'] = $this->_generateLoginForm();
        $this->load->view('login/loginview',$data);
      }
    }

    function _generateLoginForm()
    {
      $username = set_value('username');
      $plotName = set_value('plotName');

      $usernameA = array('name'=>'username','id'=>'username','size'=>'15','value'=>$username);
      $passwordA = array('name'=>'password','id'=>'password','size'=>'15');
      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');


      $plotNameA = $this->authmodel->plotname();

      $usernameTbx = form_input($usernameA);
      $passwordTbx = form_password($passwordA);
      $plotNameDD = form_dropdown('plotName',$plotNameA,$plotName,'class = "select1"');
      $submitButton = form_button($submitButtonA);


      $loginTableA = array(array('',''),
                          array('Username ',$usernameTbx),
                          array('',''),
                          array('Password: ', $passwordTbx),
                          array('',''),
                          array('Plot: ',$plotNameDD),
                          array('<br />',''),
                          array('',$submitButton)
                          );
       $this->table->set_empty("");
       $loginTable = $this->table->generate($loginTableA);

       return $loginTable;

    }
//Login End



// Logout Function : TO end the logged in users session
// redirect to homepage.
    function Logout()
    {
      $this->session->sess_destroy();
      redirect('main','location');
    }
}