<?php

class Dataupload extends Controller{

    function Dataupload()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->library(array('table','pagination'));
      $this->load->model('datauploadmodel');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }

    function oldandmulti()
    {
      $list['0'] = 'Loading Started...';
      $this->session->set_userdata('progressList',$list);

      //$detailList = "";
//      $this->session->set_userdata('detailList',$detailList);

      $data['ajaxURL1'] = site_url('dataupload/oldAjaxRequestStep');
      $data['ajaxURL2'] = site_url('dataupload/oldAjaxRequestDetail');
      //$data['ajaxURL'] = site_url('ajaxtest/uploadoldtrees');
      $data['ajaxURL'] = site_url('dataupload/uploadoldtrees');
      $data['totalSteps'] = "8";

      $data['buttonText'] = "Upload";
      $data['whichData'] = "Please Hit the Upload Button and Confirm To Start Uploading Old Trees and Multi Stems Data.<br /><span style='color:#444240; font-size:8pt;'>To see the runtime errors, you can also run the upload script directly without step by step detail. To run the script directly ".anchor('/dataupload/uploadoldtrees/direct', '<b>"Click Here"</b>', array('title'=>'Run Direct'))."</span>";
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Data Uploading - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';

      $this->load->view('upload/uploadview',$data);
    }

    function newplants()
    {
      $list['0'] = 'Loading Started...';
      $this->session->set_userdata('progressList',$list);

      //$detailList = "";
//      $this->session->set_userdata('detailList',$detailList);

      $data['ajaxURL1'] = site_url('dataupload/oldAjaxRequestStep');
      $data['ajaxURL2'] = site_url('dataupload/oldAjaxRequestDetail');
      //$data['ajaxURL'] = site_url('ajaxtest/uploadoldtrees');
      $data['ajaxURL'] = site_url('dataupload/uploadnewplants');
      $data['totalSteps'] = "5";

      $data['buttonText'] = "Upload";
      $data['whichData'] = "Please Hit the Upload Button and Confirm To Start Uploading New Plants Data.<br /><span style='color:#444240; font-size:8pt;'>To see the runtime errors, you can also run the upload script directly without step by step detail. To run the script directly ".anchor('/dataupload/uploadnewplants/direct', '<b>"Click Here"</b>', array('title'=>'Run Direct'))."</span>";
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Data Uploading - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';

      $this->load->view('upload/uploadview',$data);
    }

    function bigtrees()
    {
      $list['0'] = 'Loading Started...';
      $this->session->set_userdata('progressList',$list);

      //$detailList = "";
//      $this->session->set_userdata('detailList',$detailList);

      $data['ajaxURL1'] = site_url('dataupload/oldAjaxRequestStep');
      $data['ajaxURL2'] = site_url('dataupload/oldAjaxRequestDetail');
      $data['ajaxURL'] = site_url('dataupload/uploadbigtrees');
      $data['totalSteps'] = "5";

      $data['buttonText'] = "Upload";
      $data['whichData'] = "Please Hit the Upload Button and Confirm To Start Uploading Big Trees Data.<br /><span style='color:#444240; font-size:8pt;'>To see the runtime errors, you can also run the upload script directly without step by step detail. To run the script directly ".anchor('/dataupload/uploadbigtrees/direct', '<b>"Click Here"</b>', array('title'=>'Run Direct'))."</span>";
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Data Uploading - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';

      $this->load->view('upload/uploadview',$data);
    }

    function uploadoldtrees($runType = 'ajax')
    {

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];    //actually plotID
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      $mainStem = 'main';
      $secondaryStem = 'secondary';
      $bigdescription = 'Buttressed tree';
      $stemLost =  'stem lost';
      $deadStem = 'dead';
      $tempOldTrees = 'TempOldTrees';
      $tempNewPlants = 'TempNewPlants';
      $tempMultiStems = 'TempMultiStems';
      $tempAllTrees = 'TempAllTrees';
      $tempTrees1 = 'TempTrees1';
      $tempTrees2 = 'TempTrees2';
      $tempTrees = 'TempTrees';

      // Get resprout codes
      $resproutArr = $this->datauploadmodel->getCodes($stemLost);
      $deadArr = $this->datauploadmodel->getCodes($deadStem);

      //Start Transaction
      $this->datauploadmodel->startTransaction();

///////Update Status//////////////////////////////////
    $list['step'] = '1';
    $list['detail'] = '<span class="smallsuccess">Creating, Updating Temp Tables</span>';
    $list['detailList'] = $list['detail'];
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);     // Sleep is used to display the status properly
///////////////////////////////////////////////////////

      //createtempAllTrees
      $this->datauploadmodel->createTempAllTrees($tempAllTrees);



     //Check if TempBigTrees Exist  (Don't exist now for future use)
      if($this->datauploadmodel->ifTableExist('TempBigTrees'))
      {
         $bigCode = $this->datauploadmodel->getCodes($bigdescription);
         //Set BigTrees field to "n"
         //Set BigTrees field to "y" if code has big tree code
         $this->datauploadmodel->updateTempTreesForBigTrees($tempOldTrees,$bigCode,'Both'); //second parameter is for selecting queries
      }
      else
      {
        $bigCode = $this->datauploadmodel->getCodes($bigdescription);
        //Set BigTrees field to "n"
        $this->datauploadmodel->updateTempTreesForBigTrees($tempOldTrees,$bigCode,'Single'); //second parameter is for selecting queries
      }

///////Update Status//////////////////////////////////
    $list['step'] = '2';
    $list['detail'] = '<span class="smallsuccess">Moving from TempOldTrees to TempAllTrees</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////
      //Check to see if site uses Stem Tags
      $checkIfStemTagsUsed = $this->datauploadmodel->checkIfStemTagsUsed($plotName); //will return count of DBHID

      if($this->datauploadmodel->ifTableExist($tempOldTrees))
      {
        //Get TreeIDs for tempOldTrees where TreeID is null
        //Update tempOldTrees
        $this->datauploadmodel->updateTempOldTrees();

        if($checkIfStemTagsUsed > 0)
        {
          //Update StemID
          $this->datauploadmodel->updateStemIDs($tempOldTrees);
        }
        //Append into TempAllTrees from Old Trees - all records except where data is in Big Trees form
        $getOldTreesQuery = $this->datauploadmodel->getOldTreesNoBigTrees();

        if($getOldTreesQuery->num_rows() > 0)
        {
          foreach($getOldTreesQuery->result_array() as $getOldTreesRow)
          {
            $this->datauploadmodel->insertRowIntoTable($tempAllTrees,$getOldTreesRow);
          }
        }
        $getOldTreesQuery->free_result(); //Free Result
      }


///////Update Status//////////////////////////////////
    $list['step'] = '3';
    $list['detail'] = '<span class="smallsuccess">Moving from TempMultiStems to TempAllTrees</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      if($this->datauploadmodel->ifTableExist($tempMultiStems))
      {
        //Update TreeIDs for TempMultiStem
        $this->datauploadmodel->updateTempMultiStem();

        if($checkIfStemTagsUsed > 0)
        {
          //Update StemIDs
          $this->datauploadmodel->updateStemIDs($tempMultiStems);

          //update stemTag in TempMultiStem
          $getMultiStemsQuery = $this->datauploadmodel->getDataForTempAllTrees($tempMultiStems);
          if($getMultiStemsQuery->num_rows() > 0)
          {
            $multipleStems = array();
            foreach($getMultiStemsQuery->result_array() as $multiStemsRow)
            {
              $multiTreeID = $multiStemsRow['TreeID'];
              $multiTempID = $multiStemsRow['TempID'];
              $stemTag = $multiStemsRow['StemTag'];
              if($stemTag == NULL)
              {
                if(!in_array($multiTreeID,$multipleStems))
                {
                  $maxStemTag = $this->datauploadmodel->getMaxStemTag($multiTreeID);
                  if($maxStemTag == 'No')
                  {
                    $nextStemTag = 0;
                  }
                  else
                  {
                    $nextStemTag = $maxStemTag + 1;
                  }
                  //update StemTag in TempMultiStems
                  $this->datauploadmodel->updTempTreeStemTag($tempMultiStems,$multiTempID,$nextStemTag);
                  $multipleStems[] = $multiTreeID;
                }
                else
                {
                  $maxStemTag =  $this->datauploadmodel->getMaxStemTagInMultiStem($tempMultiStems, $multiTreeID);
                  $nextStemTag = $maxStemTag + 1;
                  //update StemTag in TempMultiStems
                  $this->datauploadmodel->updTempTreeStemTag($tempMultiStems,$multiTempID,$nextStemTag);
                }
              }
            }
          }
          $getMultiStemsQuery->free_result();
        }
        //Append TempMultiStems data to TempAllTrees
        $getMultiStemsQuery = $this->datauploadmodel->getDataForTempAllTrees($tempMultiStems);
        if($getMultiStemsQuery->num_rows() > 0)
        {
          foreach($getMultiStemsQuery->result_array() as $getMultiStemsRow)
          {
            $insertArray = array('QuadratName'=>$getMultiStemsRow['QuadratName'],'SubQuad'=>$getMultiStemsRow['SubQuad'],'Tag'=>$getMultiStemsRow['Tag'],'StemTag'=>$getMultiStemsRow['StemTag'],'Mnemonic'=>$getMultiStemsRow['Mnemonic'],'DBH'=>$getMultiStemsRow['DBH'],'Codes'=>$getMultiStemsRow['Codes'],'Comments'=>$getMultiStemsRow['Comments'],'TreeID'=>$getMultiStemsRow['TreeID'],'StemID'=>$getMultiStemsRow['StemID'],'PlotCensusNumber'=>$getMultiStemsRow['PlotCensusNumber'],'CensusID'=>$getMultiStemsRow['CensusID'],'HOM'=>$getMultiStemsRow['HOM'],'ExactDate'=>$getMultiStemsRow['ExactDate'],'X'=>$getMultiStemsRow['X'],'Y'=>$getMultiStemsRow['Y'],'PlotID'=>$getMultiStemsRow['PlotID'],'Errors'=>$getMultiStemsRow['Errors']);
            $this->datauploadmodel->insertRowIntoTable($tempAllTrees,$insertArray);
          }
        }
        $getMultiStemsQuery->free_result(); //Free Result
      }

///////Update Status//////////////////////////////////
    $list['step'] = '4';
    $list['detail'] = '<span class="smallsuccess">Moving from old trees from TempNewPlants to TempAllTrees</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      if($this->datauploadmodel->ifTableExist($tempNewPlants))
      {
        // Get Old Trees from New Plants Form
           //Set OldTrees field to "n"
           //Set OldTrees field to "y" if old tag
        $this->datauploadmodel->updateTempNewPlants();
        $checkOldTreesInNewPlants =  $this->datauploadmodel->oldTreesInTempNewPlants();
        if($checkOldTreesInNewPlants > 0)
        {
          if($checkIfStemTagsUsed > 0)
          {
            //Update StemID
            $this->datauploadmodel->updateStemIDs($tempOldTrees);

            //update stemTag in TempNewPlants
            $getNewPlantsQuery = $this->datauploadmodel->getDataForTempAllTrees($tempNewPlants);
            if($getNewPlantsQuery->num_rows() > 0)
            {
              foreach($getNewPlantsQuery->result_array() as $newPlantsRow)
              {
                $newPlantsTreeID = $newPlantsRow['TreeID'];
                $newPlantsTempID = $newPlantsRow['TempID'];
                $maxStemTag = $this->datauploadmodel->getMaxStemTag($newPlantsTreeID);
                if($maxStemTag == 'No')
                {
                  $nextStemTag = 0;
                }
                else
                {
                  $nextStemTag = $maxStemTag + 1;
                }
                //update StemTag in TempMultiStems
                $this->datauploadmodel->updTempTreeStemTag($tempNewPlants,$newPlantsTempID,$nextStemTag);
              }
            }
            $getMultiStemsQuery->free_result();

            //Append TempMultiStems data to TempAllTrees
            $getNewPlantsQuery = $this->datauploadmodel->getOldTreesInTempNewPlants();
            if($getNewPlantsQuery->num_rows() > 0)
            {
              foreach($getNewPlantsQuery->result_array() as $getNewPlantsRow)
              {
                $insertArray = array('QuadratName'=>$getNewPlantsRow['QuadratName'],'SubQuad'=>$getNewPlantsRow['SubQuad'],'Tag'=>$getNewPlantsRow['Tag'],'StemTag'=>$getNewPlantsRow['StemTag'],'Mnemonic'=>$getNewPlantsRow['Mnemonic'],'DBH'=>$getNewPlantsRow['DBH'],'Codes'=>$getNewPlantsRow['Codes'],'Comments'=>$getNewPlantsRow['Comments'],'TreeID'=>$getNewPlantsRow['TreeID'],'StemID'=>$getNewPlantsRow['StemID'],'PlotCensusNumber'=>$getNewPlantsRow['PlotCensusNumber'],'CensusID'=>$getNewPlantsRow['CensusID'],'HOM'=>$getNewPlantsRow['HOM'],'ExactDate'=>$getNewPlantsRow['ExactDate'],'PlotID'=>$getNewPlantsRow['PlotID'],'Errors'=>$getNewPlantsRow['Errors']);
                $this->datauploadmodel->insertRowIntoTable($tempAllTrees,$insertArray);
              }
            }
            $getNewPlantsQuery->free_result(); //Free Result
          }
          else
          {
            // Work only with single-stemmed trees
            $getSingleStemQuery = $this->datauploadmodel->getTempNewPlantsSingleStem($tempNewPlants);
            foreach($getSingleStemQuery->result() as $getSingleStemRow)
            {
              //Check to see if there is a resprout code
              $resprout = 'n';
              $treeID = $getSingleStemRow->TreeID;
              $tempID = $getSingleStemRow->TempID;
              $getCodesQuery = $this->datauploadmodel->getTempNewPlantsCodes($tempNewPlants,$tempID);
              if($getCodesQuery->num_rows() > 0)
              {
                $getCodesRow = $getCodesQuery->row_array();
                $noCodes = SUBSTR_COUNT($getCodesRow["Codes"],';');
                $arrCodes = explode(";", $getCodesRow["Codes"]);
                for ($i = 0; $i <= $noCodes; $i++)
                {
                  if (in_array($arrCodes[$i], $resproutArr))
                  {
                     $resprout = 'y';
                  }
                } // end for
              }//end if
              if ($resprout == 'n')
              {
               //Check how many stems there were when tree was last measured - may be several censuses ago

               $stop='n';
               // Look at data from 2 censuses ago, assume that tree was not measured in previous census
               $k = 2;
               $prevCensusNumber = $censusNumber - $k;

               while ($stop == 'n' && $prevCensusNumber >= 1)
               {
                 $prevCensusID = $this->datauploadmodel->getCensusID($plotName,$prevCensusNumber);

                 $getListOfTSMQuery = $this->datauploadmodel->getListOfTSM($prevCensusID,$treeID);
                 //$q4 = 'select TreeID, StemID, DBH, ListOfTSM from DFtemp where censusID = '.$prevcensusid.' and TreeID = '.$onestem["TreeID"].' group by TreeID,StemID';
                //$r4 = mysql_query($q4, $connect) or die('Getting Stems from DFtemp failed: ' .mysql_error());
                 $dead = 'n';
                 $respr2 = 'n';

                 //If there were more than one stem, then stop, get new StemIDs
                 if ($getListOfTSMQuery->num_rows() > 1)
                 {
                   $stop = 'y';
                 }

                 if ($getListOfTSMQuery->num_rows() == 1)
                 {
                   $row = $getListOfTSMQuery->row_array();

                   $noCodes = SUBSTR_COUNT($row["ListOfTSM"],",");
                   $arrCodes = explode(",", $row["ListOfTSM"]);
                   for ($i = 0; $i <= $noCodes; $i++)
                   {
                     if (in_array($arrCodes[$i], $deadArr))
                     {
                       $dead = 'y';
                     }
                     if (in_array($arrCodes[$i], $resproutArr))
                     {
                       $respr2 = 'y';
                     }
                   }  // end for
                   // If not dead and (dbh>=10 or resprout)
                   If ($dead == 'n')
                   {
                     If ($row["DBH"]>=10 || $respr2 == 'y')
                     {
                       $this->datauploadmodel->updateTempNewPlantStemID($tempNewPlants,$row['StemID'],$tempID);
                       $stop = 'y';
                     }
                   }  // End if ($dead == 'n')

                 } //End if (mysql_num_rows($r4) == 1)
                 $k = $k+1;    //Go to next census to find if tree measured
                 $prevCensusNumber = $censusNumber - $k;
               }//End While ($stop == 'n' && $prevcensus >= 1)
              }  // End if (resprout == 'n')
            }//end forech
            //Append into TempAllTrees from TempNewPlants
            $getNewPlantsQuery = $this->datauploadmodel->getOldTreesInTempNewPlants();
            if($getNewPlantsQuery->num_rows() > 0)
            {
              foreach($getNewPlantsQuery->result_array() as $getNewPlantsRow)
              {
                $this->datauploadmodel->insertRowIntoTable($tempAllTrees,$getNewPlantsRow);
              }
            }
            //Free Result
            $getSingleStemQuery->free_result();
            //$getCodesQuery->free_result();
            //$getListOfTSMQuery->free_result();
            $getNewPlantsQuery->free_result();
          }
        }
      }

///////Update Status//////////////////////////////////
    $list['step'] = '5';
    $list['detail'] = '<span class="smallsuccess">Updating TempAllTrees for Quadrats, Species and DBH</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      //Update Quadrat in TempAllTrees
      $this->datauploadmodel->updQuadratTempTrees($tempAllTrees);
      //Update Species in TempAllTrees
      $this->datauploadmodel->updSpeciesTempTrees($tempAllTrees);
      //Update DBH to NULL where its is O in TempAllTrees
      $this->datauploadmodel->updDBHNullTempTrees($tempAllTrees);

///////Update Status//////////////////////////////////
    $list['step'] = '6';
    $list['detail'] = '<span class="smallsuccess">Updating TempAllTrees for PrimaryStem Codes</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      //Update PrimaryStem in TempAllTrees
      $getMainStemQuery = $this->datauploadmodel->getTsmCodeDesc($mainStem);
      if($getMainStemQuery->num_rows() > 0)
      {
        $getMainStemRow = $getMainStemQuery->row_array();
        $mainCode = $getMainStemRow['TSMCode'];
        $mainDescription = $getMainStemRow['Description'];
        $this->datauploadmodel->updPrimaryTempTrees($tempAllTrees,$mainCode,$mainDescription);
      }
      $getSecondStemQuery = $this->datauploadmodel->getTsmCodeDesc($secondaryStem);
      if($getSecondStemQuery->num_rows() > 0)
      {
        $getSecondStemRow = $getSecondStemQuery->row_array();
        $secondCode = $getSecondStemRow['TSMCode'];
        $secondDescription = $getSecondStemRow['Description'];
        $this->datauploadmodel->updPrimaryTempTrees($tempAllTrees,$secondCode,$secondDescription);
      }
      //Free Result
      $getMainStemQuery->free_result();
      $getSecondStemQuery->free_result();

      //Check to see if any of the required fields have errors
      $checkNullQuery = $this->datauploadmodel->getNullTreeID($tempAllTrees);
      $checkNullRow = $checkNullQuery->row_array();
      if($checkNullRow['Cnt'] > 0)
      {
///////Update Status//////////////////////////////////
    $list['step'] = '99';//error
    $list['detail'] = '<span class="smallerror">For Some Records TreeID IS NULL OR 0 : Contact Administrator</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
///////////////////////////////////////////////////////
         //echo 'Some records from Old Trees cannot be loaded into production tables. Please ask the Administrator to check them in the tempAllTrees table
         //by using the following SQL:<br /><br />
         //TreeID IS NULL OR 0<br /><br />';
         die();
      }
      else
      {

///////Update Status//////////////////////////////////
    $list['step'] = '7';
    $list['detail'] = '<span class="smallsuccess">Uploading Data into Production from TempAllTrees</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

        $counter = 0;
        $skipCounter = 0;
        $detailList = $list['detailList'];

        //Update X and Y with QX and QY with TreeID and StemID
        //Update X and Y with QX and QY with just for the Stems where StemID is NULL
        $this->datauploadmodel->updateLocationTempAllTrees($tempAllTrees);

        //Upload New Stems into Stem table and update StemTag if available
        $stemDataQuery = $this->datauploadmodel->getDataForTempAllTrees($tempAllTrees);
        $stemDataRowCount = $stemDataQuery->num_rows();
        foreach($stemDataQuery->result_array() as $stemDataRow)
        {
          $counter++;
          if($counter == ($skipCounter + 500) || $counter == $stemDataRowCount)
          {
///////Update No of Records//////////////////////////////////
    $list['step'] = '7';
    $list['detail'] = '<span class="smallsuccess">Uploading Records - '.$counter.'/'.$stemDataRowCount.'</span>';
    $list['detailList'] = $detailList."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
///////////////////////////////////////////////////////
                 $skipCounter = $counter;
          }
          //

          $tempTreeID = $stemDataRow['TreeID'];
          $tempStemID = $stemDataRow['StemID'];
          $tempStemTag = $stemDataRow['StemTag'];
          $tempQuadratID = $stemDataRow['QuadratID'];
          //$getStemDataQuery = $this->datauploadmodel->getStemData($tempStemID);
          if($tempStemID > 0)
          {
            //Upload measurements and codes into DBH and DBHAttributes tables
            //Upload into DBH Table
              if($stemDataRow['DBH'] == NULL || $stemDataRow['DBH'] == 0 || $stemDataRow['DBH'] == '')
              {
                $stemDataRow['DBH'] = NULL;
              }
              if(($stemDataRow['HOM'] == NULL || $stemDataRow['HOM'] == 0 || $stemDataRow['HOM'] == '') AND $stemDataRow['DBH'] > 0)
              {
                //get HOM from previous Census
                $prevCensusNumber = $censusNumber - 1;
                $prevCensusID = $this->datauploadmodel->getCensusID($plotName,$prevCensusNumber);
                $homQuery = $this->datauploadmodel->getDBHRow($tempStemID,$prevCensusID);
                if($homQuery->num_rows() > 0)
                {
                  $homRow = $homQuery->row_array();
                  $stemDataRow['HOM'] = $homRow['HOM'];
                }
                else
                {
                  $stemDataRow['HOM'] = '1.3';
                }
              }
              if(($stemDataRow['HOM'] == NULL || $stemDataRow['HOM'] == 0 || $stemDataRow['HOM'] == '') AND $stemDataRow['DBH'] == NULL)
              {
                $stemDataRow['HOM'] = NULL;
              }

              $insertDBH = array('CensusID'=>$stemDataRow['CensusID'],'StemID'=>$stemDataRow['StemID'],'DBH'=>$stemDataRow['DBH'],'HOM'=>$stemDataRow['HOM'],'PrimaryStem'=>$stemDataRow['PrimaryStem'],'ExactDate'=>$stemDataRow['ExactDate'],'Comments'=>$stemDataRow['Comments']);
              //print_r($insertDBH);
              //echo '<br />';
              //die();
              $this->datauploadmodel->insertRowIntoTable('DBH',$insertDBH);
              $insertedDBHID = $this->datauploadmodel->getLastInsertedID();  //get the DBHID where the record is inserted

              //insert into DBHAttributes
              $tempCodes = $stemDataRow['Codes'];
              if(!is_null($tempCodes) AND $tempCodes<>'*' AND $tempCodes<>'')
              {
                $arrCodes = explode(";", $tempCodes);

                //Get unique values - avoid duplicate codes
                $arrCodes = array_unique($arrCodes);
                $noCodes = count($arrCodes);

                for ($i = 0; $i < $noCodes; $i++)
                {
                  if ($arrCodes[$i]<>$mainStem && $arrCodes[$i]<>$secondaryStem)
                  {
                    $tsmIDQuery = $this->datauploadmodel->getTSMID($arrCodes[$i]);
                    $tsmIDRow = $tsmIDQuery->row();
                    $tsmID = $tsmIDRow->TSMID;

                    //$insertDBHAtt = array('DBHID'=>$insertedDBHID,'CensusID'=>$stemDataRow['CensusID'],'TSMID'=>$tsmID);
                    $insertDBHAtt = array('DBHID'=>$insertedDBHID, 'TSMID'=>$tsmID);
                    //print_r($insertDBHAtt);
                    //echo '<br />';
                    $this->datauploadmodel->insertRowIntoTable('DBHAttributes',$insertDBHAtt);
                   } //End if
                }
              }
          }
          else //Insert into Stems table if not found
          {
            $insertStem = array('TreeID'=>$tempTreeID,'QuadratID'=>$tempQuadratID,'StemTag'=>$tempStemTag,'QX'=>$stemDataRow['X'],'QY'=>$stemDataRow['Y']);
            $this->datauploadmodel->insertRowIntoTable('Stem',$insertStem);
            $insertedStemID = $this->datauploadmodel->getLastInsertedID();  //get the DBHID where the record is inserted

            //Upload measurements and codes into DBH and DBHAttributes tables
            //Upload into DBH Table
              if($stemDataRow['DBH'] == NULL || $stemDataRow['DBH'] == 0 || $stemDataRow['DBH'] == '')
              {
                $stemDataRow['DBH'] = NULL;
              }
              if(($stemDataRow['HOM'] == NULL || $stemDataRow['HOM'] == 0 || $stemDataRow['HOM'] == '') AND $stemDataRow['DBH'] > 0)
              {
                //get HOM from previous Census
                $prevCensusNumber = $censusNumber - 1;
                $prevCensusID = $this->datauploadmodel->getCensusID($plotName,$prevCensusNumber);
                $homQuery = $this->datauploadmodel->getDBHRow($tempStemID,$prevCensusID);
                if($homQuery->num_rows() > 0)
                {
                  $homRow = $homQuery->row_array();
                  $stemDataRow['HOM'] = $homRow['HOM'];
                }
                else
                {
                  $stemDataRow['HOM'] = '1.3';
                }
              }
              if(($stemDataRow['HOM'] == NULL || $stemDataRow['HOM'] == 0 || $stemDataRow['HOM'] == '') AND $stemDataRow['DBH'] == NULL)
              {
                $stemDataRow['HOM'] = NULL;
              }

              $insertDBH = array('CensusID'=>$stemDataRow['CensusID'],'StemID'=>$insertedStemID,'DBH'=>$stemDataRow['DBH'],'HOM'=>$stemDataRow['HOM'],'PrimaryStem'=>$stemDataRow['PrimaryStem'],'ExactDate'=>$stemDataRow['ExactDate']);

              $this->datauploadmodel->insertRowIntoTable('DBH',$insertDBH);
              $insertedDBHID = $this->datauploadmodel->getLastInsertedID();  //get the DBHID where the record is inserted

              //insert into DBHAttributes
              $tempCodes = $stemDataRow['Codes'];
              if(!is_null($tempCodes) AND $tempCodes<>'*' AND $tempCodes<>'')
              {
                $arrCodes = explode(";", $tempCodes);

                //Get unique values - avoid duplicate codes
                $arrCodes = array_unique($arrCodes);
                $noCodes = count($arrCodes);

                for ($i = 0; $i < $noCodes; $i++)
                {
                  if ($arrCodes[$i]<>$mainStem && $arrCodes[$i]<>$secondaryStem)
                  {
                    $tsmIDQuery = $this->datauploadmodel->getTSMID($arrCodes[$i]);
                    $tsmIDRow = $tsmIDQuery->row();
                    $tsmID = $tsmIDRow->TSMID;

                    //$insertDBHAtt = array('DBHID'=>$insertedDBHID,'CensusID'=>$stemDataRow['CensusID'],'TSMID'=>$tsmID);
                    $insertDBHAtt = array('DBHID'=>$insertedDBHID, 'TSMID'=>$tsmID);
                    $this->datauploadmodel->insertRowIntoTable('DBHAttributes',$insertDBHAtt);
                  } //End if
                }
              }
            //Free Results
            //$dbhDataQuery->free_result();
            //$tsmIDQuery->free_result();
          }
        }
        $list['detailList'] = $detailList; //this will remove the number of record part
        //Free Results
        $stemDataQuery->free_result();
        //$getStemDataQuery->free->result();
      }
///////Update Status//////////////////////////////////
    $list['step'] = '8';
    $list['detail'] = '<span class="smallsuccess">Uploading Complete - Now Upload New Plants Data</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
///////////////////////////////////////////////////////
      //echo 'Done';
      //Complete Transaction
      $transStatus = $this->datauploadmodel->completeTransaction();

      if($runType == 'direct' AND  $transStatus == 'Success')
      {
        $data['detailList'] = $list['detailList'];
        $data['steps'] = 'Steps Done: 8/8';
        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Data Uploading - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';

        $this->load->view('upload/uploaddirectview',$data);
      }
    }

    function uploadnewplants($runType = 'ajax')
    {
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      $mainStem = 'main';
      $secondaryStem = 'secondary';
      $bigdescription = 'Buttressed tree';
      $stemLost =  'stem lost';
      $deadStem = 'dead';
      $tempOldTrees = 'TempOldTrees';
      $tempNewPlants = 'TempNewPlants';
      $tempMultiStems = 'TempMultiStems';
      $tempAllTrees = 'TempAllTrees';

      $tempTrees1 = 'TempTrees1';
      //$tempTrees2 = 'TempTrees2';
      //$tempTrees = 'TempTrees';

      //Start Transaction
      $this->datauploadmodel->startTransaction();

///////Update Status//////////////////////////////////
    $list['step'] = '1';
    $list['detail'] = '<span class="smallsuccess">TempNewPlants - Setting StemID and TreeID to Null</span>';
    $list['detailList'] = $list['detail'];
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);     // Sleep is used to display the status properly
///////////////////////////////////////////////////////

      //Set all TreeID and StemID to NULL from Previous Attempts
      $this->datauploadmodel->setStemIDsToNull($tempNewPlants);
      $this->datauploadmodel->setTreeIDsToNull($tempNewPlants);

      //Check if TempBigTrees Exist  (Don't exist now for future use)
      if($this->datauploadmodel->ifTableExist('TempBigTrees'))
      {
         $bigCode = $this->datauploadmodel->getCodes($bigdescription);
         //Set BigTrees field to "n"
         //Set BigTrees field to "y" if code has big tree code
         $this->datauploadmodel->updateTempTreesForBigTrees($tempNewPlants,$bigCode,'Both'); //second parameter is for selecting queries
      }
      else
      {
        $bigCode = $this->datauploadmodel->getCodes($bigdescription);
        //Set BigTrees field to "n"
        $this->datauploadmodel->updateTempTreesForBigTrees($tempNewPlants,$bigCode,'Single'); //second parameter is for selecting queries
      }
///////Update Status//////////////////////////////////
    $list['step'] = '2';
    $list['detail'] = '<span class="smallsuccess">TempNewPlants - Updating Quadrat, Species, DBH, Location</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      //Update Quadrat in TempNewPlant
      $this->datauploadmodel->updQuadratTempTrees($tempNewPlants);
      //Update Species in TempNewPlants
      $this->datauploadmodel->updSpeciesTempTrees($tempNewPlants);
      //Update DBH to NULL where its is O in TempAllTrees
      $this->datauploadmodel->updDBHNullTempTrees($tempNewPlants);
      //Update Location
      $this->datauploadmodel->updLocationTempTrees($tempNewPlants);

///////Update Status//////////////////////////////////
    $list['step'] = '3';
    $list['detail'] = '<span class="smallsuccess">TempNewPlants - Updating Primary Stem from Codes</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      //Update PrimaryStem in TempNewTrees
      $getMainStemQuery = $this->datauploadmodel->getTsmCodeDesc($mainStem);
      if($getMainStemQuery->num_rows() > 0)
      {
        $getMainStemRow = $getMainStemQuery->row_array();
        $mainCode = $getMainStemRow['TSMCode'];
        $mainDescription = $getMainStemRow['Description'];
        $this->datauploadmodel->updPrimaryTempTrees($tempNewPlants,$mainCode,$mainDescription);
      }
      $getSecondStemQuery = $this->datauploadmodel->getTsmCodeDesc($secondaryStem);
      if($getSecondStemQuery->num_rows() > 0)
      {
        $getSecondStemRow = $getSecondStemQuery->row_array();
        $secondCode = $getSecondStemRow['TSMCode'];
        $secondDescription = $getSecondStemRow['Description'];
        $this->datauploadmodel->updPrimaryTempTrees($tempNewPlants,$secondCode,$secondDescription);
      }

      //Check to see if any of the required fields have errors
      $checkNewPlants = $this->datauploadmodel->checkNewPlantsRequiredFields($tempNewPlants);   //will return count
///....If Records Missing - Stop Script and Show Error
      if($checkNewPlants > 0)
      {
///////Update Status//////////////////////////////////
    $list['step'] = '99';//error
    $list['detail'] = '<span class="smallerror">For Some Records QuadratID IS NULL OR SpeciesID IS NULL : Contact Administrator</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
///////////////////////////////////////////////////////
        //echo 'Some records from New Plants cannot be loaded into production tables. Please go back and check them by writing the following SQL in the Data Editing module:<br /><br />
        // QuadratID IS NULL OR SpeciesID IS NULL<br /><br />';
        die();
      }
///....Show upload process started
      else
      {
///////Update Status//////////////////////////////////
    $list['step'] = '4';
    $list['detail'] = '<span class="smallsuccess">TempNewPlants - Uploading Into Production Tables</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////
        //Upload into Tree table - with each tree get the tree tag and insert stems for that in stem table
        $treeDataQuery = $this->datauploadmodel->getTempTreesTreeData($tempNewPlants);
        $treeDataRowCount = $treeDataQuery->num_rows();
        if($treeDataRowCount  > 0)
        {
          $counter = 0;
          $skipCounter = 0;
          $detailList = $list['detailList'];
          $checkTreeTag = array();
          foreach($treeDataQuery->result() as $treeDataRow)
          {
            $counter++;
            if($counter == ($skipCounter + 500) || $counter == $treeDataRowCount)
            {
///////Update No of Records//////////////////////////////////
    $list['step'] = '4';
    $list['detail'] = '<span class="smallsuccess">Uploading Records - '.$counter.'/'.$treeDataRowCount.'</span>';
    $list['detailList'] = $detailList."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
///////////////////////////////////////////////////////
                 $skipCounter = $counter;
            }
            $tempTreeTag = $treeDataRow->Tag;
            $tempSpeciesID = $treeDataRow->SpeciesID;
            $stemTag = $treeDataRow->StemTag;

            //Upload into Tree Table
            if(!isset($checkTreeTag[$tempTreeTag]))  //Upload if the tag is not uploaded already - in case of multiple stems
            {
             $insertTreeData = array('Tag'=>$tempTreeTag,'SpeciesID'=>$tempSpeciesID);
             $this->datauploadmodel->insertRowIntoTable('Tree',$insertTreeData);
             $insertedTreeID = $this->datauploadmodel->getLastInsertedID();
             $checkTreeTag[$tempTreeTag] = $insertedTreeID;
            }
            else
            {
              $insertedTreeID = $checkTreeTag[$tempTreeTag];
            }

            //Upload into Stem table
            $stemDataQuery = $this->datauploadmodel->getTempNewPlantsStemData($tempNewPlants,$tempTreeTag,$stemTag);
            foreach($stemDataQuery->result() as $stemDataRow)
            {
              $tempTempID = $stemDataRow->TempID;
              $tempQuadratID = $stemDataRow->QuadratID;
              $tempStemTag = $stemDataRow->StemTag;
              $tempX = $stemDataRow->X;
              $tempY= $stemDataRow->Y;
              $insertStemData = array('TreeID'=>$insertedTreeID,'QuadratID'=>$tempQuadratID,'StemTag'=>$tempStemTag,'QX'=>$tempX,'QY'=>$tempY);
              $this->datauploadmodel->insertRowIntoTable('Stem',$insertStemData);
              $insertedStemID = $this->datauploadmodel->getLastInsertedID();

              //Upload into DBH Table
              $dbhDataQuery = $this->datauploadmodel->getTempNewPlantsDBHData($tempNewPlants,$tempTempID);
              foreach($dbhDataQuery->result_array() as $dbhDataRow)
              {
                if($dbhDataRow['DBH'] == NULL || $dbhDataRow['DBH'] == 0 || $dbhDataRow['DBH'] == '')
                {
                  $dbhDataRow['DBH'] = NULL;
                }
                if(($dbhDataRow['HOM'] == NULL || $dbhDataRow['HOM'] == 0 || $dbhDataRow['HOM'] == '') AND $dbhDataRow['DBH'] > 0)
                {
                  $dbhDataRow['HOM'] = '1.3';
                }
                if(($dbhDataRow['HOM'] == NULL || $dbhDataRow['HOM'] == 0 || $dbhDataRow['HOM'] == '') AND $dbhDataRow['DBH'] == NULL)
                {
                  $dbhDataRow['HOM'] = NULL;
                }

                $insertDBH = array('CensusID'=>$dbhDataRow['CensusID'],'StemID'=>$insertedStemID,'DBH'=>$dbhDataRow['DBH'],'HOM'=>$dbhDataRow['HOM'],'PrimaryStem'=>$dbhDataRow['PrimaryStem'],'ExactDate'=>$dbhDataRow['ExactDate']);
                $this->datauploadmodel->insertRowIntoTable('DBH',$insertDBH);
                $insertedDBHID = $this->datauploadmodel->getLastInsertedID();  //get the DBHID where the record is inserted

                //insert into DBHAttributes
                $tempCodes = $dbhDataRow['Codes'];
                if(!is_null($tempCodes) AND $tempCodes<>'*' AND $tempCodes<>'')
                {
                  $arrCodes = explode(";", $tempCodes);

                  //Get unique values - avoid duplicate codes
                  $arrCodes = array_unique($arrCodes);
                  $noCodes = count($arrCodes);

                  for ($i = 0; $i < $noCodes; $i++)
                  {
                    if ($arrCodes[$i]<>$mainStem && $arrCodes[$i]<>$secondaryStem)
                    {
                      $tsmIDQuery = $this->datauploadmodel->getTSMID($arrCodes[$i]);
                      $tsmIDRow = $tsmIDQuery->row();
                      $tsmID = $tsmIDRow->TSMID;

                      //$insertDBHAtt = array('DBHID'=>$insertedDBHID,'CensusID'=>$dbhDataRow['CensusID'],'TSMID'=>$tsmID);
                      $insertDBHAtt = array('DBHID'=>$insertedDBHID,'TSMID'=>$tsmID);
                      $this->datauploadmodel->insertRowIntoTable('DBHAttributes',$insertDBHAtt);
                    } //End if
                  }
                }
              }//end foreach dbhDataQuery
            }//end foreach stemDataQuery
          }
          $list['detailList'] = $detailList; //this will remove the number of record part
        }
      }//End Else
      //Drop Temp Tables
      $this->datauploadmodel->dropTableIfExist($tempTrees1);
///////Update Status//////////////////////////////////
    $list['step'] = '5';
    $list['detail'] = '<span class="smallsuccess">Uploading Complete</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
///////////////////////////////////////////////////////
      //Complete Transaction
      $transStatus = $this->datauploadmodel->completeTransaction();

      if($runType == 'direct' AND  $transStatus == 'Success')
      {
        $data['detailList'] = $list['detailList'];
        $data['steps'] = 'Steps Done: 5/5';
        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Data Uploading - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';

        $this->load->view('upload/uploaddirectview',$data);
      }
    }

    function uploadbigtrees($runType = 'ajax')
    {
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];    //actually plotID
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      $mainStem = 'main';
      $secondaryStem = 'secondary';
      $bigdescription = 'Buttressed tree';
      $stemLost =  'stem lost';
      $deadStem = 'dead';
      $tempOldTrees = 'TempOldTrees';
      $tempNewPlants = 'TempNewPlants';
      $tempMultiStems = 'TempMultiStems';
      $tempBigTrees = 'TempBigTrees';
      $tempAllTrees = 'TempAllTrees';
      $tempTrees1 = 'TempTrees1';
      $tempTrees2 = 'TempTrees2';
      $tempTrees = 'TempTrees';

      // Get resprout codes
      $resproutArr = $this->datauploadmodel->getCodes($stemLost);
      $deadArr = $this->datauploadmodel->getCodes($deadStem);

      //Start Transaction
      $this->datauploadmodel->startTransaction();

///////Update Status//////////////////////////////////
    $list['step'] = '1';
    $list['detail'] = '<span class="smallsuccess">Creating, Updating Temp Tables</span>';
    $list['detailList'] = $list['detail'];
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);     // Sleep is used to display the status properly
///////////////////////////////////////////////////////

      //Set all TreeID and StemID to NULL from Previous Attempts
      $this->datauploadmodel->setStemIDsToNull($tempBigTrees);
      $this->datauploadmodel->setTreeIDsToNull($tempBigTrees);

      if($censusNumber > 1)
      {
        //Check to see if site uses Stem Tags
        $checkIfStemTagsUsed = $this->datauploadmodel->checkIfStemTagsUsed($plotName); //will return count of DBHID

        if($this->datauploadmodel->ifTableExist($tempBigTrees))
        {
          //Get TreeIDs for TempBigTrees where TreeID is null
          //Update tempOldTrees
          $this->datauploadmodel->updateTempBigTrees();

          if($checkIfStemTagsUsed > 0)
          {
            //Update StemID
            $this->datauploadmodel->updateStemIDs($tempBigTrees);
          }
        }
      }
///////Update Status//////////////////////////////////
    $list['step'] = '2';
    $list['detail'] = '<span class="smallsuccess">TempBigTrees - Updating Quadrat, Species, DBH</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      //Update Quadrat in TempBigTrees
      $this->datauploadmodel->updQuadratTempTrees($tempBigTrees);
      //Update Species in TempBigTrees
      $this->datauploadmodel->updSpeciesTempTrees($tempBigTrees);
      //Update DBH to NULL where its is O in TempBigTrees
      $this->datauploadmodel->updDBHNullTempTrees($tempBigTrees);

///////Update Status//////////////////////////////////
    $list['step'] = '3';
    $list['detail'] = '<span class="smallsuccess">TempBigTrees - Updating Primary Stem from Codes</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////

      //Update PrimaryStem in TempNewTrees
      $getMainStemQuery = $this->datauploadmodel->getTsmCodeDesc($mainStem);
      if($getMainStemQuery->num_rows() > 0)
      {
        $getMainStemRow = $getMainStemQuery->row_array();
        $mainCode = $getMainStemRow['TSMCode'];
        $mainDescription = $getMainStemRow['Description'];
        $this->datauploadmodel->updPrimaryTempTrees($tempNewPlants,$mainCode,$mainDescription);
      }
      $getSecondStemQuery = $this->datauploadmodel->getTsmCodeDesc($secondaryStem);
      if($getSecondStemQuery->num_rows() > 0)
      {
        $getSecondStemRow = $getSecondStemQuery->row_array();
        $secondCode = $getSecondStemRow['TSMCode'];
        $secondDescription = $getSecondStemRow['Description'];
        $this->datauploadmodel->updPrimaryTempTrees($tempNewPlants,$secondCode,$secondDescription);
      }

///////Update Status//////////////////////////////////
    $list['step'] = '4';
    $list['detail'] = '<span class="smallsuccess">TempBigTrees - Uploading Into Production Tables</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
    sleep(2);
///////////////////////////////////////////////////////
      //Upload into Tree table - if TreeID is NULL
      $treeDataQuery = $this->datauploadmodel->getTempBigTreesTreeData($tempBigTrees);
      $treeDataRowCount = $treeDataQuery->num_rows();
      if($treeDataRowCount  > 0)
      {
        $counter = 0;
        $skipCounter = 0;
        $detailList = $list['detailList'];
        $checkTreeTag = array();
        foreach($treeDataQuery->result() as $treeDataRow)
        {
          $counter++;
          if($counter == ($skipCounter + 500) || $counter == $treeDataRowCount)
          {
///////Update No of Records//////////////////////////////////
    $list['step'] = '4';
    $list['detail'] = '<span class="smallsuccess">Uploading Records - '.$counter.'/'.$treeDataRowCount.'</span>';
    $list['detailList'] = $detailList."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
    session_write_close();
///////////////////////////////////////////////////////
            $skipCounter = $counter;
          }
          $tempTreeID = $treeDataRow->TreeID;
          $tempTreeTag = $treeDataRow->Tag;
          $tempSpeciesID = $treeDataRow->SpeciesID;
          $tempSubSpeciesID = $treeDataRow->SubSpeciesID;
          $stemTag = $treeDataRow->StemTag;

          //Upload into Tree Table
          if($tempTreeID == NULL || $tempTreeID == 0 || $tempTreeID == '')    //if TreeID is missing insert new tree into tree table
          {
             if(!isset($checkTreeTag[$tempTreeTag]))  //Upload if the tag is not uploaded already - in case of multiple stems
             {
               $insertTreeData = array('Tag'=>$tempTreeTag,'SpeciesID'=>$tempSpeciesID,'SubSpeciesID'=>$tempSubSpeciesID);
               $this->datauploadmodel->insertRowIntoTable('Tree',$insertTreeData);
               $tempTreeID = $this->datauploadmodel->getLastInsertedID();
               $checkTreeTag[$tempTreeTag] = $tempTreeID;
             }
             else
             {
               $tempTreeID = $checkTreeTag[$tempTreeTag];
             }
          }

          //Upload into Stem table

            $stemDataQuery = $this->datauploadmodel->getTempBigTreesStemData($tempBigTrees,$tempTreeTag,$stemTag);
            foreach($stemDataQuery->result() as $stemDataRow)
            {
              $tempTempID = $stemDataRow->TempID;
              $tempStemID = $stemDataRow->StemID;
              $tempQuadratID = $stemDataRow->QuadratID;
              $tempStemTag = $stemDataRow->StemTag;
              $tempX = $stemDataRow->X;
              $tempY= $stemDataRow->Y;

              if($tempStemID == NULL || $tempStemID == 0 || $tempStemID == '')    //if TreeID is missing insert new tree into tree table
              {
                $insertStemData = array('TreeID'=>$tempTreeID,'QuadratID'=>$tempQuadratID,'StemTag'=>$tempStemTag,'QX'=>$tempX,'QY'=>$tempY);
                $this->datauploadmodel->insertRowIntoTable('Stem',$insertStemData);
                $tempStemID = $this->datauploadmodel->getLastInsertedID();
              }

              //Upload into DBH Table
              $dbhDataQuery = $this->datauploadmodel->getTempBigTreesDBHData($tempBigTrees,$tempTempID);
              foreach($dbhDataQuery->result_array() as $dbhDataRow)
              {
                if($dbhDataRow['DBH'] == NULL || $dbhDataRow['DBH'] == 0 || $dbhDataRow['DBH'] == '')
                {
                  $dbhDataRow['DBH'] = NULL;
                }
                if(($dbhDataRow['HOM'] == NULL || $dbhDataRow['HOM'] == 0 || $dbhDataRow['HOM'] == '') AND $dbhDataRow['DBH'] > 0)
                {
                  $dbhDataRow['HOM'] = '1.3';
                }
                if(($dbhDataRow['HOM'] == NULL || $dbhDataRow['HOM'] == 0 || $dbhDataRow['HOM'] == '') AND $dbhDataRow['DBH'] == NULL)
                {
                  $dbhDataRow['HOM'] = NULL;
                }

                $insertDBH = array('CensusID'=>$dbhDataRow['CensusID'],'StemID'=>$tempStemID,'DBH'=>$dbhDataRow['DBH'],'HOM'=>$dbhDataRow['HOM'],'PrimaryStem'=>$dbhDataRow['PrimaryStem'],'ExactDate'=>$dbhDataRow['ExactDate']);
                $this->datauploadmodel->insertRowIntoTable('DBH',$insertDBH);
                $insertedDBHID = $this->datauploadmodel->getLastInsertedID();  //get the DBHID where the record is inserted

                //insert into DBHAttributes
                $tempCodes = $dbhDataRow['Codes'];
                if(!is_null($tempCodes) AND $tempCodes<>'*' AND $tempCodes<>'')
                {
                  $arrCodes = explode(";", $tempCodes);

                  //Get unique values - avoid duplicate codes
                  $arrCodes = array_unique($arrCodes);
                  $noCodes = count($arrCodes);

                  for ($i = 0; $i < $noCodes; $i++)
                  {
                    if ($arrCodes[$i]<>$mainStem && $arrCodes[$i]<>$secondaryStem)
                    {
                      $tsmIDQuery = $this->datauploadmodel->getTSMID($arrCodes[$i]);
                      $tsmIDRow = $tsmIDQuery->row();
                      $tsmID = $tsmIDRow->TSMID;

                      //$insertDBHAtt = array('DBHID'=>$insertedDBHID,'CensusID'=>$dbhDataRow['CensusID'],'TSMID'=>$tsmID);
                      $insertDBHAtt = array('DBHID'=>$insertedDBHID,'TSMID'=>$tsmID);
                      $this->datauploadmodel->insertRowIntoTable('DBHAttributes',$insertDBHAtt);
                    }
                  }
                }// end if is null

              }//Foreach DBH
            }//Foreach Stem
        }//Foreach tree
        $list['detailList'] = $detailList; //this will remove the number of record part
      } //end if($treeDataRowCount  > 0)

///////Update Status//////////////////////////////////
    $list['step'] = '5';
    $list['detail'] = '<span class="smallsuccess">Uploading Complete</span>';
    $list['detailList'] = $list['detailList']."<br />".$list['detail'];
    session_start();
    $this->session->set_userdata('progressList',$list);
///////////////////////////////////////////////////////
      //Complete Transaction
      $transStatus = $this->datauploadmodel->completeTransaction();

      if($runType == 'direct' AND  $transStatus == 'Success')
      {
        $data['detailList'] = $list['detailList'];
        $data['steps'] = 'Steps Done: 5/5';
        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'Data Uploading - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';

        $this->load->view('upload/uploaddirectview',$data);
      }
    }

    function oldAjaxRequestStep()
    {
      $list = $this->session->userdata('progressList');
      $step = $list['step'];
      echo $step;
    }

    function oldAjaxRequestDetail()
    {
      $list = $this->session->userdata('progressList');
      $detail = $list['detail'];
      $detailList = $list['detailList'];
      echo $detailList;
    }

}