<?php

class Dataview extends Controller{

    function Dataview()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->library(array('table','pagination'));
      $this->load->model('dataviewmodel');
    }

    function selectformtype($dataType = 'all')
    {
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      if(isset($this->session->userdata['formType']))
      {
        $this->session->unset_userdata('formType');
      }

      if(isset($this->session->userdata['tableNames']))
      {
        $this->session->unset_userdata('tableNames');
      }
      if($dataType == 'errors')
      {
        $data['formOpen'] = form_open("dataview/selectformtypevalidate/errors");
        $data['contentTitle'] = 'View Screened Data with Error-<span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      }
      else
      {
        $data['formOpen'] = form_open("dataview/selectformtypevalidate");
        $data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      }
      $data['formTable'] = $this->_selectFormTypeTable();

      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      //$data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $data['backLink'] = anchor('/dataentry/selectentrytype', 'Back', array('title'=>'Back to Select Entry Type', 'class'=>'back'));
      $this->load->view('user/dataentry/simpleform',$data);
    }

    function selectformtypevalidate($dataType = 'all')
    {
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      $this->_validateselectformtype();

      if($this->form_validation->run() == FALSE)
      {
        if($dataType == 'errors')
        {
          $data['formOpen'] = form_open("dataview/selectformtypevalidate/errors");
          $data['contentTitle'] = 'View Screened Data with Error-<span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        }
        else
        {
          $data['formOpen'] = form_open("dataview/selectformtypevalidate");
          $data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        }
        $data['formTable'] = $this->_selectFormTypeTable();

        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        //$data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/dataentry/selectentrytype', 'Back', array('title'=>'Back to Select Entry Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
      else
      {
        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];

        if(isset($this->session->userdata['tablesNames']))
        {
          $this->session->unset_userdata('tablesNames');
        }

        $formType = $this->input->post('formType');
        //$this->session->set_userdata('formType',$formType);

        if($formType == 'newform')
        {
          $like = 'TempNewPlants%';
        }
        elseif($formType == 'multiform')
        {
          $like = 'TempMultiStems%';
        }
        elseif($formType == 'oldform')
        {
          $like= 'TempOldTrees%';
        }
        elseif($formType == 'bigform')
        {
          $like = 'TempBigTrees%';
        }

        $tableNameArray = $this->dataviewmodel->tableNameList($like);

        //form with drop down - listing temp tables in the selected form type
        $data['formTable'] = $this->_selectFileTable($tableNameArray,$formType);

        if($dataType == 'errors')
        {
          $data['formOpen'] = form_open("dataview/selectfilesvalidate/errors");
          $data['backLink'] = anchor('/dataview/selectformtype/errors', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
          $data['contentTitle'] = 'View Screened Data with Error-<span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        }
        else
        {
          $data['formOpen'] = form_open("dataview/selectfilesvalidate");
          $data['backLink'] = anchor('/dataview/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
          $data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        }

        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        //$data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $this->load->view('user/dataentry/simpleform',$data);
      }
    }

    function _selectFormTypeTable()
    {
      $formType = set_value('formType');

      $formTypeA = array('default'=>'Select','newform'=>'New Plants','oldform'=>'Old Trees','multiform'=>'Multi Stem','bigform'=>'Big Trees');
      //$formTypeA = array('default'=>'Select','newform'=>'New Plants','oldform'=>'Old Trees','multiform'=>'Multi Stem');
      $formTypeDD = form_dropdown('formType',$formTypeA);

      $formTypeErr = form_error('formType');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Form Type : ',$formTypeDD,$formTypeErr),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validateselectformtype()
    {
      $this->form_validation->set_rules('formType', 'Form Type', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function _selectFileTable($tableNameArray,$formType)
    {
      $tableName1 = set_value('tableName1');

      $tableName1DD = form_dropdown('tableName1',$tableNameArray,$tableName1);
      $tableNameHd = form_hidden('tableNameArray',$tableNameArray);
      $formTypeHd = form_hidden('formType',$formType);

      $tableName1Err = form_error('tableName1');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Table : ',$tableName1DD,$tableName1Err),
                          array('',$tableNameHd.$formTypeHd),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validateselectfiles()
    {
      $this->form_validation->set_rules('tableName1', 'Table', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function selectfilesvalidate($dataType = 'all')
    {
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      $this->_validateselectfiles();
      $tableNameArray = $this->input->post('tableNameArray');
      $formType = $this->input->post('formType');
      if($this->form_validation->run() == FALSE)
      {
        //form with drop down - listing temp tables in the selected form type
        $data['formTable'] = $this->_selectFileTable($tableNameArray,$formType);
        if($dataType == 'errors')
        {
          $data['formOpen'] = form_open("dataview/selectfilesvalidate/errors");
          $data['contentTitle'] = 'View Screened Data with Erro-<span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        }
        else
        {
          $data['formOpen'] = form_open("dataview/selectfilesvalidate");
          $data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        }

        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';

        $data['backLink'] = anchor('/dataview/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
      else
      {
        $tableName1 = $this->input->post('tableName1');

        $tableNames['tableName1'] = $tableName1;

        $this->session->set_userdata('tableNames',$tableNames);

        if(isset($this->session->userdata['countTotalRecords']))
        {
          $this->session->unset_userdata('countTotalRecords');
        }

        if($dataType == 'errors')
        {
          redirect('dataview/viewerrors');
        }
        else
        {
          redirect('dataview/viewall');
        }
      }
    }

    function viewall($offset = 0)
    {
      if(!isset($this->session->userdata['tableNames']))
      {
        redirect('dataview/selectformtype');
      }
      $tableNames = $this->session->userdata('tableNames');
      $tableName1 = $tableNames['tableName1'];

      ////////////////////////////////////////
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotID = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $selectedPlotName = $this->session->userdata('selectedPlotName');
      $plotName = $this->dataviewmodel->getPlotNameByID($plotID);

      $this->load->library('formlibrary');

      $explodeTN1 = explode('_',$tableName1);
      if($explodeTN1[0] == 'TempNewPlants') //Process New Form Config File
      {
        $formType = 'newform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :  ".$fileName;
          die();
        }
        $this->load->library('newplantlibrary');
        $processData = $this->newplantlibrary->processData($formDetailResult);
      }
      elseif($explodeTN1[0] == 'TempMultiStems') //Process Multi Form Config File
      {
        $formType = 'multiform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :  ".$fileName;
          die();
        }
        $this->load->library('multistemlibrary');
        $processData = $this->multistemlibrary->processData($formDetailResult);
      }
      elseif($explodeTN1[0] == 'TempOldTrees') //Process Old Form Config File
      {
        $formType = 'oldform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :  ".$fileName;
          die();
        }
        $this->load->library('oldplantlibrary');
        $processData = $this->oldplantlibrary->processData($formDetailResult);
      }
      elseif($explodeTN1[0] == 'TempBigTrees') //Process Big Form Config File
      {
        $formType = 'bigform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :  ".$fileName;
          die();
        }
        $this->load->library('bigtreelibrary');
        $processData = $this->bigtreelibrary->processData($formDetailResult);
      }
      $headerListA = $processData['headerListA'];
      $columnNameA = $processData['columnNameA'];
      ////////////////////////////////////////////////
      $tempTableColumns = $this->_tempTableColumns();

      foreach($columnNameA as $key => $value)
      {
        $columnListA[$key] = $tempTableColumns[$value];
      }

      if(!isset($this->session->userdata['countTotalRecords']))
      {
        $getAllRecordsQuery = $this->dataviewmodel->getAllRecords($tableName1,$columnListA);
        $countTotalRecords = $getAllRecordsQuery->num_rows();
      }
      else
      {
        $countTotalRecords = $this->session->userdata('countTotalRecords');
      }

      if($countTotalRecords > 0)
      {
        $limit = 30;

        $getRecordsLimitQuery = $this->dataviewmodel->getRecordsLimit($tableName1,$columnListA,$offset,$limit);
        $getRecordsLimitResult = $getRecordsLimitQuery->result_array();

        //offset - starting point for the current page
  		$uri_segment = 3;
  		$offset = $this->uri->segment($uri_segment);

  		//generate pagination
  		$config['base_url'] = site_url('dataview/viewall/');
  		$config['total_rows'] = $countTotalRecords;
  		$config['per_page'] = $limit;
  		$config['uri_segment'] = $uri_segment;
        if($countTotalRecords > 0 AND $limit > 0)
        {
         $pageCount = $countTotalRecords / $limit;
         $pageCount = ceil($pageCount);
         $config['last_link'] = "Last(".$pageCount.")>";
        }
  		$this->pagination->initialize($config);
  		$data['pagination'] = $this->pagination->create_links();

  		//generate table data
  		$this->table->set_empty("&nbsp;");

        $headerListShift = $headerListA;
        array_unshift($headerListShift,"No.");

        $this->table->set_heading($headerListShift);
        $i = 0 + $offset;
        foreach($getRecordsLimitResult as $limitRow)
        {
          $i = ++$i;
          array_unshift($limitRow,$i);
          $this->table->add_row($limitRow);
        }
        $data['table'] = $this->table->generate();

        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>'.'<h5 align=right>Total Records: '.$countTotalRecords.'</h5>';
        $data['backLink'] = anchor('/dataview/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));

        $this->load->view('treeforms/viewform',$data);
      }
      else
      {
        $data['table'] = "<h2>No Record Found!!</h2>";
        $data['pagination'] = "";
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/dataview/selectformtype', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));

        $this->load->view('treeforms/viewform',$data);
      }
    }

    function viewerrors($offset = 0)
    {
      if(!isset($this->session->userdata['tableNames']))
      {
        redirect('dataview/selectformtype');
      }
      $tableNames = $this->session->userdata('tableNames');
      $tableName1 = $tableNames['tableName1'];

      ////////////////////////////////////////
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotID = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $selectedPlotName = $this->session->userdata('selectedPlotName');
      $plotName = $this->dataviewmodel->getPlotNameByID($plotID);

      $this->load->library('formlibrary');

      $explodeTN1 = explode('_',$tableName1);
      if($explodeTN1[0] == 'TempNewPlants') //Process New Form Config File
      {
        $formType = 'newform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :  ".$fileName;
          die();
        }
        $this->load->library('newplantlibrary');
        $processData = $this->newplantlibrary->processData($formDetailResult);
      }
      elseif($explodeTN1[0] == 'TempMultiStems') //Process Multi Form Config File
      {
        $formType = 'multiform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :  ".$fileName;
          die();
        }
        $this->load->library('multistemlibrary');
        $processData = $this->multistemlibrary->processData($formDetailResult);
      }
      elseif($explodeTN1[0] == 'TempOldTrees') //Process Old Form Config File
      {
        $formType = 'oldform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName); 
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :  ".$fileName;
          die();
        }
        $this->load->library('oldplantlibrary');
        $processData = $this->oldplantlibrary->processData($formDetailResult);
      }
      elseif($explodeTN1[0] == 'TempBigTrees') //Process Big Form Config File
      {
        $formType = 'bigform';
        $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
        $fileName = str_replace(" ","",$fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);

        if($formDetailResult == "Not Found")
        {
          echo "Configuration File Not Found  :  ".$fileName;
          die();
        }
        $this->load->library('bigtreelibrary');
        $processData = $this->bigtreelibrary->processData($formDetailResult);
      }
      $headerListA = $processData['headerListA'];
      $columnNameA = $processData['columnNameA'];
      ////////////////////////////////////////////////
      $tempTableColumns = $this->_tempTableColumns();

      foreach($columnNameA as $key => $value)
      {
        $columnListA[$key] = $tempTableColumns[$value];
      }
      //Add Errors column into columnListA and to headerListA
      $columnListA['error'] = 'Errors';
      $headerListA['error'] = 'Errors';

      if(!isset($this->session->userdata['countTotalRecords']))
      {
        $getAllRecordsQuery = $this->dataviewmodel->getAllRecordsWithError($tableName1,$columnListA);
        $countTotalRecords = $getAllRecordsQuery->num_rows();
      }
      else
      {
        $countTotalRecords = $this->session->userdata('countTotalRecords');
      }

      if($countTotalRecords > 0)
      {
        $limit = 30;

        $getRecordsLimitQuery = $this->dataviewmodel->getRecordsWithErrorLimit($tableName1,$columnListA,$offset,$limit);
        $getRecordsLimitResult = $getRecordsLimitQuery->result_array();

        //offset - starting point for the current page
  		$uri_segment = 3;
  		$offset = $this->uri->segment($uri_segment);

  		//generate pagination
  		$config['base_url'] = site_url('dataview/viewerrors/');
  		$config['total_rows'] = $countTotalRecords;
  		$config['per_page'] = $limit;
  		$config['uri_segment'] = $uri_segment;
        if($countTotalRecords > 0 AND $limit > 0)
        {
         $pageCount = $countTotalRecords / $limit;
         $pageCount = ceil($pageCount);
         $config['last_link'] = "Last(".$pageCount.")>";
        }
  		$this->pagination->initialize($config);
  		$data['pagination'] = $this->pagination->create_links();

  		//generate table data
  		$this->table->set_empty("&nbsp;");

        $headerListShift = $headerListA;
        array_unshift($headerListShift,"No.");

        $this->table->set_heading($headerListShift);
        $i = 0 + $offset;
        foreach($getRecordsLimitResult as $limitRow)
        {
          $i = ++$i;
          array_unshift($limitRow,$i);
          $errors = $limitRow['Errors'];
          $errorsA = explode(';',$errors);
          $limitRow['Errors'] = implode('<br />',$errorsA);
          $this->table->add_row($limitRow);
        }
        $data['table'] = $this->table->generate();

        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'View Screened Data with Error-<span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>'.'<h5 align=right>Total Records: '.$countTotalRecords.'</h5>';
        $data['backLink'] = anchor('/dataview/selectformtype/errors', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));

        $this->load->view('treeforms/viewform',$data);
      }
      else
      {
        $data['table'] = "<h2>No Record Found!!</h2>";
        $data['pagination'] = "";
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'View Screened Data with Error-<span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/dataview/selectformtype/errors', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));

        $this->load->view('treeforms/viewform',$data);
      }
    }

    function errorsummary($tempTable = 'TempNewPlants')
    {
      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      if($this->dataviewmodel->ifTableExist($tempTable))
      {
        $getErrorsQuery = $this->dataviewmodel->getErrors($tempTable);
        if($getErrorsQuery->num_rows() > 0)
        {
          //$tmpl = array ( 'table_open'  => '<table border="1" class="data">' );
          //$this->table->set_template($tmpl);
          $this->table->set_heading('Group Of Errors','No. Of Errors');
          foreach($getErrorsQuery->result_array() as $getErrorsRow)
          {
            $this->table->add_row($getErrorsRow['Errors'],$getErrorsRow['ErrorCount']);
          }
          $data['formTable'] = '<div class="data1">'.$this->table->generate().'</div>';
        }
        else
        {
          $data['formTable'] = "<h3>No Records with Errors!!</h3>";
        }
      }
      else
      {
        $data['formTable'] = "<h3>Temp Table Don't Exist!!</h3>";
      }
      $data['formOpen'] = '';
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Summary '.$tempTable.' - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $data['backLink'] = anchor('/dataentry/summary', 'Back', array('title'=>'Back', 'class'=>'back'));
      $this->load->view('user/dataentry/simpleform',$data);
    }

    function _tempTableColumns()
    {
      $tempTableColumns['treeID']  = 'TreeID';
      $tempTableColumns['tag']  = 'Tag';
      $tempTableColumns['stemID']  = 'StemID';
      $tempTableColumns['stemTag']  = 'StemTag';
      $tempTableColumns['quadratID']  = 'QuadratID';
      $tempTableColumns['quadratName']  = 'QuadratName';
      $tempTableColumns['subquadrat']  = 'Subquad';
      $tempTableColumns['speciesID']  = 'SpeciesID';
      $tempTableColumns['species']  = 'Mnemonic';
      $tempTableColumns['subSpeciesID']  = 'SubSpeciesID';
      $tempTableColumns['plotID']  = 'PlotID';
      $tempTableColumns['censusID']  = 'CensusID';
      $tempTableColumns['plotCensusNumber']  = 'PlotCensusNumber';
      $tempTableColumns['primaryStem']  = 'PrimaryStem';
      $tempTableColumns['x']  = 'X';
      $tempTableColumns['y']  = 'Y';
      $tempTableColumns['dbh']  = 'DBH';
      $tempTableColumns['olddbh']  = 'OldDBH';
      $tempTableColumns['hom']  = 'HOM';
      $tempTableColumns['oldhom']  = 'OldHOM';
      $tempTableColumns['codes']  = 'Codes';
      $tempTableColumns['oldcodes']  = 'OldCodes';
      $tempTableColumns['comments']  = 'Comments';
      $tempTableColumns['exactDate']  = 'ExactDate';
      $tempTableColumns['errors']  = 'Errors';
      $tempTableColumns['oldTrees']  = 'OldTrees';
      $tempTableColumns['bigTrees']  = 'BigTrees';
      $tempTableColumns['extra1']  = 'Extra1';
      $tempTableColumns['extra2']  = 'Extra2';
      $tempTableColumns['extra3']  = 'Extra3';
      $tempTableColumns['extra4']  = 'Extra4';
      $tempTableColumns['extra5']  = 'Extra5';

      return $tempTableColumns;
    }


    /////////////Helper Function/////////////////
    function dropdown_check($str)
    {
      if($str == 'default')
      {
          $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
          return FALSE;
      }
      else
      {
          return True;
      }
    }
    ////////////////////////////////////////
    /*function viewerrorsselectform()
    {
      if(isset($this->session->userdata['formType']))
      {
        $this->session->unset_userdata('formType');
      }

      $data['formOpen'] = form_open("dataview/viewerrors");
      $data['formTable'] = $this->_selectFormTypeTable();

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
      $data['backLink'] = anchor('/dataentry/viewdata', 'Back', array('title'=>'Back to View Data', 'class'=>'back'));
      $this->load->view('user/dataentry/simpleform',$data);
    }

    function _selectFormTypeTable()
    {
      $formType = set_value('formType');

      $formTypeA = array('default'=>'Select','newform'=>'New Plants','oldform'=>'Old Trees','multiform'=>'Multi Stem');
      $formTypeDD = form_dropdown('formType',$formTypeA);

      $formTypeErr = form_error('formType');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Form Type : ',$formTypeDD,$formTypeErr),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function _validateselectformtype()
    {
      $this->form_validation->set_rules('formType', 'Form Type', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function viewerrors()
    {
      $this->_validateselectformtype();

      if($this->form_validation->run() == FALSE)
      {
        $data['formOpen'] = form_open("dataview/viewerrors");
        $data['formTable'] = $this->_selectFormTypeTable();

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/dataentry/viewdata', 'Back', array('title'=>'Back to View Data', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
      else
      {
        if(isset($this->session->userdata['tablesNames']))
        {
          $this->session->unset_userdata('tablesNames');
        }

        $formType = $this->input->post('formType');
        //$this->session->set_userdata('formType',$formType);

        if($formType == 'newform')
        {
          $like = 'TempNewPlants%';
        }
        elseif($formType == 'multiform')
        {
          $like = 'TempMultiStems%';
        }
        elseif($formType == 'oldform')
        {
          $like= 'TempOldTrees%';
        }

        $tableNameArray = $this->dataviewmodel->tableNameList($like);

        //form with drop down - listing temp tables in the selected form type
        $data['formTable'] = $this->_selectFileTable($tableNameArray,$formType);
        $data['formOpen'] = form_open("dataentry/viewerrorsform");

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/dataview/viewerrorsform', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
    }

    function _selectFileTable($tableNameArray,$formType)
    {
      $tableName1 = set_value('tableName1');

      $tableName1DD = form_dropdown('tableName1',$tableNameArray,$tableName1);
      $tableNameHd = form_hidden('tableNameArray',$tableNameArray);
      $formTypeHd = form_hidden('formType',$formType);

      $tableName1Err = form_error('tableName1');

      $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array(),
                          array('Table : ',$tableName1DD,$tableName1Err),
                          array('',$tableNameHd.$formTypeHd),
                          array('',$submitButton)
                          );

      $this->table->set_empty("");
      $formTable = $this->table->generate($formTableA);

      return $formTable;
    }

    function viewerrorsform()
    {
      $this->_validateviewerrors();
      $tableNameArray = $this->input->post('tableNameArray');
      $formType = $this->input->post('formType');
      if($this->form_validation->run() == FALSE)
      {
        $data['formTable'] = $this->_selectFileTable($tableNameArray,$formType);
        $data['formOpen'] = form_open("dataentry/viewerrorsform");

        $plotCensusArray = $this->session->userdata('plotCensusArray');
        $plotName = $plotCensusArray['plotName'];
        $censusNumber = $plotCensusArray['censusNumber'];
        $plotActualName = $plotCensusArray['plotActualName'];
        $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
        $data['contentTitle'] = 'View Screened Data - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
        $data['backLink'] = anchor('/dataview/viewerrorsform', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
        $this->load->view('user/dataentry/simpleform',$data);
      }
      else
      {

      }
    }

    function _validateviewerrors()
    {
      $this->form_validation->set_rules('tableName1', 'Table', 'callback_dropdown_check');

      $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function viewalldata()
    {

    }

    /////////////Helper Function/////////////////
    function dropdown_check($str)
    {
      if($str == 'default')
      {
          $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
          return FALSE;
      }
      else
      {
          return True;
      }
    }
    ////////////////////////////////////////*/
}