<?php

class Oldplantform extends Controller {

  function Oldplantform()
  {
    parent::Controller();
    if($this->session->userdata('loggedin') !== '1')
    {
      redirect('main','location');
    }
    $this->load->model('formmodel');
  }

  function index()
  {
      if(!isset($this->session->userdata['plotCensusArray']))
      {
         redirect('dataentry/plotcensus','location');
      }

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      if(isset($this->session->userdata['includeDead']))
      {
        $this->session->unset_userdata('includeDead');
        $this->session->unset_userdata('excludeDead');
        $this->session->unset_userdata('subQuadratCustom');
      }

      $includeDead = set_value('includeDead');
      $includeDeadA = array('No'=>'No','Yes'=>'Yes');
      $subQuadratA = array('name' => 'subQuadrat', 'id' => 'subQuadrat', 'size' => '25');
      $includeDeadDD = form_dropdown('includeDead',$includeDeadA, $includeDead);

      if($censusNumber == 2){
         $excludeDeadA['1'] = '1';
         $excludeDeadA['2'] = 'Don\'t Exclude';
      }
      elseif($censusNumber > 2){
          for($i=1;$i<$censusNumber;$i++){
            if($i == 2){
              $excludeDeadA[$i] = '2 (Default)';
            }
            else {
              $excludeDeadA[$i] = $i;
            }
          }
      }
      else{
          $excludeDeadA = array('2'=>'Not Available');
      }
      $excludeDead = '2';
      $excludeDeadDD = form_dropdown('excludeDead',$excludeDeadA, $excludeDead);
      $subQuadratTbx = form_input($subQuadratA);

      $submitButtonA = array('name' => 'includeDeadButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Go To Old Tree Form');
      $submitButton = form_button($submitButtonA);

      $formTableA = array(array('<h2>Old Tree Form<h2>'),
                           array('<span style="color:#FF0000;">Instructions: </span>'),
                           array("<p>- Choose the quadrat you want to enter data from. Always finish a quadrat before submitting the form.</p>
                                  <p>- Enter all the people working on the quadrat by pressing the plus button to the right</p>
                                  <p>- In the case that your site does not have people who check the work done by the collectors, enter the same names of the collectors and the date collected in the corresponding fields for the checkers. Do not leave blank.</p>
                                  <p>- Use the * key to go from field to next.</p>
                                  <p>- Use the / key to go from field to previous.</p>
                                  <p>- Do not use special characaters (accents, etc.).</p>"),
                           array('- Do you want to include dead trees: &nbsp;&nbsp;&nbsp;&nbsp;'.$includeDeadDD),
                           array('- Exclude trees dead in all of last x census:  &nbsp;&nbsp;&nbsp;&nbsp;'.$excludeDeadDD),
                           array('SubQuadrat order(; Seperated): &nbsp;&nbsp;&nbsp;&nbsp;'.$subQuadratTbx),
                           array('<br />'),
                           array($submitButton)
                          );
       $this->table->set_empty("");
       $data['formTable'] = $this->table->generate($formTableA);
       $data['formOpen'] = form_open("oldplantform/createform");
       $data['backLink'] = '';


       $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
       $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
       $this->load->view('user/dataentry/simpleform',$data);
  }

  /*function selectcensus()
  {
    if(isset($this->session->userdata['censusID']))
    {
      $this->session->unset_userdata('censusID');
    }
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Select a Census ID";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("oldplant/createform");
    $plotID = $this->session->userdata('configPlotID');
    $data['table'] = $this->_selectCensusTable($plotID);
    $data['backLink'] = "";
    $this->load->view('forms/simpleform',$data);
  }

  function _selectCensusTable($plotID)
  {
    $censusID = set_value('selectPlot');

    $censusIDA = $this->formmodel->getCensusList($plotID);

    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');

    $censusIDDD = form_dropdown('censusID',$censusIDA);
    $submitButton = form_button($submitButtonA);

    $formTableA = array(array(),
                        array('Select Last Census ID : ',$censusIDDD),
                        array('',"<br />"),
                        array('',$submitButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }*/

  function createform()
  {
    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotID = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];

    $selectedPlotName = $this->session->userdata('selectedPlotName');

    $plotName = $this->formmodel->getPlotNameByID($plotID);

    //$plotID = $this->session->userdata('configPlotID');
    //$formType = $this->session->userdata('formType');
    $formType = 'oldform';
    $lastSubquadrat = ""; //used to create blank rows after a subquadrat ends

    $checkTabA = array();

    if(isset($_POST['getform']))
    {
     $quadratName = $this->input->post('quadrat');
    }
    else
    {
      $firstQuadratNameQ = $this->formmodel->getAllQuadratNames($plotID);
      $firstQuadratNameR = $firstQuadratNameQ->row();
      $quadratName = $firstQuadratNameR->QuadratName;
    }

    if(isset($this->session->userdata['includeDead'])) {
        $includeDead = $this->session->userdata('includeDead');
        $excludeDead = $this->session->userdata('excludeDead');
        $subQuadratCustom = $this->session->userdata('subQuadrat');

    }
    elseif(($this->input->post('includeDead')))
    {
       $includeDead = $this->input->post('includeDead');
       $excludeDead = $this->input->post('excludeDead');
       $subQuadratCustom = $this->input->post('subQuadrat');
       $this->session->set_userdata('includeDead',$includeDead);
       $this->session->set_userdata('excludeDead',$excludeDead);
       $this->session->set_userdata('subQuadratCustom',$subQuadratCustom);
    }
    else
    {
      $includeDead = 'No';
      $excludeDead = 2;
      $subQuadratCustom = '';
    }
    //die($includeDead);

    /*$this->load->model('configmodel');
    $formDetailQuery = $this->configmodel->getDataByPlotID($plotID,$formType);
    $formDetailResult = $formDetailQuery->result();*/
    $this->load->library('formlibrary');
    $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
    $fileName = str_replace(" ","",$fileName);
    $formDetailResult = $this->formlibrary->readConfigFile($fileName);

    if($formDetailResult == "Not Found")
    {
       $data['formTable'] = '<br /><br /><div class="error"> Configuration File Not Found</div>';

       $plotCensusArray = $this->session->userdata('plotCensusArray');
       $plotName = $plotCensusArray['plotName'];
       $censusNumber = $plotCensusArray['censusNumber'];
       $plotActualName = $plotCensusArray['plotActualName'];
       $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
       $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
       $this->load->view('user/dataentry/mainmenu',$data);
    }

    else //rest all code of this function
    {
        $subQuadratOrder = '';
        foreach($formDetailResult as $formDetailRow)
        {
          if($formDetailRow->ColumnType == 'oldcolumn')
          {
            $attributes = $formDetailRow->Attributes;
            $columnNumber = $formDetailRow->ColumnNumber;
            $attributesArray = $this->_sortOldFormData($attributes);
            $columnName = $attributesArray['columnName'];
            if($columnName == 'subquadrat')
            {
              $startsWith = $attributesArray['startsWith'];
              $maxX = $attributesArray['maxX'];
              $maxY = $attributesArray['maxY'];
              $orderBy = 'subquadrat';
              if($subQuadratCustom !== '') {
                $subQuadratCustomArr = explode(';', $subQuadratCustom);
                if($startsWith == 'A'){
                  foreach($subQuadratCustomArr as $key=>$val){
                    $valSplitArr = str_split($val,1);
                    $firstConv = ord(strtoupper($valSplitArr[0])) - ord('A') + 1;
                    $subQuadratCustomArr[$key] = $firstConv.$valSplitArr[1];
                  }
                }
                $subQuadratOrder = implode(',', $subQuadratCustomArr);
              }
            }
            elseif($columnName == 'nosubTag')
            {
              $maxX = $attributesArray['maxX'];
              $maxY = $attributesArray['maxY'];
              $orderBy = 'treetag';
            }
          }
        }
        $subquadQuery = "SELECT QDimX as DimX, QDimY as DimY FROM Site WHERE PlotID = ".$plotID;
        $subquadReturnQuery = $this->formmodel->subquadDDQuery($subquadQuery);
        $subquadRow = $subquadReturnQuery->row();
        $dimX = $subquadRow->DimX;
        $dimY = $subquadRow->DimY;



        $lastCensusID = $censusNumber - 1;
        if($lastCensusID == 0)
        {
           $data['formTable'] = '<br /><br /><div class="error">Old data does not exist for Census 1.</div>';

           $plotCensusArray = $this->session->userdata('plotCensusArray');
           $plotName = $plotCensusArray['plotName'];
           $censusNumber = $plotCensusArray['censusNumber'];
           $plotActualName = $plotCensusArray['plotActualName'];
           $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
           $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
           $this->load->view('user/dataentry/mainmenu',$data);
        }
        else
        {
          //Create Table
          $tmpl = array ( 'table_open'  => '<table id="formtable">' );
          $this->table->set_template($tmpl);
          $this->table->set_empty("&nbsp;");
          //$this->table->set_heading($headerListA);


          $this->load->model('formmodel');

          if($excludeDead !=2 and $includeDead == 'no'){
            $treeDeadArray = $this->formmodel->treeDeadExclude($lastCensusID,$plotID,$quadratName,$excludeDead);
          }
          else {
            if($lastCensusID > 2 and $includeDead == 'no')
            {
              $treeDeadArray = $this->formmodel->treeDead($lastCensusID,$plotID,$quadratName);
            }
            else
            {
              $treeDeadArray = array();
            }
          }

          $oldDataExtractQuery = $this->formmodel->olddataextractField($lastCensusID,$plotID,$quadratName,$maxX,$maxY,$dimX,$dimY,$orderBy,$treeDeadArray,$subQuadratOrder);

          if($oldDataExtractQuery->num_rows > 0)
          {
            $rowNumber = 1;
            foreach($oldDataExtractQuery->result() as $oldExtractRow)
            {
              /*if($formDetailQuery->num_rows() > 0)
              {*/
                foreach($formDetailResult as $formDetailRow)
                {
                  if($formDetailRow->ColumnType == 'oldcolumn')
                  {
                    $attributes = $formDetailRow->Attributes;
                    $columnNumber = $formDetailRow->ColumnNumber;

                    $attributesArray = $this->_sortOldFormData($attributes);
                    $columnHeader = $attributesArray['columnHeader'];
                    $headerListA[$columnNumber] = $columnHeader;
                    $columnName = $attributesArray['columnName'];
                    $columnNameA[$columnNumber] = $columnName;
                    $columnSize = $attributesArray['columnSize'];
                    if($columnName == 'subquadrat')
                    {
                      $startsWith = $attributesArray['startsWith'];
                      $maxX = $attributesArray['maxX'];
                      $maxY = $attributesArray['maxY'];

                      if($startsWith == '0')
                      {
                        $in = 0;
                      }
                      else
                      {
                        $in = 1;
                      }
                      $qX = $oldExtractRow->QX;
                      $qY = $oldExtractRow->QY;
                      if($qX != "")
                      {
                        $qX = $in + intval(($qX-$dimX*intval($qX/$dimX))/$maxX);
                        if($startsWith == 'A')
                        {
                          $aX = 'A';
                          for($zz=1;$zz<$qX;$zz++)
                          {
                            ++$aX;
                          }
                          $qX = $aX;
                        }
                      }
                      if($qY != "")
                      {
                        $qY = $in + intval(($qY-$dimY*intval($qY/$dimY))/$maxY);
                      }
                      $subquadrat = $qX.$qY;
                      $columnListA[$columnNumber] = $this->_readOnlyAddColumn($subquadrat,$columnName,$rowNumber,$columnSize);
                      if($lastSubquadrat !== $subquadrat)
                      {
                        $this->table->add_row('<br /><br />');  //to create gap after a group of subquadrats
                      }
                      $lastSubquadrat = $subquadrat;
                      $checkTabA[$columnNumber] = "no";

                     }
                     elseif($columnName == 'tag')
                     {
                       $treeTag = $oldExtractRow->Tag;
                       $columnListA[$columnNumber] = $this->_readOnlyAddColumn($treeTag,$columnName,$rowNumber,$columnSize);
                       $checkTabA[$columnNumber] = "no";
                     }
                     elseif($columnName == 'nosubTag')
                     {
                       $treeTag = $oldExtractRow->Tag;
                       $columnListA[$columnNumber] = $this->_readOnlyAddColumn($treeTag,$columnName,$rowNumber,$columnSize);
                       $checkTabA[$columnNumber] = "no";
                     }
                     elseif($columnName == 'stemTag')
                     {
                       $readOnly = $attributesArray['readOnly'];
                       $stemTag = $oldExtractRow->StemTag;
                       if($readOnly == "no")
                       {
                         $columnListA[$columnNumber] = $this->_notReadOnlyAddColumn($stemTag,$columnName,$rowNumber,$columnSize);
                         $checkTabA[$columnNumber] = "yes";
                       }
                       else
                       {
                         $columnListA[$columnNumber] = $this->_readOnlyAddColumn($stemTag,$columnName,$rowNumber,$columnSize);
                         $checkTabA[$columnNumber] = "no";
                       }
                     }
                     elseif($columnName == 'species')
                     {
                       $species = $oldExtractRow->Mnemonic;
                       $columnListA[$columnNumber] = $this->_readOnlyAddColumn($species,$columnName,$rowNumber,$columnSize);
                       $checkTabA[$columnNumber] = "no";
                     }
                     elseif($columnName == 'olddbh')
                     {
                       $dbh = $oldExtractRow->DBH;
                       $columnListA[$columnNumber] = $this->_readOnlyAddColumn($dbh,$columnName,$rowNumber,$columnSize);
                       $checkTabA[$columnNumber] = "no";
                     }
                     elseif($columnName == 'oldcodes')
                     {
                       $code = $oldExtractRow->ListOfTSM;
                       $columnListA[$columnNumber] = $this->_readOnlyAddColumn($code,$columnName,$rowNumber,$columnSize);
                       $checkTabA[$columnNumber] = "no";
                     }
                     elseif($columnName == 'oldhom')
                     {
                       $hom = $oldExtractRow->HOM;
                       $columnListA[$columnNumber] = $this->_readOnlyAddColumn($hom,$columnName,$rowNumber,$columnSize);
                       $checkTabA[$columnNumber] = "no";
                     }
                     elseif($columnName == 'x')
                     {
                       $qx = $oldExtractRow->QX;
                       $columnListA[$columnNumber] = $this->_readOnlyAddColumn($qx,$columnName,$rowNumber,$columnSize);
                       $checkTabA[$columnNumber] = "no";
                     }
                     elseif($columnName == 'y')
                     {
                       $qy = $oldExtractRow->QY;
                       $columnListA[$columnNumber] = $this->_readOnlyAddColumn($qy,$columnName,$rowNumber,$columnSize);
                       $checkTabA[$columnNumber] = "no";
                     }
                     else{
                       $column = $oldExtractRow->$columnName;
                       $columnListA[$columnNumber] = $this->_readOnlyAddColumn($column,$columnName,$rowNumber,$columnSize);
                       $checkTabA[$columnNumber] = "no";
                     }
                   }
                   elseif($formDetailRow->ColumnType == 'text')
                   {
                     $attributes = $formDetailRow->Attributes;
                     $columnNumber = $formDetailRow->ColumnNumber;
                     $columnDetailA = $this->_textAttributes($attributes);
                     $columnName = $columnDetailA['columnName'];
                     $columnNameA[$columnNumber] = $columnName;
                     $headerListA[$columnNumber] = $columnDetailA['columnHeader'];
                     $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                     $columnListA[$formDetailRow->ColumnNumber] = $this->_addColumnRow($columnDetailA,$rowNumber);
                     $checkTabA[$columnNumber] = "yes";
                   }
                   elseif($formDetailRow->ColumnType == "limit")
                   {
                     $attributes = $formDetailRow->Attributes;
                     $columnNumber = $formDetailRow->ColumnNumber;
                     $columnDetailA = $this->_limitAttributes($attributes);
                     $columnName = $columnDetailA['columnName'];
                     $columnNameA[$columnNumber] = $columnName;
                     $headerListA[$columnNumber] = $columnDetailA['columnHeader'];
                     $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                     $columnListA[$formDetailRow->ColumnNumber] = $this->_addColumnRow($columnDetailA,$rowNumber);
                     $checkTabA[$columnNumber] = "yes";
                   }
                 }
                 $stemID = $oldExtractRow->StemID;
                 $stemColumnName = 'stemID_'.$rowNumber;
                 $stemColumnNumber = $columnNumber + 1;
                 $columnListA[$stemColumnNumber] = form_hidden($stemColumnName,$stemID);
                 //$checkTabA[] = "no";
              /*}
              else
              {
                echo "Add Columns First!!";
                die();
              }*/
              $this->table->add_row($columnListA);
              $rowNumber++;
            }
            $this->table->set_heading($headerListA);
            $data['table2'] = $this->table->generate();

            /////////////Table 1 - Top Panel///////////////////////
            $this->load->model('formmodel');

            $quadratA = $this->formmodel->getQuadratNames($plotID);
            $quadratDD = form_dropdown('quadrat',$quadratA,$quadratName);

            $quadratNameHD = form_hidden('quadratName',$quadratName);

            $personnelA = $this->formmodel->getPersonnelNames();
            $collectedDD = form_dropdown('collected[]',$personnelA);
            $checkedDD = form_dropdown('checked[]',$personnelA);
            $enteredDD = form_dropdown('entered[]',$personnelA);
            $getFormOpen = form_open("oldplantform/createform");

            ///Hidden///
            $num_collected_Hidden = '<input type="hidden" id="num_collected" name="num_collected" value="1" />';
            $num_checked_Hidden = '<input type="hidden" id="num_checked" name="num_checked"  value="1" />';
            $num_entered_Hidden = '<input type="hidden" id="num_entered" name="num_entered" value="1" />';
            $row_count = '<input type="hidden" id="row_count" name="row_count" value="'.$rowNumber.'" />';

            //Hidden Session Values - Added this because on server for some reason the session is getting lost at random. This will help to atleast save the data from getting lost.
            $databaseName = $this->session->userdata('databaseName');

            $databaseName_Hidden =  '<input type="hidden" id="databaseName" name="databaseName" value="'.$databaseName.'" />';
            $plotName_Hidden = '<input type="hidden" id="plotName" name="plotName" value="'.$plotID.'" />';
            $censusNumber_Hidden = '<input type="hidden" id="censusNumber" name="censusNumber" value="'.$censusNumber.'" />';
            $plotActualName_Hidden = '<input type="hidden" id="plotActualName" name="plotActualName" value="'.$plotActualName.'" />';
            $selectedPlotName_Hidden =  '<input type="hidden" id="selectedPlotName" name="selectedPlotName" value="'.$selectedPlotName.'" />';

            $hiddenValues = $num_collected_Hidden.$num_checked_Hidden.$num_entered_Hidden.$row_count.$quadratNameHD.$databaseName_Hidden.$plotName_Hidden.$censusNumber_Hidden.$plotActualName_Hidden.$selectedPlotName_Hidden;
            ///////////


            $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit','onclick'=>"return confirm('Are you sure data for this quadrat is complete?')");

            $this->load->library('formlibrary');
            $formOpen = form_open("oldplantfile");
            $data['table1'] = $this->formlibrary->addTopPanel2($plotID,$quadratDD,$collectedDD,$checkedDD,$enteredDD,$getFormOpen,$formOpen);
            //$data['table1'] = $this->formlibrary->addTopPanel($plotID,$quadratDD,$collectedDD,$checkedDD,$enteredDD);
            /////////////////////////////////////////////////////////
            if($includeDead == 'Yes') {
               $includeDeadTitle =  '<span style="color:#FF0000; font-size:14px">(Include Dead: '.$includeDead.')</span>';
            }
            else {
               $includeDeadTitle =  '<span style="font-size:14px">(Include Dead: '.$includeDead.')</span>';
            }


            $data['title'] = "Data Entry";
            $data['contentTitle'] = "Old Plant Form ".$includeDeadTitle;
            $data['formHeading'] = "";
            $data['formOpen'] = ''; //formOpen for main form echo in addTopPanel2 because this form open get echo before the getFormOpen
            $data['backLink'] = anchor('oldplantform','Back',array('class'=>'back'));
            $data['checkTabJS'] = $this->_createCheckTab($columnNameA,$checkTabA); //CheckTab Javascript
            //$data['insertRowJS'] = $this->_insertRow($formDetailResult);
            //$data['checkTabJS'] = "";
            $data['insertRowJS'] = "";
            $data['submitButton'] = '<p style="text-align:center;">'.form_button($submitButtonA).'</p>';
            $data['hiddenValues'] = $hiddenValues;
            $this->load->view('treeforms/simpleform',$data);
            ///////////
          }
          else
          {  $quadratA = $this->formmodel->getQuadratNames($plotID);
             $quadratDD = form_dropdown('quadrat',$quadratA,$quadratName);
             $submitButtonA = array('name'=>'getform','id'=>'button','type'=>'submit','content'=>'Submit');
             $submitButton = form_button($submitButtonA);

             $quadTableA = array(array(''),
                           array('Quadrat Name: ',$quadratDD,'&nbsp;&nbsp;&nbsp;',$submitButton)
                          );
             $this->table->set_empty("");
             $quadTable = $this->table->generate($quadTableA);


             $data['formTable'] = '<br /><br /><div class="error">Unable to extract old data for Quadrat: '.$quadratName.'.</div><br /><h5>Select another quadrat</h5><br />'.$quadTable;
             $data['formOpen'] = form_open("oldplantform/createform");
             $data['backLink'] = '';
             $plotCensusArray = $this->session->userdata('plotCensusArray');
             $plotName = $plotCensusArray['plotName'];
             $censusNumber = $plotCensusArray['censusNumber'];
             $plotActualName = $plotCensusArray['plotActualName'];
             $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
             $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
             $this->load->view('user/dataentry/simpleform',$data);
          }
        }
    }
  }


  function _sortOldFormData($attributes)
  {
    $attributesList = explode("\t",$attributes);
    $attributesArray['columnHeader'] = $attributesList[0];
    $attributesArray['columnName'] = $attributesList[1];
    $attributesArray['columnSize'] = $attributesList[2];
    if($attributesArray['columnName'] == 'subquadrat')
    {
      $attributesArray['startsWith'] = $attributesList[3];
      $attributesArray['maxX'] = $attributesList[4];
      $attributesArray['maxY'] = $attributesList[5];
    }
    elseif($attributesArray['columnName'] == 'nosubTag')
    {
      $attributesArray['maxX'] = $attributesList[3];
      $attributesArray['maxY'] = $attributesList[4];
    }
    elseif($attributesArray['columnName'] == 'stemTag')
    {
      $attributesArray['readOnly'] = $attributesList[3];
    }
    return $attributesArray;
  }

  function _readOnlyAddColumn($value,$columnName,$rowNumber,$columnSize)
  {
    $columnName = $columnName."_".$rowNumber;
    $onKeyStroke = 'return checkTab(event,this);';

    $dataA = array('id'=>$columnName,'name'=>$columnName,'value'=>$value,'size'=>$columnSize,'readonly'=>'readonly','style'=>'background:#CCCCCC; border:0; text-align: center;');
    $columnTbx = form_input($dataA);
    return $columnTbx;
  }

  function _notReadOnlyAddColumn($value,$columnName,$rowNumber,$columnSize)
  {
    $columnName = $columnName."_".$rowNumber;
    $onKeyStroke = 'return checkTab(event,this);';

    if($value == "")
    {
      $dataA = array('id'=>$columnName,'name'=>$columnName,'value'=>$value,'size'=>$columnSize,'onkeypress'=>$onKeyStroke, 'style'=>'text-align: center;');
    }
    else
    {
      $dataA = array('id'=>$columnName,'name'=>$columnName,'value'=>$value,'size'=>$columnSize,'readonly'=>'readonly','style'=>'background:#CCCCCC; border:0; text-align: center;');
    }
    $columnTbx = form_input($dataA);
    return $columnTbx;
  }

  function _textAttributes($attributes)
  {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['defaultValue'] = $attributeA[3];
    $array['columnSize'] = $attributeA[4];
    $array['allowNull'] = $attributeA[5];

    return $array;
  }

  function _limitAttributes($attributes)
  {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['upperLimit'] = $attributeA[3];
    $array['lowerLimit'] = $attributeA[4];
    $array['defaultValue'] = $attributeA[5];
    $array['columnSize'] = $attributeA[6];
    $array['allowNull'] = $attributeA[7];

    return $array;
  }

  function _addColumnRow($columnDetailA,$rowNumber)
  {
    if($columnDetailA['columnType'] == 'text')
    {
      $columnName =$columnDetailA['columnName']."_".$rowNumber;
      $columnSize = $columnDetailA['columnSize'];
      $defaultValue = $columnDetailA['defaultValue'];
      if($columnDetailA['allowNull'] == 'no')
      {
        $onBlur = 'validateNotEmpty(this)';
      }
      else
      {
        $onBlur = "";
      }
      $onKeyStroke = 'return checkTab(event,this);';


      $dataA = array('id'=>$columnName,'name'=>$columnName,'size'=>$columnSize,'value'=>$defaultValue,'onblur'=>$onBlur,'onkeypress'=>$onKeyStroke);
      $columnTbx = form_input($dataA);
      return $columnTbx;
    }
    elseif($columnDetailA['columnType'] == 'limit')
    {
      $columnName =$columnDetailA['columnName']."_".$rowNumber;
      $columnSize = $columnDetailA['columnSize'];
      $defaultValue = $columnDetailA['defaultValue'];
      $lowerLimit = $columnDetailA['lowerLimit'];
      $upperLimit = $columnDetailA['upperLimit'];
      if($columnDetailA['allowNull'] == 'no')
      {
        $onBlur = 'validateLimitNotEmpty(this,'.$lowerLimit.','.$upperLimit.')';
      }
      else
      {
        $onBlur = 'validateLimit(this,'.$lowerLimit.','.$upperLimit.')';
      }
      $onKeyStroke = 'return checkTab(event,this);';

      $dataA = array('id'=>$columnName,'name'=>$columnName,'size'=>$columnSize,'value'=>$defaultValue,'onblur'=>$onBlur,'onkeypress'=>$onKeyStroke);
      $columnTbx = form_input($dataA).'<br />';
      return $columnTbx;
    }
  }

//////////////////CheckTab JS/////////////////////////////
  function _createCheckTab($columnNameA,$checkTabA)
  {
    $checkTabAsc = $this->_checkTabAsc($columnNameA,$checkTabA);
    $checkTabDesc = $this->_checkTabDesc($columnNameA,$checkTabA);
    $checkTabJS = '<script type="text/javascript">
                    function checkTab(e, obj) {
                   	var keynum;
                	var keychar;
                	var next;

                	if(window.event) // IE
                  	{
                  		keynum = e.keyCode;
                  	}
                	else if(e.which) // Netscape/Firefox/Opera
                  	{
                 		 keynum = e.which;
                  	}

                   if (keynum == 42) {
                        var id_arr = obj.id.split("_");'
                        .$checkTabAsc.
                        'return false;
                    } else if (keynum == 47) {
                        var id_arr = obj.id.split("_");'
                        .$checkTabDesc.
                        'return false;
                    } else if (keynum == 13) {
                        return false;
                    } else {
                		return true;
                	}
                }
                </script>';
    return $checkTabJS;
  }

  function _checkTabAsc($columnNameA,$checkTabA)
  {
    $checkTabAsc = "";
    $arrayCount = count($columnNameA);
    $a = "";
    $b = "";

    for($i=1;$i <=$arrayCount;$i++)
    {
      if($checkTabA[$i] == 'yes')
      {
        $firstColumn = $columnNameA[$i];
        $a = $i;
        break;
      }
    }
    for($i=1;$i <=$arrayCount;$i++)
    {
      if($checkTabA[$i] == 'yes')
      {
        $lastColumn = $columnNameA[$i];
        $b = $i;
      }
    }

    for($i=1;$i <=$arrayCount;$i++)
    {
     if($checkTabA[$i] == 'yes')
     {
       $columnName1 = $columnNameA[$i];
       for($j=$i+1;$j<=$arrayCount;$j++)
       {
         if($checkTabA[$j] == 'yes')
         {
           $columnName2 = $columnNameA[$j];
           break;
         }
       }
       //$columnName1 = $columnNameA[$i];
       //$columnName2 = $columnNameA[$i+1];
       if($i == $a)
       {
         $checkTabAsc = $checkTabAsc.'if (id_arr[0] == "'.$columnName1.'")
                                  {
                                  document.getElementById("'.$columnName2.'_"+id_arr[1] ).focus();
                                  }';
       }
       elseif($i == $b)
       {
         $checkTabAsc = $checkTabAsc.'else if (id_arr[0] == "'.$columnName1.'")
                                  {
                                   var nextRow = parseInt(id_arr[1]) + 1;
                                   document.getElementById("'.$firstColumn.'_"+nextRow).focus();
                                  }';
       }
       else
       {
          $checkTabAsc = $checkTabAsc.'else if (id_arr[0] == "'.$columnName1.'")
                                  {
                                   document.getElementById("'.$columnName2.'_"+id_arr[1] ).focus();
                                  }';
       }
      }
    }
    return $checkTabAsc;
  }

  function _checkTabDesc($columnNameA,$checkTabA)
  {
    $checkTabDesc = "";
    $arrayCount = count($columnNameA);
    $a = "";
    $b = "";
    for($i=1;$i <=$arrayCount;$i++)
    {
      if($checkTabA[$i] == 'yes')
      {
        $firstColumn = $columnNameA[$i];
        $a = $i;
        break;
      }
    }
    for($i=1;$i <=$arrayCount;$i++)
    {
      if($checkTabA[$i] == 'yes')
      {
        $lastColumn = $columnNameA[$i];
        $b = $i;
      }
    }
    for($i=$arrayCount;$i >= 1;$i--)
    {
     if($checkTabA[$i] == 'yes')
     {
       $columnName1 = $columnNameA[$i];
       for($j=$i-1;$j >= 1;$j--)
       {
         if($checkTabA[$j] == 'yes')
         {
           $columnName2 = $columnNameA[$j];
           break;
         }
       }
       //$columnName1 = $columnNameA[$i];
       //$columnName2 = $columnNameA[$i-1];
       if($i == $b)
       {
        $checkTabDesc = $checkTabDesc.'if (id_arr[0] == "'.$columnName1.'")
                                {
                                 document.getElementById("'.$columnName2.'_"+id_arr[1] ).focus();
                                }';
       }
       elseif($i == $a)
       {
         $checkTabDesc = $checkTabDesc.'else if (id_arr[0] == "'.$firstColumn.'")
                                {
                                 var prevRow = parseInt(id_arr[1]) - 1;
                                 document.getElementById("'.$lastColumn.'_"+prevRow ).focus();
                                }';
       }
       else
       {
         $checkTabDesc = $checkTabDesc.'else if (id_arr[0] == "'.$columnName1.'")
                                {
                                 document.getElementById("'.$columnName2.'_"+id_arr[1] ).focus();
                                }';
       }
      }
    }
    return $checkTabDesc;
  }
/////////////////////////////////////////////////////////////////////



}
