<?php

class User extends Controller{

    function User()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->library(array('table','pagination'));
      global $databaseVersion;
      $databaseVersion = $this->session->userdata('databaseVersion');
      if($databaseVersion == 'new')
      {
        $this->load->model('usermodel_new','usermodel');

      }
      elseif($databaseVersion == 'old')
      {
        $this->load->model('usermodel','usermodel');
      }
      global $databaseName;
      $databaseName = $this->session->userdata('databaseName');
    }

    //Index Start
    function index()
    {
       $this->load->library('updatelibrary');
       $updateAvailable = $this->updatelibrary->checkUpdate1();
       if($updateAvailable == 'YES')
       {
         $updataMessage = '<span class="blink" style="font-size:10pt; color:#FF0000;">&nbsp;&nbsp;&nbsp;(An Update Is Available)</span>';
       }
       else
       {
         $updataMessage = '';
       }
       $data1 = array('title'=>'CTFS/ForestGEO Forest Plot Census Data',
                        'contentTitle'=> 'Welcome to CTFS DataEntry and Reporting System'.$updataMessage,
                        'detail1'=>'<p>This is the main page of the website. Choose an option from Menu.<p>');

       $this->load->view('user/mainview', $data1);
    }
    // Index end

    function personnel($offset = 0)
    {
   /*   $this->_personnelTable($offset);
    }

    function _personnelTable($offset)
      {*/
        //$offset = 0;
        global $databaseName;
        if($this->session->userdata($databaseName.'personnelID'))
        {
          $this->session->unset_userdata($databaseName.'personnelID');
        }
        $limit = 30;

        $personnelData['limit'] = $limit;
        $personnelData['offset'] = $offset;

        //get personnel information from personnel table
        $personnelReturnData = $this->usermodel->getPersonnelInfo($personnelData);

        $personnelQuery = $personnelReturnData['query'];
        $count_all = $personnelReturnData['count_all'];

        if($count_all > 0)
        {
          // offset
    		$uri_segment = 3;
    		$offset = $this->uri->segment($uri_segment);

          //Load Data
          $personnelResult = $personnelQuery->result();

    		// generate pagination
    		$config['base_url'] = site_url('user/personnel');
     		$config['total_rows'] = $count_all;
     		$config['per_page'] = $limit;
    		$config['uri_segment'] = $uri_segment;
    		$this->pagination->initialize($config);
    		$dataTable['pagination'] = $this->pagination->create_links();

           // generate table data
        		$this->table->set_empty("");
        		$this->table->set_heading('No.', 'Personnel', 'Role');
        		$i = 0 + $offset;
        		foreach ($personnelResult as $personnelRow){
        		    $personnelID = $personnelRow->PersonnelID;
                  $roles = $this->usermodel->getRoles($personnelID);
     ///////////////////Temporary Fix - Remove Later///////////////////////
                  if($personnelRow->FirstName == 'Raymond' && $personnelRow->LastName == 'Johnson')
                  {
                    $roles = "HSBC Climate Champion";
                  }
     //////////////////////////////////////////////////////////////////////
        			$this->table->add_row(++$i, anchor('user/personneldetail/'.$personnelID,'<b>'.$personnelRow->FirstName.' '.$personnelRow->LastName.'</b>'), $roles);
        		}
        	 $dataTable['table'] = $this->table->generate();

           $dataTable['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
           $img_prop = array('src'=>'images/HSBCClimateSmall.png','align'=>'right');
           $dataTable['contentTitle'] ='Personnel'.img($img_prop);
           $dataTable['backLink'] = anchor('/user', 'Back', array('title'=>'Back to Main Page', 'class'=>'back'));
         }
         else
         {
           $dataTable['pagination'] = "<br /><br /> ";
           $dataTable['table'] = "<h2>No Personnel Data Is Yet Available For This Plot.</h2>";
           $dataTable['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
           $img_prop = array('src'=>'images/HSBCClimateSmall.png','align'=>'right');
           $dataTable['contentTitle'] ='Personnel'.img($img_prop);
         }
        // load view
  		$this->load->view('user/personnel', $dataTable);
      }

      function personneldetail($personnelID)
      {
        global $databaseName;
        $personName = $this->usermodel->getPersonName($personnelID);
        $personRole = $this->usermodel->getRoles($personnelID);

        ///////////////////Temporary Fix - Remove Later///////////////////////
                  if($personName == 'Raymond Johnson')
                  {
                    $personRole = "HSBC Climate Champion";
                  }
     //////////////////////////////////////////////////////////////////////

        $quadratCount = $this->usermodel->getQuadratCount($personnelID);
        $hectares = $this->usermodel->getNoOfHectares($personnelID);

        $treeQuery = $this->usermodel->treeMeasured($personnelID);
        $treeCount = $treeQuery->num_rows();

        $totalBiomass = 0;
        $this->load->model('agbmodel');
        if($treeCount !== 0)
        {
          foreach($treeQuery->result() as $treeRow)
          {
            $data['treeID'] = $treeRow->TreeID;
            $data['censusID'] = $treeRow->CensusID;
            $biomass = $this->agbmodel->getTreeCensusBiomass($data);
            $totalBiomass = $totalBiomass + $biomass;
          }
          $totalBiomass = round($totalBiomass,2);
        }

        //$stemQuery = $this->usermodel->stemMeasured($personnelID);
        //$stemCount = $stemQuery->num_rows();

        $speciesQuery = $this->usermodel->speciesMeasured($personnelID);
        $speciesCount = $speciesQuery->num_rows();

        $startDate = $this->usermodel->getStartDate($personnelID);
        $endDate = $this->usermodel->getEndDate($personnelID);

        if($startDate !== NULL and $endDate !== NULL)
        {
          list($year,$month,$date) = explode('-',$startDate);
          $startDate = $month.'/'.$date.'/'.$year;
          $endDate = $this->usermodel->getEndDate($personnelID);
          list($year,$month,$date) = explode('-',$endDate);
          $endDate = $month.'/'.$date.'/'.$year;
          $date = $startDate.' to '.$endDate;
        }
        else
        {
          $date = 'Not Available';
        }

          if(!$this->session->userdata($databaseName.'totalPlotValues'))
          {
          $totalPlotTrees = $this->usermodel->totalPlotTrees();
          //$totalPlotStems = $this->usermodel->totalPlotStems();
          $totalPlotQuadrat = $this->usermodel->plotQuadratCount();
          $totalPlotHectare = $this->usermodel->plotNoOfHectares();
          $totalPlotHectare = round($totalPlotHectare);
          $totalPlotSpecies = $this->usermodel->totalPlotSpecies();

          $this->load->model('agbmodel');
          $totalPlotBiomass = $this->agbmodel->totalPlotBiomass();
          $totalPlotBiomass = round($totalPlotBiomass,2);

          $totalPlotValues['totalPlotTrees'] = $totalPlotTrees;
          //$totalPlotValues['totalPlotStems'] = $totalPlotStems;
          $totalPlotValues['totalPlotQuadrat'] = $totalPlotQuadrat;
          $totalPlotValues['totalPlotHectare'] = $totalPlotHectare;
          $totalPlotValues['totalPlotSpecies'] = $totalPlotSpecies;
          $totalPlotValues['totalPlotBiomass'] = $totalPlotBiomass;

          $this->session->set_userdata($databaseName.'totalPlotValues',$totalPlotValues);
        }
        else
        {
          $totalPlotValues = $this->session->userdata($databaseName.'totalPlotValues');
          $totalPlotTrees = $totalPlotValues['totalPlotTrees'];
          $totalPlotQuadrat = $totalPlotValues['totalPlotQuadrat'];
          $totalPlotHectare = $totalPlotValues['totalPlotHectare'];
          //$totalPlotStems = $totalPlotValues['totalPlotStems'];
          $totalPlotSpecies = $totalPlotValues['totalPlotSpecies'];
          $totalPlotBiomass = $totalPlotValues['totalPlotBiomass'];
        }


        $tableA = array(array('',''),
                            //array('<b>Personnel : </b>', $personName),
                            array('<b>Role : </b>',$personRole),
                            array('<b>Work Period : </b>',$date),
                            array('<b>Total Hectares : </b>',$hectares,'&nbsp;&nbsp;&nbsp;','<b>Total No. Of Hectares Censused : </b>',$totalPlotHectare),
                            array('<b>No. Of Quadrats Worked On : </b>',$quadratCount,'&nbsp;&nbsp;&nbsp;','<b>Total No. Of Quadrats Censused : </b>',$totalPlotQuadrat),
                            //array('<b>Total No. Of Trees : </b>',$treeCount),
                            //array('<b>Total No. Of Stems : </b>',$stemCount),
                            //array('<b>Total No. Of Species : </b>',$speciesCount),
                            array('<b>Total No. Of Trees : </b>',$treeCount,'&nbsp;&nbsp;&nbsp;','<b>Total No. Of Trees Censused : </b>',$totalPlotTrees),
                            //array('<b>Total No. Of Stems : </b>',$stemCount,'&nbsp;&nbsp;&nbsp;','<b>Total No. Of Stems On Plot : </b>',$totalPlotStems),
                            array('<b>Total No. Of Species : </b>',$speciesCount,'&nbsp;&nbsp;&nbsp;','<b>Total No. Of Species Censused : </b>',$totalPlotSpecies),
                            array('<b>Total Biomass (Mg) : </b>',$totalBiomass,'&nbsp;&nbsp;&nbsp;','<b>Total Biomass Censused (Mg) : </b>',$totalPlotBiomass),
//                            array('<b></b>',$),
//                            array('<b></b>',$)
                            );
        $this->table->set_empty("");
        $dataTable['tablePersonnel'] = $this->table->generate($tableA);

        $this->table->clear();

        $dataTable['legend1'] = 'Personnel';
        $dataTable['linkSet1'] = anchor('user/quadratset/'.$personnelID,'Quadrat Details',array('class'=>'quadrat')).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.
                                 anchor('user/treeset/'.$personnelID,'Tree Details',array('class'=>'tree')).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.
                                 anchor('maps/personnelmap/'.$personnelID,'View Map',array('class'=>'map'));
        $dataTable['linkSet2'] = anchor('charts/speciesgraph/','Compare this Plot to other CTFS Plots',array('class'=>'graph', 'target'=>"_blank")).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.
                                 anchor('sitemap/map/','View on World Map',array('class'=>'earth', 'target'=>"_blank"));



        $dataTable['legend2'] = 'Census Based Info';
        $censusQuery = $this->usermodel->censusList($personnelID);
        if($censusQuery->num_rows > 0)
        {
        $censusResult = $censusQuery->result();
        $this->table->set_empty("");
      		$this->table->set_heading('No.', 'PlotCensusNumber', 'StartDate', 'EndDate');
            $i = 0;
      		foreach ($censusResult as $censusRow){
      		    $censusID = $censusRow->CensusID;
      			$this->table->add_row(++$i, anchor('user/censusdetails/'.$personnelID.'S'.$censusID,'<u><b>'.$censusRow->PlotCensusNumber.'</b></u>'),$censusRow->StartDate,$censusRow->EndDate);
      		}
      	 $dataTable['tableCensus'] = $this->table->generate();
        }
        else
        {
      	 $dataTable['tableCensus'] = 'No Census Information.';
        }



        $dataTable['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $img_prop = array('src'=>'images/HSBCClimateSmall.png','align'=>'right');
        $dataTable['contentTitle'] = $personName."'s Contribution".img($img_prop);
        $dataTable['backLink'] = anchor('/user/personnel', 'Back', array('title'=>'Back to Personnel List', 'class'=>'back'));
        // load view
  		$this->load->view('user/personneldetail', $dataTable);
      }

      function quadratset($personnelID)
      {
        global $databaseName;
        if($this->session->userdata($databaseName.'personnelID'))
        {
          $this->session->unset_userdata($databaseName.'personnelID');
        }
        $this->quadrat($personnelID);
        redirect('user/quadrat/','location');

      }

      function quadrat($infoPass=0)
      {
        global $databaseName;
        if($this->session->userdata($databaseName.'personnelID'))
        {
          $personnelID = $this->session->userdata($databaseName.'personnelID');
          $offset = $infoPass;
        }
        else
        {
          $personnelID = $infoPass;
          $this->session->set_userdata($databaseName.'personnelID',$personnelID);
          $offset = 0;
        }

        $limit = 30;

        $quadratData['limit'] = $limit;
        $quadratData['offset'] = $offset;
        $quadratData['personnelID'] = $personnelID;

        //Get QuadratID, CensusID and PlotID for particular Personnel ID from DataCollection
        $quadratQuery = $this->usermodel->getQuadratData($quadratData);
        $count_all = $this->usermodel->getQuadratCount($personnelID);

        // offset
  		$uri_segment = 3;
  		//$offset = $this->uri->segment($uri_segment);

        //Load Data
        $quadratResult = $quadratQuery->result();

  		// generate pagination
  		$config['base_url'] = site_url('user/quadrat');
   		$config['total_rows'] = $count_all;
   		$config['per_page'] = $limit;
  		$config['uri_segment'] = $uri_segment;
  		$this->pagination->initialize($config);
  		$dataTable['pagination'] = $this->pagination->create_links();

        if($count_all !== 0)
        {
         // generate table data
      		$this->table->set_empty("&nbsp");
      		$this->table->set_heading('No.', 'PlotName', 'QuadratName','Trees','Biomass','Species','StartDate','EndDate','Action');
      		$i = 0 + $offset;
          foreach($quadratResult as $quadratRow)
          {
            $countData['personnelID'] = $personnelID;
            $countData['quadratID'] = $quadratRow->QuadratID;
            $quadratName = $quadratRow->QuadratName;
            $treeQuery = $this->usermodel->quadratTreeMeasured($countData);
            $treeCount = $treeQuery->num_rows();
            $speciesQuery = $this->usermodel->quadratSpeciesMeasured($countData);
            $speciesCount = $speciesQuery->num_rows();

            $totalBiomass = 0;
            $this->load->model('agbmodel');
            if($treeCount !== 0)
            {
              foreach($treeQuery->result() as $treeRow)
              {
                $data['treeID'] = $treeRow->TreeID;
                $data['censusID'] = $treeRow->CensusID;
                $biomass = $this->agbmodel->getTreeCensusBiomass($data);
                $totalBiomass = $totalBiomass + $biomass;
              }
            }
            $this->table->add_row(++$i, $quadratRow->PlotName,$quadratRow->QuadratName,$treeCount,$totalBiomass,$speciesCount,$quadratRow->StartDate,$quadratRow->EndDate,anchor('/maps/quadratmap/'.$personnelID.'/'.$quadratName, '<b>View&nbsp;Map</b>', array('title'=>'View Map for this Quadrat')));
      	  }
          $dataTable['table'] = $this->table->generate();
        }
        else
        {
        $dataTable['table'] = 'No Quadrat Information for this Personnel.';
        }


         $dataTable['personName'] = $this->usermodel->getPersonName($personnelID)."'s Contribution";


         $dataTable['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
         $dataTable['contentTitle'] ='Quadrat Information';
         $dataTable['backLink'] = anchor('/user/personneldetail/'.$personnelID, 'Back', array('title'=>'Back to Personnel Detail', 'class'=>'back'));
        // load view
  		$this->load->view('user/quadrat', $dataTable);
      }


      function treeset($personnelID)
      {
        global $databaseName;
        if($this->session->userdata($databaseName.'personnelID'))
        {
          $this->session->unset_userdata($databaseName.'personnelID');
        }
        $this->tree($personnelID);
        redirect('user/tree/','location');
      }

      function tree($infoPass=0)
      {
        global $databaseName;
        if($this->session->userdata($databaseName.'personnelID'))
        {
          $personnelID = $this->session->userdata($databaseName.'personnelID');
          $offset = $infoPass;
        }
        else
        {
          $personnelID = $infoPass;
          $this->session->set_userdata($databaseName.'personnelID',$personnelID);
          $offset = 0;
        }

        $limit = 30;

        $treeData['limit'] = $limit;
        $treeData['offset'] = $offset;
        $treeData['personnelID'] = $personnelID;

        //Get QuadratID, CensusID and PlotID for particular Personnel ID from DataCollection
        $treeQuery = $this->usermodel->getTreeData($treeData);
        $count_all = $this->usermodel->getTreeCount($personnelID);

        // offset
  		$uri_segment = 3;
  		//$offset = $this->uri->segment($uri_segment);

        //Load Data
        $treeResult = $treeQuery->result();

  		// generate pagination
  		$config['base_url'] = site_url('user/tree');
   		$config['total_rows'] = $count_all;
   		$config['per_page'] = $limit;
  		$config['uri_segment'] = $uri_segment;
  		$this->pagination->initialize($config);
  		$dataTable['pagination'] = $this->pagination->create_links();

        if($count_all !== 0)
        {
         // generate table data
      		$this->table->set_empty("&nbsp");
      		$this->table->set_heading('No.', 'Tree Tag', 'Stem Tag', 'DBH', 'Genus Species', 'Census', 'Status');
      		$i = 0 + $offset;
          foreach($treeResult as $treeRow)
          {
             $treeID = $treeRow->TreeID;
             $stemID = $treeRow->StemID;
             $censusID = $treeRow->CensusID;

             $this->table->add_row(++$i, $treeRow->Tag,$treeRow->StemTag, $treeRow->DBH, $treeRow->GenusSpecies,$treeRow->PlotCensusNumber,$treeRow->Status);
      	  }
          $dataTable['table'] = $this->table->generate();
        }
        else
        {
        $dataTable['table'] = 'No Tree Information for this Personnel.';
        }


         $dataTable['personName'] = $this->usermodel->getPersonName($personnelID)."'s Contribution";

         $dataTable['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
         $dataTable['contentTitle'] ='Tree Information';
         $dataTable['backLink'] = anchor('/user/personneldetail/'.$personnelID, 'Back', array('title'=>'Back to Personnel Detail', 'class'=>'back'));
        // load view
  		$this->load->view('user/tree', $dataTable);
      }

      function censusdetails($passedIDs)
      {
        $passedIDsExplode = explode('S',$passedIDs);
        $personnelID = $passedIDsExplode[0];
        $censusID = $passedIDsExplode[1];

        $censusData['personnelID'] = $personnelID;
        $censusData['censusID'] = $censusID;

        $personName = $this->usermodel->getPersonName($personnelID);
        $personRole = $this->usermodel->getRoles($personnelID);

        $censusInfo = $this->usermodel->getCensusInfo($censusID);
        $plotCensusNumber = $censusInfo['plotCensusNumber'];
        $startDate = $censusInfo['startDate'];
        $endDate = $censusInfo['endDate'];

        if($startDate !== NULL and $endDate !== NULL)
        {
          list($year,$month,$date) = explode('-',$startDate);
          $startDate = $month.'/'.$date.'/'.$year;
          $endDate = $this->usermodel->getEndDate($personnelID);
          list($year,$month,$date) = explode('-',$endDate);
          $endDate = $month.'/'.$date.'/'.$year;
          $date = $startDate.' to '.$endDate;
        }
        else
        {
          $date = 'Not Available';
        }

        $quadratCount = $this->usermodel->getCensusQuadratCount($censusData);
        $hectares = $this->usermodel->getCensusNoOfHectares($censusData);

        $treeQuery = $this->usermodel->censusTreeMeasured($censusData);
        $treeCount = $treeQuery->num_rows();

        $totalBiomass = 0;
        $this->load->model('agbmodel');
        if($treeCount !== 0)
        {
          foreach($treeQuery->result() as $treeRow)
          {
            $data['treeID'] = $treeRow->TreeID;
            $data['censusID'] = $censusID;
            $biomass = $this->agbmodel->getTreeCensusBiomass($data);
            $totalBiomass = $totalBiomass + $biomass;
          }
          $totalBiomass = round($totalBiomass,2);
        }

        //$stemQuery = $this->usermodel->censusStemMeasured($censusData);
        //$stemCount = $stemQuery->num_rows();

        $speciesQuery = $this->usermodel->censusSpeciesMeasured($censusData);
        $speciesCount = $speciesQuery->num_rows();

        $tableA = array(array('',''),
                            //array('<b>Personnel : </b>', $personName),
                            array('<b>Role : </b>',$personRole),
                            array('<b>PlotCensusNumber',$plotCensusNumber),
                            array('<b>Census Period : </b>',$date),
                            array('<b>Total Hectares : </b>',$hectares),
                            array('<b>No. Of Quadrats Worked On : </b>',$quadratCount),
                            array('<b>Total No. Of Trees : </b>',$treeCount),
                            //array('<b>Total No. Of Stems : </b>',$stemCount),
                            array('<b>Total No. Of Species : </b>',$speciesCount),
                            array('<b>Total Biomass (Mg) : </b>',$totalBiomass)
                            );
        $this->table->set_empty("");
        $dataTable['tableCensus'] = $this->table->generate($tableA);

        $this->table->clear();

        $dataTable['legend1'] = 'Census Based Info';
        $dataTable['backLink'] = anchor('/user/personneldetail/'.$personnelID, 'Back', array('title'=>'Back to Personnel Detail', 'class'=>'back'));
        $dataTable['linkSet1'] = anchor('user/censusquadratset/'.$personnelID.'S'.$censusID,'Quadrat Details',array('class'=>'quadrat')).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.
                                 anchor('user/censustreeset/'.$personnelID.'S'.$censusID,'Tree Details',array('class'=>'tree')).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.
                                 anchor('maps/censuspersonnelmap/'.$personnelID.'/'.$censusID,'View Map',array('class'=>'map'));
        $dataTable['linkSet2'] = anchor('charts/speciesgraph/','Compare this Plot to other CTFS Plots',array('class'=>'graph', 'target'=>"_blank")).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.
                                 anchor('sitemap/map/','View on World Map',array('class'=>'earth', 'target'=>"_blank"));


        $dataTable['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
        $dataTable['contentTitle'] =$personName."'s Contribution - Census ".$plotCensusNumber;
        // load view
  		$this->load->view('user/censusdetail', $dataTable);


      }

      function censusquadratset($passedIDs)
      {
        global $databaseName;
        if($this->session->userdata($databaseName.'passedIDs'))
        {
          $this->session->unset_userdata($databaseName.'passedIDs');
        }
        $this->censusquadrat($passedIDs);
        redirect('user/censusquadrat/','location');
      }

      function censusquadrat($infoPass=0)
      {
        global $databaseName;
        if($this->session->userdata($databaseName.'passedIDs'))
        {
          $passedIDs = $this->session->userdata($databaseName.'passedIDs');
          $offset = $infoPass;
        }
        else
        {
          $passedIDs = $infoPass;
          $this->session->set_userdata($databaseName.'passedIDs',$passedIDs);
          $offset = 0;
        }

        $limit = 30;

        $quadratData['limit'] = $limit;
        $quadratData['offset'] = $offset;

        $passedIDsExplode = explode('S',$passedIDs);
        $personnelID = $passedIDsExplode[0];
        $censusID = $passedIDsExplode[1];

        $quadratData['personnelID'] = $personnelID;
        $quadratData['censusID'] = $censusID;

        //Get QuadratID, CensusID and PlotID for particular Personnel ID from DataCollection
        $quadratQuery = $this->usermodel->getCensusQuadratData($quadratData);
        $count_all = $this->usermodel->getCensusQuadratCount($quadratData);

        // offset
  		$uri_segment = 3;
  		//$offset = $this->uri->segment($uri_segment);

        //Load Data
        $quadratResult = $quadratQuery->result();

  		// generate pagination
  		$config['base_url'] = site_url('user/censusquadrat');
   		$config['total_rows'] = $count_all;
   		$config['per_page'] = $limit;
  		$config['uri_segment'] = $uri_segment;
  		$this->pagination->initialize($config);
  		$dataTable['pagination'] = $this->pagination->create_links();

        if($count_all !== 0)
        {
         // generate table data
      		$this->table->set_empty("&nbsp");
      		$this->table->set_heading('No.', 'PlotName', 'QuadratName','Trees','Biomass','Species','StartDate','EndDate','Action');
      		$i = 0 + $offset;
          foreach($quadratResult as $quadratRow)
          {
            $countData['personnelID'] = $personnelID;
            $countData['quadratID'] = $quadratRow->QuadratID;
            $countData['censusID'] = $censusID;
            $treeQuery = $this->usermodel->censusQuadratTreeMeasured($countData);
            $treeCount = $treeQuery->num_rows();
            $speciesQuery = $this->usermodel->censusQuadratSpeciesMeasured($countData);
            $speciesCount = $speciesQuery->num_rows();

            $totalBiomass = 0;
            $this->load->model('agbmodel');
            if($treeCount !== 0)
            {
              foreach($treeQuery->result() as $treeRow)
              {
                $data['treeID'] = $treeRow->TreeID;
                $data['censusID'] = $treeRow->CensusID;
                $biomass = $this->agbmodel->getTreeCensusBiomass($data);
                $totalBiomass = $totalBiomass + $biomass;
              }
            }
      	    $this->table->add_row(++$i, $quadratRow->PlotName,$quadratRow->QuadratName,$treeCount,$totalBiomass,$speciesCount,$quadratRow->StartDate,$quadratRow->EndDate,anchor('/maps/censusquadratmap/'.$personnelID.'/'.$quadratRow->QuadratName.'/'.$censusID, '<b>View&nbsp;Map</b>', array('title'=>'View Map for this Quadrat')));
      	  }
          $dataTable['table'] = $this->table->generate();
        }
        else
        {
        $dataTable['table'] = 'No Quadrat Information for this Personnel.';
        }


         $dataTable['personName'] = $this->usermodel->getPersonName($personnelID)."'s Contribution";


         $dataTable['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
         $dataTable['contentTitle'] ='Quadrat Information';
         $dataTable['backLink'] = anchor('/user/censusdetails/'.$personnelID.'S'.$censusID, 'Back', array('title'=>'Back to Personnel Detail', 'class'=>'back'));
        // load view
  		$this->load->view('user/quadrat', $dataTable);
      }

      function censustreeset($passedIDs)
      {
        global $databaseName;
        if($this->session->userdata($databaseName.'passedIDs'))
        {
          $this->session->unset_userdata($databaseName.'passedIDs');
        }
        $this->censustree($passedIDs);
        redirect('user/censustree/','location');
      }

      function censustree($infoPass=0)
      {
        global $databaseName;
        if($this->session->userdata($databaseName.'passedIDs'))
        {
          $passedIDs = $this->session->userdata($databaseName.'passedIDs');
          $offset = $infoPass;
        }
        else
        {
          $passedIDs = $infoPass;
          $this->session->set_userdata($databaseName.'passedIDs',$passedIDs);
          $offset = 0;
        }

        $limit = 30;

        $treeData['limit'] = $limit;
        $treeData['offset'] = $offset;

        $passedIDsExplode = explode('S',$passedIDs);
        $personnelID = $passedIDsExplode[0];
        $censusID = $passedIDsExplode[1];

        $treeData['personnelID'] = $personnelID;
        $treeData['censusID'] = $censusID;

        //Get QuadratID, CensusID and PlotID for particular Personnel ID from DataCollection
        $treeQuery = $this->usermodel->getCensusTreeData($treeData);
        $count_all = $this->usermodel->getCensusTreeCount($treeData);

        // offset
  		$uri_segment = 3;
  		//$offset = $this->uri->segment($uri_segment);

        //Load Data
        $treeResult = $treeQuery->result();

  		// generate pagination
  		$config['base_url'] = site_url('user/censustree');
   		$config['total_rows'] = $count_all;
   		$config['per_page'] = $limit;
  		$config['uri_segment'] = $uri_segment;
  		$this->pagination->initialize($config);
  		$dataTable['pagination'] = $this->pagination->create_links();

        if($count_all !== 0)
        {
         // generate table data
      		$this->table->set_empty("&nbsp");
      		$this->table->set_heading('No.', 'Tree Tag', 'Stem Tag', 'DBH', 'Genus Species', 'Census', 'Status');
      		$i = 0 + $offset;
          foreach($treeResult as $treeRow)
          {
             $treeID = $treeRow->TreeID;
             $stemID = $treeRow->StemID;
             $censusID = $treeRow->CensusID;

             $this->table->add_row(++$i, $treeRow->Tag,$treeRow->StemTag, $treeRow->DBH, $treeRow->GenusSpecies,$treeRow->PlotCensusNumber,$treeRow->Status);
      	  }
          $dataTable['table'] = $this->table->generate();
        }
        else
        {
        $dataTable['table'] = 'No Tree Information for this Personnel.';
        }


         $dataTable['personName'] = $this->usermodel->getPersonName($personnelID)."'s Contribution";

         $dataTable['title'] = 'CTFS/ForestGEO Forest Plot Census Data';
         $dataTable['contentTitle'] ='Tree Information';
         $dataTable['backLink'] = anchor('/user/censusdetails/'.$personnelID.'S'.$censusID, 'Back', array('title'=>'Back to Personnel Detail', 'class'=>'back'));
        // load view
  		$this->load->view('user/tree', $dataTable);
      }


}