<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once dirname(__FILE__) . '/tcpdf/tcpdf.php';
require_once dirname(__FILE__) . '/fpdi/fpdi.php';
class Concatpdflibrary extends FPDI
{
     var $files = array();
     function setFiles($files) {
          $this->files = $files;
     }
     function concat($orientation) {
          foreach($this->files AS $file) {
               $pagecount = $this->setSourceFile($file);
               for ($i = 1; $i <= $pagecount; $i++) {
                    $tplidx = $this->ImportPage($i);
                    $s = $this->getTemplatesize($tplidx);
                    $this->AddPage($orientation, array($s['w'], $s['h']));
                    $this->useTemplate($tplidx);
               }
          }
     }
}