<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Newplantlibrary
{
   function processData($formDetailResult)
   {
     foreach($formDetailResult as $formDetailRow)
      {
        if($formDetailRow->ColumnType == 'text')
        {
          $columnDetailA = $this->_textAttributes($formDetailRow->Attributes);
          $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
          $columnDetailA['columnType'] = $formDetailRow->ColumnType;
          $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
          $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
          $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
        }
        elseif($formDetailRow->ColumnType == 'limit')
        {
          $columnDetailA = $this->_limitAttributes($formDetailRow->Attributes);
          $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
          $columnDetailA['columnType'] = $formDetailRow->ColumnType;
          $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
          $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
          $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];

        }
        elseif($formDetailRow->ColumnType == 'speciesdd')
        {
          $columnDetailA = $this->_speciesDDAttributes($formDetailRow->Attributes);
          $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
          $columnDetailA['columnType'] = $formDetailRow->ColumnType;
          $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
          $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
          $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];

        }
        elseif($formDetailRow->ColumnType == 'subquaddd')
        {
          $columnDetailA = $this->_subquadDDAttributes($formDetailRow->Attributes);
          $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
          $columnDetailA['columnType'] = $formDetailRow->ColumnType;
          $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
          $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
          $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
        }
        elseif($formDetailRow->ColumnType == 'userdd')
        {
          $columnDetailA = $this->_userDDAttributes($formDetailRow->Attributes);
          $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
          $columnDetailA['columnType'] = $formDetailRow->ColumnType;
          $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
          $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
          $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
        }
        elseif($formDetailRow->ColumnType == 'twotext')
        {
          $columnDetailA = $this->_twotextAttributes($formDetailRow->Attributes);
          $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
          $columnDetailA['columnType'] = $formDetailRow->ColumnType;
          $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
          $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
          $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
        }
        elseif($formDetailRow->ColumnType == 'tagstem')
        {
          $columnDetailA = $this->_tagstemAttributes($formDetailRow->Attributes);
          $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
          $columnDetailA['columnType'] = $formDetailRow->ColumnType;
          $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
          $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
          $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
        }
      }
      $processData['headerListA'] = $headerListA;
      $processData['columnNameA'] = $columnNameA;
      $processData['columnTypeA'] = $columnTypeA;
      return $processData;
   }

   function _textAttributes($attributes)
   {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['stemChange'] = $attributeA[3];
    $array['treeChange'] = $attributeA[4];
    $array['defaultValue'] = $attributeA[5];
    $array['columnSize'] = $attributeA[6];
    $array['allowNull'] = $attributeA[7];
    $array['nextLineKey'] = $attributeA[8];

    return $array;
   }

   function _limitAttributes($attributes)
   {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['stemChange'] = $attributeA[3];
    $array['treeChange'] = $attributeA[4];
    $array['upperLimit'] = $attributeA[5];
    $array['lowerLimit'] = $attributeA[6];
    $array['defaultValue'] = $attributeA[7];
    $array['columnSize'] = $attributeA[8];
    $array['allowNull'] = $attributeA[9];
    $array['nextLineKey'] = $attributeA[10];

    return $array;
   }

   function _speciesDDAttributes($attributes)
   {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['stemChange'] = $attributeA[2];
    $array['query'] = $attributeA[3];

    return $array;
   }

   function _subquadDDAttributes($attributes)
   {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['startsWith'] = $attributeA[2];
    $array['maxX'] = $attributeA[3];
    $array['maxY'] = $attributeA[4];
    $array['query'] = $attributeA[5];

    return $array;
   }

   function _userDDAttributes($attributes)
   {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['userData'] = $attributeA[2];

    return $array;
  }

   function _twotextAttributes($attributes)
   {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['stemChange'] = $attributeA[3];
    $array['treeChange'] = $attributeA[4];
    $array['prefix'] = $attributeA[5];
    $array['defaultValue'] = $attributeA[6];
    $array['columnSize'] = $attributeA[7];
    $array['allowNull'] = $attributeA[8];
    $array['nextLineKey'] = $attributeA[9];

    return $array;
   }

   function _tagstemAttributes($attributes)
   {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['stemChange'] = $attributeA[3];
    $array['defaultValue'] = $attributeA[4];
    $array['columnSize'] = $attributeA[5];
    $array['allowNull'] = $attributeA[6];
    $array['nextLineKey'] = $attributeA[7];

    return $array;
   }
}
