<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Updatelibrary
{
  function checkUpdate()
  {
    $thisVersionFile =  base_url()."VersionDetail.txt";
    if($this->fileExists($thisVersionFile))
    {
      if(($file1 = fopen($thisVersionFile,"r")) !== FALSE)
      {
        $firstRow = fgets($file1);
        $secondRow = fgets($file1);
        $secondRowArray = explode('_',$secondRow);
        $thisVersion = floatval($secondRowArray[2]);  // Installed Version Number

        $latestVersionFile = "http://ctfs.arnarb.harvard.edu/Public/software/ctfsweb/versiondetail/latest_version_info.txt";
        if($this->fileExists($latestVersionFile))
        {
          if(($file2 = fopen($latestVersionFile,"r")) !== FALSE)
          {
            $firstRow = fgets($file2);
            $firstRowArray = explode('_',$firstRow);
            $latestVersion = floatval($firstRowArray[2]); //Latest Version Number
            $secondRow = fgets($file2);
            $updateLink = $secondRow;
            $updateLink = anchor($updateLink, 'Click Here', array('title'=>'Download Updates', 'target'=>'_blank'));
            $thirdRow = fgets($file2);    //Contain any additional information for New Update
            $fourthRow = fgets($file2);   //Can include information for the current version

            if($latestVersion > $thisVersion)
            {
              $message = '<div class="success">Installed Version: '.$thisVersion.'<br /><br />Latest Update Available - Version: '.$latestVersion.'. <u>'.$updateLink.'</u> To Download</div>'.$thirdRow;
            }
            elseif($latestVersion == $thisVersion)
            {
              $message = '<div class="success">You Have The Latest Version('.$thisVersion.') Installed.</div>'.$fourthRow;
            }
            else
            {                                                                             // Incase the Installed version is greater than listed on server - Only possible if online info file is not updated.
              $message = "Error checking version info. Please contact administrator.";
            }
          }
          fclose($file1);
          fclose($file2);
        }
        else
        {
          $message = '<div class="error">Unable to check server for latest updates. Please make sure that the computer is connected to the Internet.</div>';
        }
      }
    }
    else
    {
      $message = '<div class="error">Unable to check local version for update.</div>';
    }
    return $message;
  }

  function checkUpdate1()               // To display an update is available on front page
  {
    $thisVersionFile =  base_url()."VersionDetail.txt";
    if($this->fileExists($thisVersionFile))
    {
      if(($file1 = fopen($thisVersionFile,"r")) !== FALSE)
      {
        $firstRow = fgets($file1);
        $secondRow = fgets($file1);
        $secondRowArray = explode('_',$secondRow);
        $thisVersion = floatval($secondRowArray[2]);  // Installed Version Number

        $latestVersionFile = "http://ctfs.arnarb.harvard.edu/Public/software/ctfsweb/versiondetail/latest_version_info.txt";
        if($this->fileExists($latestVersionFile))
        {
          if(($file2 = fopen($latestVersionFile,"r")) !== FALSE)
          {
            $firstRow = fgets($file2);
            $firstRowArray = explode('_',$firstRow);
            $latestVersion = floatval($firstRowArray[2]); //Latest Version Number
            $secondRow = fgets($file2);
            $updateLink = $secondRow;
            $updateLink = anchor($updateLink, 'Click Here', array('title'=>'Download Updates', 'target'=>'_blank'));
            $thirdRow = fgets($file2);    //Contain any additional information for New Update
            $fourthRow = fgets($file2);   //Can include information for the current version

            if($latestVersion > $thisVersion)
            {
              $message = 'YES';
            }
            elseif($latestVersion == $thisVersion)
            {
              $message = 'NO';
            }
            else
            {                                                                             // Incase the Installed version is greater than listed on server - Only possible if online info file is not updated.
              $message = "Error checking version info. Please contact administrator.";
            }
          }
          fclose($file1);
          fclose($file2);
        }
        else
        {
          $message = 'NO';
        }
      }
    }
    else
    {
      $message = 'NO';
    }
    return $message;
  }

  function fileExists($path)
  {
    return (@fopen($path,"r")==true);
  }
}