<?php
class Configmodel extends Model{

    function Configmodel()
    {
      parent::Model();
      //$database = $this->session->userdata('databaseName');
      $this->configdb = $this->load->database('db1',TRUE);
    }

    function databaseName()
    {
      $this->configdb->select('Plots_ID, PlotName');
      $this->configdb->from('Plots');
      $plotData = $this->configdb->get();
      $plotNameA = array();
      $plotNameA['default'] = 'Select';
      foreach($plotData->result() as $row){
              $plotNameA[$row->Plots_ID] = $row->PlotName;
              }
      return $plotNameA;
    }

    function getDatabaseName($plotID)
    {
      $this->configdb->select('*');
      $this->configdb->where('Plots_ID',$plotID);
      $query = $this->configdb->get('Plots');
      $row = $query->row();
      $selectedPlotInfo['databaseName'] = $row->DatabaseName;
      $selectedPlotInfo['plotName'] = $row->PlotName;
      //$selectedPlotInfo['databaseVersion'] = $row->DatabaseVersion;
      return $selectedPlotInfo;
    }

    function getDataByPlotID($plotID,$databaseName,$formType)
    {
      $this->configdb->select('*');
      $this->configdb->from('DataEntryConfig');
      $this->configdb->where('Plots_ID',$plotID);
      $this->configdb->where('DatabaseName',$databaseName);
      $this->configdb->where('FormType',$formType);
      $this->configdb->order_by('ColumnNumber asc');
      $query = $this->configdb->get();
      return $query;
    }

    function getPlotNameByID($plotID)
    {
      $this->configdb->select('PlotName');
      $this->configdb->where('Plots_ID',$plotID);
      $query = $this->configdb->get('Plots');
      $row = $query->row();
      $plotName = $row->PlotName;
      return $plotName;
    }

    function getColumnNumber($plotID,$formType)
    {
      $databaseName = $this->session->userdata('selectedPlotName');
      $this->configdb->select_max('ColumnNumber');
      $this->configdb->where('Plots_ID',$plotID);
      $this->configdb->where('DatabaseName',$databaseName);
      $this->configdb->where('FormType',$formType);
      $query = $this->configdb->get('DataEntryConfig');
      if($query->num_rows() > 0)
      {
        $row = $query->row();
        $columnNumber = $row->ColumnNumber;
        $columnNumber = $columnNumber + 1;
      }
      else
      {
        $columnNumber = 1;
      }
      return $columnNumber;
    }

    function insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes)
    {
      $databaseName = $this->session->userdata('selectedPlotName');
      $insertArray = array('Plots_ID'=>$plotID,'DatabaseName'=>$databaseName,'FormType'=>$formType,'ColumnNumber'=>$columnNumber,'ColumnType'=>$columnType,'Attributes'=>$attributes);
      $this->configdb->insert('DataEntryConfig',$insertArray);
    }

    function resetColumnNumber($dataEntryConfigID,$i)
    {
      $data = array('ColumnNumber'=>$i);
      $this->configdb->where('DataEntryConfig_ID',$dataEntryConfigID);
      $this->configdb->update('DataEntryConfig',$data);
    }

    function deleteColumn($dataEntryConfigID)
    {
      $this->configdb->where('DataEntryConfig_ID',$dataEntryConfigID);
      $this->configdb->delete('DataEntryConfig');
    }

    function getDefaultData($plotID)
    {
      $this->configdb->select('FormType,ColumnNumber,ColumnType,Attributes');
      $this->configdb->where('Plots_ID',$plotID);
      $this->configdb->from('DataEntryConfig');
      $this->configdb->order_by('FormType,ColumnNumber');
      $query = $this->configdb->get();
      return $query;
    }
}