var month_array = new Array();

month_array[0] = "January";
month_array[1] = "February";
month_array[2] = "March";
month_array[3] = "April";
month_array[4] = "May";
month_array[5] = "June";
month_array[6] = "July";
month_array[7] = "August";
month_array[8] = "September";
month_array[9] = "October";
month_array[10] = "November";
month_array[11] = "December";

var day_array = new Array();

day_array[0] = 31;
day_array[1] = 28;
day_array[2] = 31;
day_array[3] = 30;
day_array[4] = 31;
day_array[5] = 30;
day_array[6] = 31;
day_array[7] = 31;
day_array[8] = 30;
day_array[9] = 31;
day_array[10] = 30;
day_array[11] = 31;

var currDate = new Date();


function generate_days(dropDownObj,container){

	var curr_date = new Date();

	var selected_month = dropDownObj.options[dropDownObj.selectedIndex].value;

	var obj = document.getElementById(container);

	var num_days = 0;

	alert(selected_month);

	switch (selected_month)
	{
	case "1":
		num_days = 31;
		break;
	case "2":
		num_days = 28;
		break;
	case "3":
		num_days = 31;
		break;
	case "4":
		num_days = 30;
		break;
	case "5":
		num_days = 31;
		break;
	case "6":
		num_days = 30;
		break;
	case "7":
		num_days = 31;
		break;
	case "8":
		num_days = 31;
		break;
	case "9":
		num_days = 30;
		break;
	case "10":
		num_days = 31;
		break;
	case "11":
		num_days = 30;
		break;
	case "12":
		num_days = 31;
		break;
	default:
		alert("Javascript encountered an error in file: date_handler.js");
		num_days = 0;
		break;
	}


	var daySelect = document.createElement("select");

	daySelect.id = "day_select";
	daySelect.name = "day_select";

	//obj.innerHTML = "<SELECT>";

	for (i=0; i<num_days; i++){

		daySelect.options[i] = new Option(i+1,i+1);

		//obj.innerHTML += "<OPTION value="+i+">"+i+"</OPTION>";

	}

	obj.appendChild(daySelect);


}

function createMonth(element_name,container){

	var monthSelect = document.createElement("select");

	monthSelect.id = element_name + "_month";
	monthSelect.name = element_name + "_month";
	monthSelect.onchange = generate_days;

	for(x in month_array){
		if (x == currDate.getMonth()){
			monthSelect.options[x] = new Option(month_array[x],x+1,true);
		} else {
			monthSelect.options[x] = new Option(month_array[x],x+1,false);
		}
	}

	var obj = document.getElementById(container);

	obj.appendChild(monthSelect);

}


function createDay(element_name,container){

	var daySelect = document.createElement("select");

	daySelect.id = element_name + "_day";
	daySelect.id = element_name + "_day";

	for (x=0; x < day_array[currDate.getMonth()]; x++){
		if (x+1 == currDate.getDate()){
			daySelect.options[x] = new Option(x+1,x+1,true);
		} else {
			daySelect.options[x] = new Option(x+1,x+1,false);
		}
	}

	var obj = document.getElementById(container);

	obj.appendChild(daySelect);

}

function createYear(element_name,container){

	var yearSelect = document.createElement("select");

	yearSelect.id = element_name + "_year";
	yearSelect.id = element_name + "_year";


	for (x=currDate.getFullYear(); x < currDate.getFullYear() + 20; x++){

		var index = x - currDate.getFullYear();

		if (x == currDate.getFullYear()){
			yearSelect.options[index] = new Option(x,x,true);
		} else {
			yearSelect.options[index] = new Option(x,x,false);
		}
	}

	var obj = document.getElementById(container);

	obj.appendChild(yearSelect);

}

function makeDate(element_name, container){

	createMonth(element_name, container);
	createDay(element_name, container);
	createYear(element_name,container);

}

function update_day(obj_name, obj_type){

	month_obj = document.getElementById(obj_name+"_month");
	month_val = month_obj.options[month_obj.selectedIndex].value;

	year_obj = document.getElementById(obj_name+"_year");
	year_val = year_obj.options[year_obj.selectedIndex].value;

	day_obj = document.getElementById(obj_name+"_day");
	day_val = day_obj.options[day_obj.selectedIndex].value;


	if(parseInt(year_val)%4 == 0 && month_val == "02"){
		//Leap Year Yes and February Yes
		for(j in day_obj){
			day_obj.remove(j);
		}
		for(j=0; j<29; j++){
			if(j+1 == day_val){
				day_obj.options[j] = new Option(j+1,j+1,true);
			} else {
				day_obj.options[j] = new Option(j+1,j+1,false);
			}
		}
	} else {
		// not Leap year and Feb.
		switch (month_val)
		{
		case "01":
			//jan.
			num_days = 31;
			break;
		case "02":
			//feb.
			num_days = 28;
			break;
		case "03":
			//mar.
			num_days = 31;
			break;
		case "04":
			//apr.
			num_days = 30;
			break;
		case "05":
			//may
			num_days = 31;
			break;
		case "06":
			//june
			num_days = 30;
			break;
		case "07":
			//july
			num_days = 31;
			break;
		case "08":
			//aug.
			num_days = 31;
			break;
		case "09":
			//sep.
			num_days = 30;
			break;
		case "10":
			//oct.
			num_days = 31;
			break;
		case "11":
			//nov.
			num_days = 30;
			break;
		case "12":
			//dec.
			num_days = 31;
			break;
		default:
			alert("Javascript encountered an error in file: date_handler.js");
			num_days = 0;
			break;
		}
		for(j in day_obj){
			day_obj.remove(j);
		}
		for(j=0; j<num_days; j++){
			if(j+1 == day_val){
				day_obj.options[j] = new Option(j+1,j+1,true);
			} else {
				day_obj.options[j] = new Option(j+1,j+1,false);
			}
		}
	}
}