<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/*
| -------------------------------------------------------------------
| DATABASE CONNECTIVITY SETTINGS
| -------------------------------------------------------------------
| This file will contain the settings needed to access your database.
|
| For complete instructions please consult the "Database Connection"
| page of the User Guide.
|
| -------------------------------------------------------------------
| EXPLANATION OF VARIABLES
| -------------------------------------------------------------------
|
|	['hostname'] The hostname of your database server.
|	['username'] The username used to connect to the database
|	['password'] The password used to connect to the database
|	['database'] The name of the database you want to connect to
|	['dbdriver'] The database type. ie: mysql.  Currently supported:
				 mysql, mysqli, postgre, odbc, mssql, sqlite, oci8
|	['dbprefix'] You can add an optional prefix, which will be added
|				 to the table name when using the  Active Record class
|	['pconnect'] TRUE/FALSE - Whether to use a persistent connection
|	['db_debug'] TRUE/FALSE - Whether database errors should be displayed.
|	['cache_on'] TRUE/FALSE - Enables/disables query caching
|	['cachedir'] The path to the folder where cache files should be stored
|	['char_set'] The character set used in communicating with the database
|	['dbcollat'] The character collation used in communicating with the database
|
| The $active_group variable lets you choose which connection group to
| make active.  By default there is only one group (the "default" group).
|
| The $active_record variables lets you determine whether or not to load
| the active record class
*/

$active_group = "db1";
$active_record = TRUE;

$db['db1']['hostname'] = "localhost";
$db['db1']['username'] = "root";
$db['db1']['password'] = "";
$db['db1']['database'] = "db_webuser";
$db['db1']['dbdriver'] = "mysql";
$db['db1']['dbprefix'] = "";
$db['db1']['pconnect'] = FALSE;
$db['db1']['db_debug'] = TRUE;
$db['db1']['cache_on'] = FALSE;
$db['db1']['cachedir'] = "";
$db['db1']['char_set'] = "utf8";
$db['db1']['dbcollat'] = "utf8_general_ci";


/*
//To add database information - for each database use following set of code
//Put in the required Information
//Replace db_bci with the name you will use while adding database into list using Admin Panel
$db['db_bci']['hostname'] = "localhost";
$db['db_bci']['username'] = "root";   //Put the username for mysql here if other than root
$db['db_bci']['password'] = "";       //Put the password for mysql here if any
$db['db_bci']['database'] = "";       //Put the database name here
$db['db_bci']['dbdriver'] = "mysql";
$db['db_bci']['dbprefix'] = "";
$db['db_bci']['pconnect'] = FALSE;
$db['db_bci']['db_debug'] = TRUE;
$db['db_bci']['cache_on'] = FALSE;
$db['db_bci']['cachedir'] = "";
$db['db_bci']['char_set'] = "utf8";
$db['db_bci']['dbcollat'] = "utf8_general_ci";
*/




/* End of file database.php */
/* Location: ./system/application/config/database.php */