<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

// shared_options : highcharts global settings, like interface or language
$config['shared_options'] = array(
	'chart' => array(
		'backgroundColor' => array(
			'linearGradient' => array(0, 0, 500, 500),
			'stops' => array(
				array(0, 'rgb(255, 255, 255)'),
				array(1, 'rgb(200, 200, 255)')
			)
		),
		'shadow' => true
	),
    'legend' => array(
       'margin' => 30,
       'itemWidth' => 180
     ),
     /*'plotOptions' => array(
        'series' => array(
            'marker' => array(
                'radius' => 4)
                )
        ),*/
);

// Template Example
$config['chart_template'] = array(
	'chart' => array(
		'renderTo' => 'graph',
		'defaultSeriesType' => 'column',
		'backgroundColor' => array(
			'linearGradient' => array(0, 500, 0, 0),
			'stops' => array(
				array(0, 'rgb(255, 255, 255)'),
				array(1, 'rgb(190, 200, 255)')
			)
		),
     ),
     'colors' => array(
     	 '#ED561B', '#50B432'
     ),
     'credits' => array(
     	'enable'=> true,
     	'text'	=> 'Anudeep',
		'href' => ''
     ),
     'title' => array(
		'text' => 'Template from config file'
     ),
     'legend' => array(

     ),
    'yAxis' => array(
		'title' => array(
			'text' => ''
		)
	),
	'xAxis' => array(
		'title' => array(
			'text' => ''
		)
	),
	'tooltip' => array(
		'shared' => true
	)
);