<?php

class Appfiles extends Controller {

  function Appfiles()
  {
    parent::Controller();
    if($this->session->userdata('loggedin') !== '1')
    {
      redirect('main','location');
    }
    $this->load->model('appfilesmodel');
    $this->load->helper('text');
    $this->load->helper('file');

    set_time_limit(0);
    ini_set('memory_limit', '-1');

    global $fileLinkJoin;
  }

  function personnelfile()
  {
     global $fileLinkJoin;
     $plotCensusArray = $this->session->userdata('plotCensusArray');
     $plotID = $plotCensusArray['plotName'];
     $plotName = $this->appfilesmodel->getPlotNameByID($plotID);

     $namesA = $this->appfilesmodel->getPersonnelNames();

     if(isset($namesA['error']))
     {
       echo $namesA['error'];
     }
     else
     {
       $x = 1;
       $nextline = "\r\n";
       $mainFolderName = $plotName;
       $fileFolderName = 'entered_collected_by';
       $filename = 'entered_collected_by';

       if (!file_exists('appfiles/'.$mainFolderName))
       {
         mkdir('appfiles/'.$mainFolderName, 0777, true);
       }
       if (!file_exists('appfiles/'.$mainFolderName.'/'.$fileFolderName))
       {
         mkdir('appfiles/'.$mainFolderName.'/'.$fileFolderName, 0777, true);
       }

       foreach($namesA as $key=>$value)
       {
         $value = utf8_decode($value);
         $value = $this->removeAccents($value);
         if($x==1)
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $value,'w'); //use w to start a new file rather than appending in existing
         }
         else
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $value,'a');
         }
         if($x < count($namesA))
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $nextline,'a');
         }
         $x++;
       }
       $filepath = base_url().'appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt';
       if($this->fileExists($filepath))
       {
          chmod('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', 0777);
          $fileLink = anchor($filepath, $filename.'.txt ', array('title'=>'View Text File', 'target'=>'_blank'));
          //echo '<div class="success">The File Created Successfully - '.$fileLink.'</div>';
       }
       else
       {
         $fileLink =  '<span style="font-size:10pt; color:#FF0000;">Error creating '.$filename.'.txt</span>';
          //echo '<div class="error">Error Occured while Creating File.</div>';
       }
       $fileLinkJoin = $fileLinkJoin.'<br />'.$fileLink;
     }
  }

  function quadratfile()
  {
     global $fileLinkJoin;
     $plotCensusArray = $this->session->userdata('plotCensusArray');
     $plotID = $plotCensusArray['plotName'];
     $plotName = $this->appfilesmodel->getPlotNameByID($plotID);

     $namesA = $this->appfilesmodel->getQuadratNames($plotID);

     if(isset($namesA['error']))
     {
       echo $namesA['error'];
     }
     else
     {
       $x = 1;
       $nextline = "\r\n";
       $mainFolderName = $plotName;
       $fileFolderName = 'quadrat_name';
       $filename = 'quadrat_name';

       if (!file_exists('appfiles/'.$mainFolderName))
       {
         mkdir('appfiles/'.$mainFolderName, 0777, true);
       }
       if (!file_exists('appfiles/'.$mainFolderName.'/'.$fileFolderName))
       {
         mkdir('appfiles/'.$mainFolderName.'/'.$fileFolderName, 0777, true);
       }
       foreach($namesA as $key=>$value)
       {
         $value = utf8_decode($value);
         $value = $this->removeAccents($value);
         if($x==1)
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $value,'w'); //use w to start a new file rather than appending in existing
         }
         else
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $value,'a');
         }
         if($x < count($namesA))
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $nextline,'a');
         }
         $x++;
       }
       $filepath = base_url().'appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt';
       if($this->fileExists($filepath))
       {
          chmod('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', 0777);
          $fileLink = anchor($filepath, $filename.'.txt ', array('title'=>'View Text File', 'target'=>'_blank'));
          //echo '<div class="success">The File Created Successfully - '.$fileLink.'</div>';
       }
       else
       {
         $fileLink =  '<span style="font-size:10pt; color:#FF0000;">Error creating '.$filename.'.txt</span>';
          //echo '<div class="error">Error Occured while Creating File.</div>';
       }
       $fileLinkJoin = $fileLinkJoin.'<br />'.$fileLink;
     }
  }

  function speciesfile()
  {
     global $fileLinkJoin;
     $plotCensusArray = $this->session->userdata('plotCensusArray');
     $plotID = $plotCensusArray['plotName'];
     $plotName = $this->appfilesmodel->getPlotNameByID($plotID);

     $namesA = $this->appfilesmodel->getSpeciesNames();

     if(isset($namesA['error']))
     {
       echo $namesA['error'];
     }
     else
     {
       $x = 1;
       $nextline = "\r\n";
       $mainFolderName = $plotName;
       $fileFolderName = 'species';
       $filename = 'species';

       if (!file_exists('appfiles/'.$mainFolderName))
       {
         mkdir('appfiles/'.$mainFolderName, 0777, true);
       }
       if (!file_exists('appfiles/'.$mainFolderName.'/'.$fileFolderName))
       {
         mkdir('appfiles/'.$mainFolderName.'/'.$fileFolderName, 0777, true);
       }

       foreach($namesA as $key=>$value)
       {
         //$value = utf8_decode($value);
         //$value = $this->removeAccents($value);
         if($x==1)
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $value,'w'); //use w to start a new file rather than appending in existing
         }
         else
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $value,'a');
         }
         if($x < count($namesA))
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $nextline,'a');
         }
         $x++;
       }
       $filepath = base_url().'appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt';
       if($this->fileExists($filepath))
       {
          chmod('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', 0777);
          $fileLink = anchor($filepath, $filename.'.txt', array('title'=>'View Text File', 'target'=>'_blank'));
          //echo '<div class="success">The File Created Successfully - '.$fileLink.'</div>';
       }
       else
       {
         $fileLink =  '<span style="font-size:10pt; color:#FF0000;">Error creating '.$filename.'.txt</span>';
          //echo '<div class="error">Error Occured while Creating File.</div>';
       }
       $fileLinkJoin = $fileLinkJoin.'<br />'.$fileLink;
     }
  }

  function censusfile()
  {
     global $fileLinkJoin;
     $plotCensusArray = $this->session->userdata('plotCensusArray');
     $plotID = $plotCensusArray['plotName'];
     $plotName = $this->appfilesmodel->getPlotNameByID($plotID);

     $namesA = $this->appfilesmodel->getCensus($plotID);

     if(isset($namesA['error']))
     {
       echo $namesA['error'];
     }
     else
     {
       $x = 1;
       $nextline = "\r\n";
       $mainFolderName = $plotName;
       $fileFolderName = 'census';
       $filename = 'census';

       if (!file_exists('appfiles/'.$mainFolderName))
       {
         mkdir('appfiles/'.$mainFolderName, 0777, true);
       }
       if (!file_exists('appfiles/'.$mainFolderName.'/'.$fileFolderName))
       {
         mkdir('appfiles/'.$mainFolderName.'/'.$fileFolderName, 0777, true);
       }

       foreach($namesA as $key=>$value)
       {
         //$value = utf8_decode($value);
         //$value = $this->removeAccents($value);
         if($x==1)
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $value,'w'); //use w to start a new file rather than appending in existing
         }
         else
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $value,'a');
         }
         if($x < count($namesA))
         {
           write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $nextline,'a');
         }
         $x++;
       }
       $filepath = base_url().'appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt';
      if($this->fileExists($filepath))
       {
          chmod('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', 0777);
          $fileLink = anchor($filepath, $filename.'.txt', array('title'=>'View Text File', 'target'=>'_blank'));
          //echo '<div class="success">The File Created Successfully - '.$fileLink.'</div>';
       }
       else
       {
         $fileLink =  '<span style="font-size:10pt; color:#FF0000;">Error creating '.$filename.'.txt</span>';
          //echo '<div class="error">Error Occured while Creating File.</div>';
       }
       $fileLinkJoin = $fileLinkJoin.'<br />'.$fileLink;
     }
  }

  function plotfile()
  {
     global $fileLinkJoin;
     $plotCensusArray = $this->session->userdata('plotCensusArray');
     $plotID = $plotCensusArray['plotName'];
     $plotName = $this->appfilesmodel->getPlotNameByID($plotID);

     $nextline = "\r\n";
     $mainFolderName = $plotName;
     $fileFolderName = 'plot';
     $filename = 'plot';

     if (!file_exists('appfiles/'.$mainFolderName))
     {
       mkdir('appfiles/'.$mainFolderName, 0777, true);
     }
     if (!file_exists('appfiles/'.$mainFolderName.'/'.$fileFolderName))
     {
       mkdir('appfiles/'.$mainFolderName.'/'.$fileFolderName, 0777, true);
     }
     $value = $plotName;

     write_file('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', $value,'w');

     $filepath = base_url().'appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt';
     if($this->fileExists($filepath))
       {
          chmod('./appfiles/'.$mainFolderName.'/'.$fileFolderName.'/'.$filename.'.txt', 0777);
          $fileLink = anchor($filepath, $filename.'.txt', array('title'=>'View Text File', 'target'=>'_blank'));
       }
       else
       {
         $fileLink =  '<span style="font-size:10pt; color:#FF0000;">Error creating '.$filename.'.txt</span>';
          //echo '<div class="error">Error Occured while Creating File.</div>';
       }
       $fileLinkJoin = $fileLinkJoin.'<br />'.$fileLink;
  }

  function generateallfiles()
  {

    global $fileLinkJoin;
    $fileLinkJoin = "";

    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotID = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];

    $this->personnelfile();
    $this->speciesfile();
    $this->quadratfile();
    $this->censusfile();
    $this->plotfile();

    $backLink = anchor('dataentry/androidapp', 'Back To Android App Menu', array('title'=>'Back To Android App Menu', 'class'=>'back'));
    $data['formTable'] = '<div class="success">List of Files Created: '.$fileLinkJoin.'</div>';

    $data['formOpen'] = "";
    $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
    $data['contentTitle'] = 'Android App Files - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
    $data['backLink'] = '<br />'.$backLink;
    $this->load->view('user/dataentry/simpleform',$data);
  }

  function deleteFolder($dirName)
  {
    //$dirName = 'BCI_New';
    // ensure $dir ends with a slash
    $dir = 'appfiles/'.$dirName."/";

    $files = glob($dir.'*'); // get all file names
    foreach($files as $file)
    { // iterate files
      if(is_file($file))
      unlink($file); // delete file
    }
    rmdir($dir);
  }

  function fileExists($path)
  {
    return (@fopen($path,"r")==true);
  }

  function removeAccents($str)
  {
    $a = array('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', '', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', '?', '?', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', '?', '?', 'L', 'l', 'N', 'n', 'N', 'n', 'N', 'n', '?', 'O', 'o', 'O', 'o', 'O', 'o', '', '', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', '', '', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', '', 'Z', 'z', 'Z', 'z', '', '', '?', '', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', '?', '?', '?', '?', '?', '?');
    $b = array('A', 'A', 'A', 'A', 'A', 'A', 'AE', 'C', 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I', 'D', 'N', 'O', 'O', 'O', 'O', 'O', 'O', 'U', 'U', 'U', 'U', 'Y', 's', 'a', 'a', 'a', 'a', 'a', 'a', 'ae', 'c', 'e', 'e', 'e', 'e', 'i', 'i', 'i', 'i', 'n', 'o', 'o', 'o', 'o', 'o', 'o', 'u', 'u', 'u', 'u', 'y', 'y', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', 'D', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'IJ', 'ij', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', 'L', 'l', 'l', 'l', 'N', 'n', 'N', 'n', 'N', 'n', 'n', 'O', 'o', 'O', 'o', 'O', 'o', 'OE', 'oe', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', 'S', 's', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', 'Y', 'Z', 'z', 'Z', 'z', 'Z', 'z', 's', 'f', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'A', 'a', 'AE', 'ae', 'O', 'o');
    $str = str_replace($a, $b, $str);
    return $str;
  }


}