<?php

class Bigtreefile extends Controller {

  function Bigtreefile()
  {
    parent::Controller();
    if($this->session->userdata('loggedin') !== '1')
    {
      redirect('main','location');
    }
    $this->load->model('formmodel');

    set_time_limit(0);
    ini_set('memory_limit', '-1');
  }

  function createfile($merge = 'notMerge')
  {
    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotID = $plotCensusArray['plotName'];
    $selectedPlotName = $this->session->userdata('selectedPlotName');
    //$plotActualName = $plotCensusArray['plotActualName'];

    //$formType = $this->session->userdata('formType');
    $formType = 'bigform';
    $plotName = $this->formmodel->getPlotNameByID($plotID);

    $this->load->library('formlibrary');

    $fileName = base_url()."files/configfiles/".$formType."_".$selectedPlotName."_".$plotName."_".$plotID.".txt";
    $fileName = str_replace(" ","",$fileName);
    $formDetailResult = $this->formlibrary->readConfigFile($fileName);

    if($formDetailResult == "Not Found")
    {
      echo "Configuration File Not Found  :  ".$fileName;
      die();
    }
    /*$plotID = $this->session->userdata('configPlotID');
    $formType = $this->session->userdata('formType');
    $this->load->model('configmodel');
    $formDetailQuery = $this->configmodel->getDataByPlotID($plotID,$formType);

    if($formDetailQuery->num_rows() > 0)
    {
      $formDetailResult = $formDetailQuery->result();*/

      /*$headerListA = array();
      $rowNumber = 1;
      $columnValue = "";*/

      $this->load->library('bigtreelibrary');
      $processData = $this->bigtreelibrary->processData($formDetailResult);
      $headerListA = $processData['headerListA'];
      $columnNameA = $processData['columnNameA'];
      $columnTypeA = $processData['columnTypeA'];
    //}
    $collectedNum = $this->input->post('num_collected');
    $checkedNum = $this->input->post('num_checked');
    $enteredNum = $this->input->post('num_entered');
    $recordsNum = $this->input->post('row_count');

    $collected = $this->input->post('collected');
    $checked = $this->input->post('checked');
    $entered = $this->input->post('entered');

    //$quadrat = $this->input->post('quadrat');

    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotID = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];

    if($merge == 'merge')
    {
      $filename = $this->session->userdata('mergefilename');
    }
    else
    {
      $this->load->helper('date');
      $datestring = "%m-%d-%Y";
      $date = mdate($datestring);
      $random = rand(1,99);
      $enteredBy = $this->formmodel->getPersonnelNameByID($entered[0]);
      $enteredBy = utf8_decode($enteredBy);
      $enteredBy  = $this->removeAccents($enteredBy);
      //$filename = join('_',array('MultiStemForm',$plotActualName,$censusNumber,$quadrat,$date,$random));
      $filename = join('_',array('BigTreeForm',$plotActualName,$censusNumber,$date,$enteredBy,$random));
      $filename = str_replace(" ","",$filename);
    }

    $linetab = "\t";
    $nextline = "\r\n";

    $this->load->helper('file');

    if($merge == 'merge')
    {
      //don't add header data
    }
    else
    {
      /////////////Collected//////////
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $collectedNum,'w'); //use w to start a new file rather than appending in existing
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $linetab,'a');
      for($i = 0; $i < $collectedNum; $i++)
      {
        write_file('./files/datafiles/bigtree/'.$filename.'.txt', $collected[$i],'a');
        write_file('./files/datafiles/bigtree/'.$filename.'.txt', $linetab,'a');
      }
      $collectedDate = $this->input->post('collected_year')."-".$this->input->post('collected_month')."-".$this->input->post('collected_day');
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $collectedDate,'a');
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $linetab,'a');
      ///////////////////////////////

      ////////////Checked////////////
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $checkedNum,'a');
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $linetab,'a');
      for($i = 0; $i < $checkedNum; $i++)
      {
        write_file('./files/datafiles/bigtree/'.$filename.'.txt', $checked[$i],'a');
        write_file('./files/datafiles/bigtree/'.$filename.'.txt', $linetab,'a');
      }
      $checkedDate = $this->input->post('checked_year')."-".$this->input->post('checked_month')."-".$this->input->post('checked_day');
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $checkedDate,'a');
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $linetab,'a');
      ///////////////////////////////

      ////////////Entered////////////
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $enteredNum,'a');
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $linetab,'a');
      for($i = 0; $i < $enteredNum; $i++)
      {
        write_file('./files/datafiles/bigtree/'.$filename.'.txt', $entered[$i],'a');
        write_file('./files/datafiles/bigtree/'.$filename.'.txt', $linetab,'a');
      }
      $enteredDate = $this->input->post('entered_year')."-".$this->input->post('entered_month')."-".$this->input->post('entered_day');
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $enteredDate,'a');
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $linetab,'a');
      ///////////////////////////////

      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $nextline,'a');

      /////////column names//////////
      $dataJoin = join("\t",$columnNameA);
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $dataJoin,'a');
      //////////////////////////////

      //write_file('./files/datafiles/multistem/'.$filename.'.txt', $nextline,'a');
    }

    ///////column data//////////
    for($i = 1; $i <= $recordsNum; $i++)
    {
      $columnCount = count($columnNameA); //columnNameA keys are columnNumber
      write_file('./files/datafiles/bigtree/'.$filename.'.txt', $nextline,'a');
      for($x = 1; $x <= $columnCount; $x++)
      {
        $columnName = $columnNameA[$x];
        $columnType = $columnTypeA[$x];
        if($columnType == 'twotext')
        {
          $columnValue1 = $this->input->post($columnName."prefix_".$i);
          $columnValue2 = $this->input->post($columnName."_".$i);
          $columnValue = $columnValue1.$columnValue2;
        }
        else
        {
          $columnValue = $this->input->post($columnName."_".$i);
        }
        write_file('./files/datafiles/bigtree/'.$filename.'.txt', $columnValue,'a');
        write_file('./files/datafiles/bigtree/'.$filename.'.txt', $linetab,'a');
      }
    }
    $filepath = base_url().'files/datafiles/bigtree/'.$filename.'.txt';

    if($this->fileExists($filepath))
    {
      $fileLink = anchor($filepath, $filename.'.txt', array('title'=>'View Text File', 'target'=>'_blank'));
      $data['formTable'] = '<div class="success">The File Created Successfully - '.$fileLink.'</div>';
    }
    else
    {
      $data['formTable'] = '<div class="error">Error Occured while Creating File.</div>';
    }
    $data['formOpen'] = "";

    $plotCensusArray = $this->session->userdata('plotCensusArray');
    $plotName = $plotCensusArray['plotName'];
    $censusNumber = $plotCensusArray['censusNumber'];
    $plotActualName = $plotCensusArray['plotActualName'];
    $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
    $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';
    $data['backLink'] = anchor('dataentry/mainmenu/', 'Back', array('title'=>'Back to Select Form Type', 'class'=>'back'));
    $this->load->view('user/dataentry/simpleform',$data);
  }

  function fileExists($path)
  {
    return (@fopen($path,"r")==true);
  }

  function removeAccents($str)
  {
    $a = array('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', '', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', '?', '?', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', '?', '?', 'L', 'l', 'N', 'n', 'N', 'n', 'N', 'n', '?', 'O', 'o', 'O', 'o', 'O', 'o', '', '', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', '', '', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', '', 'Z', 'z', 'Z', 'z', '', '', '?', '', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', '?', '?', '?', '?', '?', '?');
    $b = array('A', 'A', 'A', 'A', 'A', 'A', 'AE', 'C', 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I', 'D', 'N', 'O', 'O', 'O', 'O', 'O', 'O', 'U', 'U', 'U', 'U', 'Y', 's', 'a', 'a', 'a', 'a', 'a', 'a', 'ae', 'c', 'e', 'e', 'e', 'e', 'i', 'i', 'i', 'i', 'n', 'o', 'o', 'o', 'o', 'o', 'o', 'u', 'u', 'u', 'u', 'y', 'y', 'A', 'a', 'A', 'a', 'A', 'a', 'C', 'c', 'C', 'c', 'C', 'c', 'C', 'c', 'D', 'd', 'D', 'd', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'E', 'e', 'G', 'g', 'G', 'g', 'G', 'g', 'G', 'g', 'H', 'h', 'H', 'h', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'I', 'i', 'IJ', 'ij', 'J', 'j', 'K', 'k', 'L', 'l', 'L', 'l', 'L', 'l', 'L', 'l', 'l', 'l', 'N', 'n', 'N', 'n', 'N', 'n', 'n', 'O', 'o', 'O', 'o', 'O', 'o', 'OE', 'oe', 'R', 'r', 'R', 'r', 'R', 'r', 'S', 's', 'S', 's', 'S', 's', 'S', 's', 'T', 't', 'T', 't', 'T', 't', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'W', 'w', 'Y', 'y', 'Y', 'Z', 'z', 'Z', 'z', 'Z', 'z', 's', 'f', 'O', 'o', 'U', 'u', 'A', 'a', 'I', 'i', 'O', 'o', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'U', 'u', 'A', 'a', 'AE', 'ae', 'O', 'o');
    $str = str_replace($a, $b, $str);
    return $str;
  }
}