<?php

class Finishup extends Controller{

    function Finishup()
    {
      parent::Controller();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->model('finishupmodel');
      global $databaseName;
      $databaseName = $this->session->userdata('databaseName');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }

    function removetemp()
    {
       $getTempTblNamesList = $this->finishupmodel->getTempTblNames();
       //print_r($getTempTblNamesList);
       $tableCheckArray = array();
       foreach($getTempTblNamesList as $key=>$value)
       {
         $tableName = $value;
         $checkData = array('name'=>'tablecheckbox[]','id'=>'tablecheckbox','value'=>$tableName);
         $tableCheckArray[] = form_checkbox($checkData)." ".$tableName."<br />";
       }
       $data['tableCheckArray'] = $tableCheckArray;

       $plotCensusArray = $this->session->userdata('plotCensusArray');
       $plotName = $plotCensusArray['plotName'];
       $censusNumber = $plotCensusArray['censusNumber'];
       $plotActualName = $plotCensusArray['plotActualName'];

       $removeButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Remove','onclick'=>"return confirm('Are you sure you want to remove these Temp Tables?')");
       $data['submitButton'] = '<p style="text-align:center;">'.form_button($removeButtonA).'</p>';
       $data['formOpen'] = form_open('finishup/removetempform',array('name'=>'myform'));
       $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
       $data['contentTitle'] = 'Erase Temporary Data Tables - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span></span>';
       $this->load->view('finishup/removetableview',$data);
    }

    function removetempform()
    {
      $tableCheckArray = $this->input->post('tablecheckbox');
      if(empty($tableCheckArray))
      {
        $status = '<div class="error">No Table Was Selected!!';
      }
      else
      {
        $dropCount = 0;
        foreach($tableCheckArray as $key=>$tableName)
        {
          $dropStatus = $this->finishupmodel->droptable($tableName);
          if($dropStatus == TRUE)
          {
             $dropCount++;
          }
        }
        $status = '<div class="success">Number of Temp Table Dropped: '.$dropCount.'</div>';
      }

      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];

      $data['formTable'] = '<br /><br />'.$status;
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Erase Temporary Data Tables - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.$plotActualName.'</span></span>';
      $this->load->view('user/dataentry/mainmenu',$data);
    }

}