<?php

class Forms extends Controller {

  function Forms()
  {
    parent::Controller();
    if($this->session->userdata('loggedin') !== '1')
    {
      redirect('main','location');
    }
    $this->load->model('configmodel');
  }

  function index()
  {
    redirect('forms/selectdatabase');
  }

  /*function selectdatabase()
  {
    if(isset($this->session->userdata['configDatabaseID']))
    {
      $this->session->unset_userdata('configDatabaseID');
    }
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Select a Database";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("forms/selectdatabaseform");
    $data['table'] = $this->_selectDatabaseTable();
    $data['backLink'] = "";
    $this->load->view('forms/simpleform',$data);
  }

  function selectdatabaseform()
  {
    $this->_validateselectdatabaseform();

    if($this->form_validation->run() == FALSE)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Select a Database";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("forms/selectdatabaseform");
      $data['table'] = $this->_selectDatabaseTable();
      $data['backLink'] = "";
      $this->load->view('forms/simpleform',$data);
    }
    else
    {
      $databaseID = $this->input->post('selectDatabase');
      $selectedPlotInfo = $this->configmodel->getDatabaseName($databaseID);
      $selectedPlotName = $selectedPlotInfo['plotName'];
      $selectedDatabaseName = $selectedPlotInfo['databaseName'];
      $this->session->set_userdata('configDatabaseID',$databaseID);
      $this->session->set_userdata('database',$selectedDatabaseName);
      $this->session->set_userdata('selectedPlotName',$selectedPlotName);// need to differentiate between plots of different databases - save in database as DatabaseName
      redirect('forms/selectplot');
    }
  }

  function _selectDatabaseTable()
  {
    $selectDatabase = set_value('selectDatabase');

    //$this->load->model('configmodel');

    $selectDatabaseA = $this->configmodel->databaseName();

    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');

    $selectDatabaseDD = form_dropdown('selectDatabase',$selectDatabaseA);
    $submitButton = form_button($submitButtonA);

    $selectDatabaseErr = form_error('selectDatabase');

    $formTableA = array(array(),
                        array('Select Database : ',$selectDatabaseDD,$selectDatabaseErr),
                        array('',"<br />"),
                        array('',$submitButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validateselectDatabaseform()
  {
    $this->form_validation->set_rules('selectDatabase', 'Database Name', 'callback_dropdown_check');

    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }*/



  function selectplot()
  {
    if(isset($this->session->userdata['configPlotID']))
    {
      $this->session->unset_userdata('configPlotID');
    }
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Select a Plot";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("forms/selectplotform");
    $data['table'] = $this->_selectPlotTable();
    $data['backLink'] = "";
    $this->load->view('forms/simpleform',$data);
  }

  function selectplotform()
  {
    $this->_validateselectplotform();

    if($this->form_validation->run() == FALSE)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Select a Plot";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("forms/selectplotform");
      $data['table'] = $this->_selectPlotTable();
      $data['backLink'] = anchor('forms/selectdatabase/','Back',array('class'=>'back'));
      $this->load->view('forms/simpleform',$data);
    }
    else
    {
      $plotID = $this->input->post('selectPlot');
      $this->session->set_userdata('configPlotID',$plotID);
      $this->load->model('formmodel');
      $plotName = $this->formmodel->getPlotNameByID($plotID);
      $this->session->set_userdata('plotName',$plotName);
      redirect('forms/selectformtype');
    }
  }

  function _selectPlotTable()
  {
    $selectPlot = set_value('selectPlot');

    $this->load->model('formmodel');

    $selectPlotA = $this->formmodel->getPlotName();

    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');

    $selectPlotDD = form_dropdown('selectPlot',$selectPlotA);
    $submitButton = form_button($submitButtonA);

    $selectPlotErr = form_error('selectPlot');

    $formTableA = array(array(),
                        array('Select Plot : ',$selectPlotDD,$selectPlotErr),
                        array('','<p style="text-align:center;">'.$submitButton.'</p>')
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validateselectplotform()
  {
    $this->form_validation->set_rules('selectPlot', 'Plot Name', 'callback_dropdown_check');

    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }

  function selectformtype()
  {
    if(isset($this->session->userdata['formType']))
    {
      $this->session->unset_userdata('formType');
    }
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Select Form Type";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("forms/selectformtypevalidate");
    $data['table'] = $this->_selectFormTypeTable();
    $data['backLink'] = anchor('forms/selectplot/','Back',array('class'=>'back'));
    $this->load->view('forms/simpleform',$data);
  }

  function selectformtypevalidate()
  {
    $this->_validateselectformtype();

    if($this->form_validation->run() == FALSE)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Select Form Type";
      $data['formHeading'] = "";
      $data['formOpen'] = form_open("forms/selectformtypevalidate");
      $data['table'] = $this->_selectFormTypeTable();
      $data['backLink'] = anchor('forms/selectplot/','Back',array('class'=>'back'));
      $this->load->view('forms/simpleform',$data);
    }
    else
    {
      $formType = $this->input->post('formType');
      $this->session->set_userdata('formType',$formType);
      redirect('forms/addcolumn');
    }
  }

  function _selectFormTypeTable()
  {
    $formType = set_value('formType');

    $formTypeA = array('default'=>'Select','newform'=>'New Plants Form','oldform'=>'Old Trees Form','multiform'=>'Multi Stem Form','bigform'=>'Big Trees Form');
    //$formTypeA = array('default'=>'Select','newform'=>'New Plants Form','oldform'=>'Old Trees Form','multiform'=>'Multi Stem Form');
    $formTypeDD = form_dropdown('formType',$formTypeA);

    $formTypeErr = form_error('formType');

    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
    $submitButton = form_button($submitButtonA);

    $formTableA = array(array(),
                        array('Form Type : ',$formTypeDD,$formTypeErr),
                        array('','<p style="text-align:center;">'.$submitButton.'</p>')
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function _validateselectformtype()
  {
    $this->form_validation->set_rules('formType', 'Form Type', 'callback_dropdown_check');

    $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
  }

  function addcolumn()
  {
    $formType = $this->session->userdata('formType');
    if($formType == 'newform')
    {
      $this->addcolumnnew();
    }
    elseif($formType == 'oldform')
    {
      $this->addcolumnold();
    }
    elseif($formType == 'multiform')
    {
      $this->addcolumnmulti();
    }
    elseif($formType == 'bigform')
    {
      $this->addcolumnbig();
    }
  }


  function addcolumnnew()
  {
    if(!isset($this->session->userdata['configPlotID']) || !isset($this->session->userdata['formType']))
    {
      redirect('forms/selectplot');
    }
    //get the session PlotID and formType from session
    //get the list of already existing columns for the plot
    //get the option to Add/Update/Delete the columns
    $plotID = $this->session->userdata('configPlotID');
    $plotName = $this->session->userdata('plotName');
    //$plotName = $this->formmodel->getPlotNameByID($plotID);
    $formType = $this->session->userdata('formType');
    $formName = $this->_getFormName($formType);
    $databaseName = $this->session->userdata('selectedPlotName');
    $plotColumnQuery = $this->configmodel->getDataByPlotID($plotID,$databaseName,$formType);

    $this->table->set_empty("&nbsp;");
    if($plotColumnQuery->num_rows() > 0)
    {
      $this->table->set_heading('Number', 'Column','Action');
      $plotColumnResult = $plotColumnQuery->result();
      foreach($plotColumnResult as $plotColumnRow)
      {
        $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
        $attributesArray = explode("\t",$plotColumnRow->Attributes);
        $columnHeader = $attributesArray[0];
        $this->table->add_row($plotColumnRow->ColumnNumber,$columnHeader,
                              //anchor('forms/updateColumn/'.$dataEntryConfigID,'update',array('class'=>'update')).' '.
          			          anchor('forms/deleteColumn/'.$dataEntryConfigID,'delete',array('class'=>'delete','onclick'=>"return confirm('Are you sure, you want to delete this record?')"))  );
      }
    }
    else
    {
       $this->table->add_row('No Columns Added Yet. Please Click "Add a New Column".');
    }
    $data['table'] = $this->table->generate();

    //Add a button to Add New Column
    $addLink = anchor('forms/selectcolumntype/','Add a New Column',array('class'=>'add'));
    if($plotColumnQuery->num_rows() > 0 )
    {
       $addLink = $addLink."&nbsp;&nbsp;&nbsp;".anchor('forms/sortlist/','Rearrange Columns',array('class'=>'update'))
                            ."&nbsp;&nbsp;&nbsp;"
                            .anchor('newplant/createform/','Preview Form',array('class'=>'view', 'target'=>'_blank'))
                            ."&nbsp;&nbsp;&nbsp;"
                            .anchor('forms/createconfigfile/','Create Config File',array('class'=>'write'))
                            ;
    }
    else
    {
      $addLink = $addLink."&nbsp;&nbsp;&nbsp;".anchor('forms/usedefault','Use Default Config File',array('class'=>'update', 'onclick'=>"return confirm('Preview and make sure that the default configuration will work for your Plot')"));
    }
    $data['addLink'] = $addLink;
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "List of Columns - ".$plotName." - ".$formName;
    $data['formHeading'] = "";
    $this->load->view('forms/columnlist',$data);
  }

  function addcolumnold()
  {
    if(!isset($this->session->userdata['configPlotID']) || !isset($this->session->userdata['formType']))
    {
      redirect('forms/selectplot');
    }
    //get the session PlotID and formType from session
    //get the list of already existing columns for the plot
    //get the option to Add/Update/Delete the columns
    $plotID = $this->session->userdata('configPlotID');
    $plotName = $this->session->userdata('plotName');
    $formType = $this->session->userdata('formType');
    $formName = $this->_getFormName($formType);

    $databaseName = $this->session->userdata('selectedPlotName');
    $plotColumnQuery = $this->configmodel->getDataByPlotID($plotID,$databaseName,$formType);

    $this->table->set_empty("&nbsp;");
    if($plotColumnQuery->num_rows() > 0)
    {
      $this->table->set_heading('Number', 'Column','Action');
      $plotColumnResult = $plotColumnQuery->result();
      foreach($plotColumnResult as $plotColumnRow)
      {
        $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
        $attributesArray = explode("\t",$plotColumnRow->Attributes);
        $columnHeader = $attributesArray[0];
        $this->table->add_row($plotColumnRow->ColumnNumber,$columnHeader,
                              //anchor('forms/updateColumn/'.$dataEntryConfigID,'update',array('class'=>'update')).' '.
          			          anchor('forms/deleteColumn/'.$dataEntryConfigID,'delete',array('class'=>'delete','onclick'=>"return confirm('Are you sure, you want to delete this record?')"))  );
      }
    }
    else
    {
      //Column Count is Zero...so
      //Add Subquadrat and TreeTag columns automatically
      //Then refresh the page.

      /*//Add Subquadrat
      $columnType = "oldcolumn";
      $columnNumber = 1;
      $columnHeader = "Subquadrat";
      $columnName = "subquadrat";
      $attributes = join("\t",array($columnHeader,$columnName));
      $this->configmodel->insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes);

      //Add TreeTag

      $columnType = "oldcolumn";
      $columnNumber = 2;
      $columnHeader = "Tree Tag";
      $columnName = "treetag";
      $attributes = join("\t",array($columnHeader,$columnName));
      $this->configmodel->insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes);
      redirect('forms/addcolumn'); */

      $this->table->add_row('No Columns Added Yet. Please Click "Add a New Column".');
    }
    $data['table'] = $this->table->generate();

    //Add a button to Add New Column
    $addLink = anchor('addoldcolumns/selectcolumntype/','Add a New Column',array('class'=>'add'));
    $addLink = $addLink."&nbsp;&nbsp;&nbsp;".anchor('addoldcolumns/listcolumns/','Add an Old Column',array('class'=>'add'));
    if($plotColumnQuery->num_rows() > 0 )
    {
       $addLink = $addLink."&nbsp;&nbsp;&nbsp;".anchor('forms/sortlist/','Rearrange Columns',array('class'=>'update'))
                            ."&nbsp;&nbsp;&nbsp;"
                            .anchor('oldplant/selectcensus/','Preview Form',array('class'=>'view', 'target'=>'_blank'))
                            ."&nbsp;&nbsp;&nbsp;<br /><br />"
                            .anchor('forms/createconfigfile/','Create Config File',array('class'=>'write'))
                            ;
    }
    else
    {
      $addLink = $addLink."&nbsp;&nbsp;&nbsp;".anchor('forms/usedefault','Use Default Config File',array('class'=>'update', 'onclick'=>"return confirm('Preview and make sure that the default configuration will work for your Plot')"));
    }
    $data['addLink'] = $addLink;
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "List of Columns - ".$plotName." - ".$formName;
    $data['formHeading'] = "";
    $this->load->view('forms/columnlist',$data);
  }

  function addcolumnmulti()
  {
    if(!isset($this->session->userdata['configPlotID']) || !isset($this->session->userdata['formType']))
    {
      redirect('forms/selectplot');
    }
    //get the session PlotID and formType from session
    //get the list of already existing columns for the plot
    //get the option to Add/Update/Delete the columns
    $plotID = $this->session->userdata('configPlotID');
    $plotName = $this->session->userdata('plotName');
    //$plotName = $this->configmodel->getPlotNameByID($plotID);
    $formType = $this->session->userdata('formType');
    $formName = $this->_getFormName($formType);

    $databaseName = $this->session->userdata('selectedPlotName');
    $plotColumnQuery = $this->configmodel->getDataByPlotID($plotID,$databaseName,$formType);

    $this->table->set_empty("&nbsp;");
    if($plotColumnQuery->num_rows() > 0)
    {
      $this->table->set_heading('Number', 'Column','Action');
      $plotColumnResult = $plotColumnQuery->result();
      foreach($plotColumnResult as $plotColumnRow)
      {
        $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
        $attributesArray = explode("\t",$plotColumnRow->Attributes);
        $columnHeader = $attributesArray[0];
        $this->table->add_row($plotColumnRow->ColumnNumber,$columnHeader,
                              //anchor('forms/updateColumn/'.$dataEntryConfigID,'update',array('class'=>'update')).' '.
          			          anchor('forms/deleteColumn/'.$dataEntryConfigID,'delete',array('class'=>'delete','onclick'=>"return confirm('Are you sure, you want to delete this record?')"))  );
      }
    }
    else
    {
       $this->table->add_row('No Columns Added Yet. Please Click "Add a New Column".');
    }
    $data['table'] = $this->table->generate();

    //Add a button to Add New Column
    $addLink = anchor('forms/selectcolumntype/','Add a New Column',array('class'=>'add'));
    if($plotColumnQuery->num_rows() > 0 )
    {
       $addLink = $addLink."&nbsp;&nbsp;&nbsp;".anchor('forms/sortlist/','Rearrange Columns',array('class'=>'update'))
                            ."&nbsp;&nbsp;&nbsp;"
                            .anchor('multistem/createform/','Preview Form',array('class'=>'view', 'target'=>'_blank'))
                            ."&nbsp;&nbsp;&nbsp;"
                            .anchor('forms/createconfigfile/','Create Config File',array('class'=>'write'))
                            ;
    }
    else
    {
      $addLink = $addLink."&nbsp;&nbsp;&nbsp;".anchor('forms/usedefault','Use Default Config File',array('class'=>'update', 'onclick'=>"return confirm('Preview and make sure that the default configuration will work for your Plot')"));
    }
    $data['addLink'] = $addLink;
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "List of Columns - ".$plotName." - ".$formName;
    $data['formHeading'] = "";
    $this->load->view('forms/columnlist',$data);
  }

  function addcolumnbig()
  {
    if(!isset($this->session->userdata['configPlotID']) || !isset($this->session->userdata['formType']))
    {
      redirect('forms/selectplot');
    }
    //get the session PlotID and formType from session
    //get the list of already existing columns for the plot
    //get the option to Add/Update/Delete the columns
    $plotID = $this->session->userdata('configPlotID');
    $plotName = $this->session->userdata('plotName');
    //$plotName = $this->configmodel->getPlotNameByID($plotID);
    $formType = $this->session->userdata('formType');
    $formName = $this->_getFormName($formType);

    $databaseName = $this->session->userdata('selectedPlotName');
    $plotColumnQuery = $this->configmodel->getDataByPlotID($plotID,$databaseName,$formType);

    $this->table->set_empty("&nbsp;");
    if($plotColumnQuery->num_rows() > 0)
    {
      $this->table->set_heading('Number', 'Column','Action');
      $plotColumnResult = $plotColumnQuery->result();
      foreach($plotColumnResult as $plotColumnRow)
      {
        $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
        $attributesArray = explode("\t",$plotColumnRow->Attributes);
        $columnHeader = $attributesArray[0];
        $this->table->add_row($plotColumnRow->ColumnNumber,$columnHeader,
                              //anchor('forms/updateColumn/'.$dataEntryConfigID,'update',array('class'=>'update')).' '.
          			          anchor('forms/deleteColumn/'.$dataEntryConfigID,'delete',array('class'=>'delete','onclick'=>"return confirm('Are you sure, you want to delete this record?')"))  );
      }
    }
    else
    {
       $this->table->add_row('No Columns Added Yet. Please Click "Add a New Column".');
    }
    $data['table'] = $this->table->generate();

    //Add a button to Add New Column
    $addLink = anchor('forms/selectcolumntype/','Add a New Column',array('class'=>'add'));
    if($plotColumnQuery->num_rows() > 0 )
    {
       $addLink = $addLink."&nbsp;&nbsp;&nbsp;".anchor('forms/sortlist/','Rearrange Columns',array('class'=>'update'))
                            ."&nbsp;&nbsp;&nbsp;"
                            .anchor('bigtree/createform/','Preview Form',array('class'=>'view', 'target'=>'_blank'))
                            ."&nbsp;&nbsp;&nbsp;"
                            .anchor('forms/createconfigfile/','Create Config File',array('class'=>'write'))
                            ;
    }
    else
    {
      $addLink = $addLink."&nbsp;&nbsp;&nbsp;".anchor('forms/usedefault','Use Default Config File',array('class'=>'update', 'onclick'=>"return confirm('Preview and make sure that the default configuration will work for your Plot')"));
    }
    $data['addLink'] = $addLink;
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "List of Columns - ".$plotName." - ".$formName;
    $data['formHeading'] = "";
    $this->load->view('forms/columnlist',$data);
  }

  function selectcolumntype()
  {
    //after the addcolumn page
    //select the type of column to be added
    $plotID = $this->session->userdata('configPlotID');
    $plotName = $this->session->userdata('plotName');
    //$plotName = $this->configmodel->getPlotNameByID($plotID);
    $formType = $this->session->userdata('formType');
    $formName = $this->_getFormName($formType);

    $this->table->set_empty("&nbsp;");
    $this->table->add_row(anchor('formtypes/textform/','Simple textbox with text, integer or decimal values without limits',array('class'=>'add')));
    $this->table->add_row(anchor('formtypes/limitform/','Simple textbox with numeric value with limits',array('class'=>'add')));
    if($formType == 'bigform')
    {
      $this->table->add_row(anchor('formtypes/quadratdropdown','Add Quadrat dropdown',array('class'=>'add')));
    }
    $this->table->add_row(anchor('formtypes/speciesdropdown/','Add Species dropdown',array('class'=>'add')));
    $this->table->add_row(anchor('formtypes/subquaddropdown/','Add Subquadrat dropdown',array('class'=>'add')));
    $this->table->add_row(anchor('formtypes/userdropdown/','Add User dropdown',array('class'=>'add')));
    $this->table->add_row(anchor('formtypes/twotextform/','Simple textbox with a prefix value',array('class'=>'add')));
    $this->table->add_row(anchor('formtypes/tagstemform/','Tree Tag Increment with Stem Tag',array('class'=>'add')));
    $data['table'] = $this->table->generate();

    $data['backLink'] = anchor('forms/addcolumn/','Back',array('class'=>'back'));
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Select a Column Type - ".$plotName." - ".$formName;
    $data['formHeading'] = "";
    $this->load->view('forms/selectcolumntype',$data);
  }

  function dropdown_check($str)
  {
     if($str == 'default')
     {
        $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
        return FALSE;
     }
     else
     {
        return True;
     }
  }

  function _getFormName($formType)
  {
    if($formType == 'newform')
    {
      $formName = "New Plants Form";
    }
    elseif($formType == 'oldform')
    {
      $formName = "Old Trees Form";
    }
    elseif($formType == 'multiform')
    {
      $formName = "Multi Stem Form";
    }
    elseif($formType == "bigform")
    {
      $formName = "Big Trees Form";
    }
    return $formName;
  }

  function deleteColumn($dataEntryConfigID)
  {
    $plotID = $this->session->userdata('configPlotID');
    $formType = $this->session->userdata('formType');
    $this->configmodel->deleteColumn($dataEntryConfigID);
    $this->_resetColumnNumbers($plotID,$formType);
    redirect('forms/addcolumn');
  }

  function _resetColumnNumbers($plotID,$formType)
  {
    $databaseName = $this->session->userdata('selectedPlotName');
    $plotColumnQuery = $this->configmodel->getDataByPlotID($plotID,$databaseName,$formType);
    $plotColumnCount = $plotColumnQuery->num_rows();
    $i = 1;
    if($plotColumnCount > 0)
    {
      foreach($plotColumnQuery->result() as $plotColumnRow)
      {
        $this->configmodel->resetColumnNumber($plotColumnRow->DataEntryConfig_ID,$i);
        $i++;
      }
    }
  }

  function sortlist()
  {
    if(!isset($this->session->userdata['configPlotID']) || !isset($this->session->userdata['formType']))
    {
      redirect('forms/selectplot');
    }
    //get the session PlotID and formType from session
    $plotID = $this->session->userdata('configPlotID');
    $plotName = $this->session->userdata('plotName');
    //$plotName = $this->configmodel->getPlotNameByID($plotID);
    $formType = $this->session->userdata('formType');
    $formName = $this->_getFormName($formType);

    $databaseName = $this->session->userdata('selectedPlotName');
    $plotColumnQuery = $this->configmodel->getDataByPlotID($plotID,$databaseName,$formType);

    if($plotColumnQuery->num_rows() > 0 )
    {
      $sortList = "<ul>";
      //$this->table->set_heading('Column');
      $plotColumnResult = $plotColumnQuery->result();
      foreach($plotColumnResult as $plotColumnRow)
      {
        $dataEntryConfigID = $plotColumnRow->DataEntryConfig_ID;
        $attributesArray = explode("\t",$plotColumnRow->Attributes);
        $columnHeader = $attributesArray[0];
        //$this->table->add_row($columnHeader);
        $sortList = $sortList.'<li id="recordsArray_'.$dataEntryConfigID.'">'.$plotColumnRow->ColumnNumber.". ".$columnHeader.'</li>';
      }
      $sortList = $sortList."</ul>";

    }
    else
    {
       $sortList = 'No Columns Added Yet. Please Click "Add a New Column" First.';
    }
    $data['list'] = $sortList;
    //$submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');
    // $data['button'] = form_button($submitButtonA);
    $data['button']= '<p><input type="button" value="Update" onclick="updateList()"/></p>';

    $data['backLink'] = anchor('forms/addcolumn/','Back',array('class'=>'back'));
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Sort Column List - ".$plotName." - ".$formName;
    $data['formHeading'] = "";
    $data['formOpen'] = form_open('forms/updatesortinglist');
    $this->load->view('forms/sortlist',$data);
  }

  function updatesortlist()
  {
    $updateRecordsArray = $_POST['recordsArray'];

    $listingCounter = 1;
	foreach ($updateRecordsArray as $dataEntryConfigID)
    {
        $this->configmodel->resetColumnNumber($dataEntryConfigID,$listingCounter);
		$listingCounter = $listingCounter + 1;
	}
    $color = $this->_randomcolor();
    echo '<span style="color:#'.$color.'; font-size:medium;">List Updated!!</span>';
  }

  function _randomcolor()
  {
    mt_srand((double)microtime()*1000000);
    $c = '';
    while(strlen($c)<6){
        $c .= sprintf("%02X", mt_rand(0, 200));
    }
    return $c;
  }

  function createconfigfile()
  {
    $plotID = $this->session->userdata('configPlotID');
    $plotName = $this->session->userdata('plotName');
    $databaseName = $this->session->userdata('selectedPlotName');
    $formType = $this->session->userdata('formType');
    $formName = $this->_getFormName($formType);

    $databaseName = $this->session->userdata('selectedPlotName');
    $plotColumnQuery = $this->configmodel->getDataByPlotID($plotID,$databaseName,$formType);

    if($plotColumnQuery->num_rows() > 0)
    {
      $this->load->helper('file');

      $fileName = $formType."_".$databaseName."_".$plotName."_".$plotID;
      $fileName = str_replace(" ","",$fileName);
      $header = join('$',array("ColumnNumber","ColumnType","Attributes"));
      $nextline = "\r\n";

      write_file('./files/configfiles/'.$fileName.'.txt', $header,'w+');

      write_file('./files/configfiles/'.$fileName.'.txt', $nextline,'a');

      $plotColumnResult = $plotColumnQuery->result();
      foreach($plotColumnResult as $plotColumnRow)
      {
        $dataRow = join('$',array($plotColumnRow->ColumnNumber,$plotColumnRow->ColumnType,$plotColumnRow->Attributes));
        write_file('./files/configfiles/'.$fileName.'.txt', $dataRow,'a');
        write_file('./files/configfiles/'.$fileName.'.txt', $nextline,'a');
      }
    }
    $data['text'] = '<div class="success">Config File Created.</div>';
    $data['backLink'] = anchor('forms/addcolumn/','Back',array('class'=>'back'));
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "File Created - ".$plotName." - ".$formName;
    $data['formHeading'] = "";
    $this->load->view('forms/simpletext',$data);
  }

  function usedefault()
  {
    $plotID = $this->session->userdata('configPlotID');
    $plotName = $this->session->userdata('plotName');
    $databaseName = $this->session->userdata('selectedPlotName');
    $formType = $this->session->userdata('formType');

    $this->load->library('formlibrary');
    $fileDefault = base_url()."files/defaultconfigfiles/".$formType.".txt";
    $formDetailResult = $this->formlibrary->readConfigFile($fileDefault);
    foreach($formDetailResult as $formRow)
    {
      $columnNumber = $formRow->ColumnNumber;
      $columnType = $formRow->ColumnType;
      $attributes = $formRow->Attributes;
      $this->configmodel->insertFormData($plotID,$formType,$columnNumber,$columnType,$attributes);
    }
    if($formType == 'newform')
    {
      redirect('forms/addcolumn');
    }
    elseif($formType == 'oldform')
    {
      redirect('forms/addcolumnold');
    }
    elseif($formType == 'multiform')
    {
      redirect('forms/addcolumnmulti');
    }
    elseif($formType == 'bigform')
    {
      redirect('forms/addcolumnbig');
    }
  }

  function listcolumnnames()
  {
    $tableA = array(array('Columns','Column Name(use this name while adding columns'),
              array('TreeID', 'treeID'),
              array('Tag, Tree Tag', 'tag'),
              array('StemID', 'stemID'),
              array('Stem Tag, Multi Stem', 'stemTag'),
              array('QuadratID', 'quadratID'),
              array('Quadrat Name', 'quadratName'),
              array('Subquadrat ', 'subquadrat'),
              array('SpeciesID', 'speciesID'),
              array('Mnemonic, Species', 'species'),
              array('SubSpeciesID', 'subSpeciesID'),
              array('PlotID', 'plotID'),
              array('CensusID', 'censusID'),
              array('PlotCensusNumber', 'plotCensusNumber'),
              array('Primary Stem', 'primaryStem'),
              array('X', 'x'),
              array('Y', 'y'),
              array('DBH, Diameter', 'dbh'),
              array('OldDBH, Old Diameter', 'olddbh'),
              array('HOM, Height', 'hom'),
              array('OldHOM, Old Height', 'oldhom'),
              array('Codes', 'codes'),
              array('Old Codes', 'oldcodes'),
              array('Comments', 'comments'),
              array('Exact Date', 'exactDate'),
              array('Errors', 'errors'),
              array('Old Trees', 'oldTrees'),
              array('Big Trees', 'bigTrees'),
              array('Extra1(if not listed)', 'extra1'),
              array('Extra2(if not listed)', 'extra2'),
              array('Extra3(if not listed)', 'extra3'),
              array('Extra4(if not listed)', 'extra4'),
              array('Extra5(if not listed)', 'extra5'));
    $dataTable['table'] = $this->table->generate($tableA);
    $dataTable['title'] = 'CTFS/SIGEO Forest Plot Census Data';
    $dataTable['contentTitle'] = 'List of Column Names';
    $this->load->view('user/tsmcode', $dataTable);
  }


}