<?php

class Oldplant extends Controller {

  function Oldplant()
  {
    parent::Controller();
    if($this->session->userdata('loggedin') !== '1')
    {
      redirect('main','location');
    }
    $this->load->model('formmodel');
  }

  function selectcensus()
  {
    if(isset($this->session->userdata['censusID']))
    {
      $this->session->unset_userdata('censusID');
    }
    $data['title'] = "Configuration Form";
    $data['contentTitle'] = "Select a Census ID";
    $data['formHeading'] = "";
    $data['formOpen'] = form_open("oldplant/createform");
    $plotID = $this->session->userdata('configPlotID');
    $data['table'] = $this->_selectCensusTable($plotID);
    $data['backLink'] = "";
    $this->load->view('forms/simpleform',$data);
  }

  function _selectCensusTable($plotID)
  {
    $censusID = set_value('selectPlot');

    $censusIDA = $this->formmodel->getCensusList($plotID);

    $submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');

    $censusIDDD = form_dropdown('censusID',$censusIDA);
    $submitButton = form_button($submitButtonA);

    $formTableA = array(array(),
                        array('Select Last Census ID : ',$censusIDDD),
                        array('',"<br />"),
                        array('',$submitButton)
                        );

    $this->table->set_empty("");
    $formTable = $this->table->generate($formTableA);

    return $formTable;
  }

  function createform()
  {
    $plotID = $this->session->userdata('configPlotID');
    $formType = $this->session->userdata('formType');
    $lastSubquadrat = ""; //used to create blank rows after a subquadrat ends

    $checkTabA = array();

    if(isset($this->session->userdata['censusID']))
    {
      $censusID = $this->session->userdata('censusID');
    }
    else
    {
      $censusID = $this->input->post('censusID');
      $this->session->set_userdata('censusID',$censusID);
    }

    if(isset($_POST['getform']))
    {
     $quadratName = $this->input->post('quadrat');
    }
    else
    {
      $firstQuadratNameQ = $this->formmodel->getAllQuadratNames($plotID);
      $firstQuadratNameR = $firstQuadratNameQ->row();
      $quadratName = $firstQuadratNameR->QuadratName;
    }

    $this->load->model('configmodel');
    $databaseName = $this->session->userdata('selectedPlotName');
    $formDetailQuery = $this->configmodel->getDataByPlotID($plotID,$databaseName,$formType);
    $formDetailResult = $formDetailQuery->result();
    foreach($formDetailResult as $formDetailRow)
    {
      if($formDetailRow->ColumnType == 'oldcolumn')
      {
        $attributes = $formDetailRow->Attributes;
        $columnNumber = $formDetailRow->ColumnNumber;
        $attributesArray = $this->_sortOldFormData($attributes);
        $columnName = $attributesArray['columnName'];
        if($columnName == 'subquadrat')
        {
          $maxX = $attributesArray['maxX'];
          $maxY = $attributesArray['maxY'];
          $orderBy = 'subquadrat';
        }
        elseif($columnName == 'nosubTag')
        {
          $maxX = $attributesArray['maxX'];
          $maxY = $attributesArray['maxY'];
          $orderBy = 'treetag';
        }
      }
    }
    $subquadQuery = "SELECT QDimX as DimX, QDimY as DimY FROM Site WHERE PlotID = ".$plotID;
    $subquadReturnQuery = $this->formmodel->subquadDDQuery($subquadQuery);
    $subquadRow = $subquadReturnQuery->row();
    $dimX = $subquadRow->DimX;
    $dimY = $subquadRow->DimY;



    $lastCensusID = $censusID - 1;
    if($lastCensusID == 0)
    {
      $data['title'] = "Configuration Form";
      $data['contentTitle'] = "Select a Census ID";
      $data['formHeading'] = "";
      $data['formOpen'] = "";
      $plotID = $this->session->userdata('configPlotID');
      $data['table'] = '<br /><br /><div class="error">Old data does not exist for Census 1.</div>';
      $data['backLink'] = "";
      $this->load->view('forms/simpleform',$data);
    }
    else
    {
      //Create Table
      $tmpl = array ( 'table_open'  => '<table id="formtable">' );
      $this->table->set_template($tmpl);
      $this->table->set_empty("&nbsp;");
      //$this->table->set_heading($headerListA);


      $this->load->model('formmodel');
      if($lastCensusID > 2)
      {
        $treeDeadArray = $this->formmodel->treeDead($lastCensusID,$plotID,$quadratName);
      }
      else
      {
        $treeDeadArray = array();
      }
      $oldDataExtractQuery = $this->formmodel->olddataextract($lastCensusID,$plotID,$quadratName,$maxX,$maxY,$dimX,$dimY,$orderBy,$treeDeadArray);

      if($oldDataExtractQuery->num_rows > 0)
      {
        $rowNumber = 1;
        foreach($oldDataExtractQuery->result() as $oldExtractRow)
        {
          if($formDetailQuery->num_rows() > 0)
          {
            foreach($formDetailResult as $formDetailRow)
            {
              if($formDetailRow->ColumnType == 'oldcolumn')
              {
                $attributes = $formDetailRow->Attributes;
                $columnNumber = $formDetailRow->ColumnNumber;

                $attributesArray = $this->_sortOldFormData($attributes);
                $columnHeader = $attributesArray['columnHeader'];
                $headerListA[$columnNumber] = $columnHeader;
                $columnName = $attributesArray['columnName'];
                $columnNameA[$columnNumber] = $columnName;
                $columnSize = $attributesArray['columnSize'];


                if($columnName == 'subquadrat')
                {
                  $startsWith = $attributesArray['startsWith'];
                  $maxX = $attributesArray['maxX'];
                  $maxY = $attributesArray['maxY'];

                  if($startsWith == '0')
                  {
                    $in = 0;
                  }
                  else
                  {
                    $in = 1;
                  }
                  $qX = $oldExtractRow->QX;
                  $qY = $oldExtractRow->QY;
                  if($qX != "")
                  {
                    $qX = $in + intval(($qX-$dimX*intval($qX/$dimX))/$maxX);
                    if($startsWith == 'A')
                    {
                      $aX = 'A';
                      for($zz=1;$zz<$qX;$zz++)
                      {
                        ++$aX;
                      }
                      $qX = $aX;
                    }
                  }
                  if($qY != "")
                  {
                     $qY = $in + intval(($qY-$dimY*intval($qY/$dimY))/$maxY);
                  }
                  $subquadrat = $qX.$qY;
                  $columnListA[$columnNumber] = $this->_readOnlyAddColumn($subquadrat,$columnName,$rowNumber,$columnSize);
                  if($lastSubquadrat !== $subquadrat)
                  {
                    $this->table->add_row('<br /><br />');  //to create gap after a group of subquadrats
                  }
                  $lastSubquadrat = $subquadrat;
                  $checkTabA[$columnNumber] = "no";

                 }
                 elseif($columnName == 'tag')
                 {
                   $treeTag = $oldExtractRow->Tag;
                   $columnListA[$columnNumber] = $this->_readOnlyAddColumn($treeTag,$columnName,$rowNumber,$columnSize);
                   $checkTabA[$columnNumber] = "no";
                 }
                 elseif($columnName == 'nosubTag')
                 {
                   $treeTag = $oldExtractRow->Tag;
                   $columnListA[$columnNumber] = $this->_readOnlyAddColumn($treeTag,$columnName,$rowNumber,$columnSize);
                   $checkTabA[$columnNumber] = "no";
                 }
                 elseif($columnName == 'stemTag')
                 {
                   $readOnly = $attributesArray['readOnly'];
                   $stemTag = $oldExtractRow->StemTag;
                   if($readOnly == "no")
                   {
                     $columnListA[$columnNumber] = $this->_notReadOnlyAddColumn($stemTag,$columnName,$rowNumber,$columnSize);
                     $checkTabA[$columnNumber] = "yes";
                   }
                   else
                   {
                     $columnListA[$columnNumber] = $this->_readOnlyAddColumn($stemTag,$columnName,$rowNumber,$columnSize);
                     $checkTabA[$columnNumber] = "no";
                   }
                 }
                 elseif($columnName == 'species')
                 {
                   $species = $oldExtractRow->Mnemonic;
                   $columnListA[$columnNumber] = $this->_readOnlyAddColumn($species,$columnName,$rowNumber,$columnSize);
                   $checkTabA[$columnNumber] = "no";
                 }
                 elseif($columnName == 'olddbh')
                 {
                   $dbh = $oldExtractRow->DBH;
                   $columnListA[$columnNumber] = $this->_readOnlyAddColumn($dbh,$columnName,$rowNumber,$columnSize);
                   $checkTabA[$columnNumber] = "no";
                 }
                 elseif($columnName == 'oldcodes')
                 {
                   $code = $oldExtractRow->ListOfTSM;
                   $columnListA[$columnNumber] = $this->_readOnlyAddColumn($code,$columnName,$rowNumber,$columnSize);
                   $checkTabA[$columnNumber] = "no";
                 }
                 elseif($columnName == 'oldhom')
                 {
                   $hom = $oldExtractRow->HOM;
                   $columnListA[$columnNumber] = $this->_readOnlyAddColumn($hom,$columnName,$rowNumber,$columnSize);
                   $checkTabA[$columnNumber] = "no";
                 }
                 elseif($columnName == 'x')
                 {
                   $qx = $oldExtractRow->QX;
                   $columnListA[$columnNumber] = $this->_readOnlyAddColumn($qx,$columnName,$rowNumber,$columnSize);
                   $checkTabA[$columnNumber] = "no";
                 }
                 elseif($columnName == 'y')
                 {
                   $qy = $oldExtractRow->QY;
                   $columnListA[$columnNumber] = $this->_readOnlyAddColumn($qy,$columnName,$rowNumber,$columnSize);
                   $checkTabA[$columnNumber] = "no";
                 }
                 else{
                   $column = $oldExtractRow->$columnName;
                   $columnListA[$columnNumber] = $this->_readOnlyAddColumn($column,$columnName,$rowNumber,$columnSize);
                   $checkTabA[$columnNumber] = "no";
                 }
               }
               elseif($formDetailRow->ColumnType == 'text')
               {
                 $attributes = $formDetailRow->Attributes;
                 $columnNumber = $formDetailRow->ColumnNumber;
                 $columnDetailA = $this->_textAttributes($attributes);
                 $columnName = $columnDetailA['columnName'];
                 $columnNameA[$columnNumber] = $columnName;
                 $headerListA[$columnNumber] = $columnDetailA['columnHeader'];
                 $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                 $columnListA[$formDetailRow->ColumnNumber] = $this->_addColumnRow($columnDetailA,$rowNumber);
                 $checkTabA[$columnNumber] = "yes";
               }
               elseif($formDetailRow->ColumnType == "limit")
               {
                 $attributes = $formDetailRow->Attributes;
                 $columnNumber = $formDetailRow->ColumnNumber;
                 $columnDetailA = $this->_limitAttributes($attributes);
                 $columnName = $columnDetailA['columnName'];
                 $columnNameA[$columnNumber] = $columnName;
                 $headerListA[$columnNumber] = $columnDetailA['columnHeader'];
                 $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                 $columnListA[$formDetailRow->ColumnNumber] = $this->_addColumnRow($columnDetailA,$rowNumber);
                 $checkTabA[$columnNumber] = "yes";
               }
             }
             $stemID = $oldExtractRow->StemID;
             $stemColumnName = 'stemID_'.$rowNumber;
             $stemColumnNumber = $columnNumber + 1;
             $columnListA[$stemColumnNumber] = form_hidden($stemColumnName,$stemID);
          }
          else
          {
            echo "Add Columns First!!";
            die();
          }
          $this->table->add_row($columnListA);
          $rowNumber++;
        }
        $this->table->set_heading($headerListA);
        $data['table2'] = $this->table->generate();

        /////////////Table 1 - Top Panel///////////////////////
        $this->load->model('formmodel');

        $quadratA = $this->formmodel->getQuadratNames($plotID);
        $quadratDD = form_dropdown('quadrat',$quadratA,$quadratName);

        $quadratNameHD = form_hidden('quadratName',$quadratName);

        $personnelA = $this->formmodel->getPersonnelNames();
        $collectedDD = form_dropdown('collected[]',$personnelA);
        $checkedDD = form_dropdown('checked[]',$personnelA);
        $enteredDD = form_dropdown('entered[]',$personnelA);
        $getFormOpen = form_open("oldplant/createform");

        ///Hidden///
        $num_collected_Hidden = '<input type="hidden" id="num_collected" name="num_collected" value="1" />';
        $num_checked_Hidden = '<input type="hidden" id="num_checked" name="num_checked"  value="1" />';
        $num_entered_Hidden = '<input type="hidden" id="num_entered" name="num_entered" value="1" />';
        $row_count = '<input type="hidden" id="row_count" name="row_count" value="'.$rowNumber.'" />';

        $hiddenValues = $num_collected_Hidden.$num_checked_Hidden.$num_entered_Hidden.$row_count.$quadratNameHD;
        ///////////


        //$submitButtonA = array('name'=>'submitButton','id'=>'button','type'=>'submit','content'=>'Submit');

        $this->load->library('formlibrary');
        $formOpen = form_open("oldplantfile");
        $data['table1'] = $this->formlibrary->addTopPanel2($plotID,$quadratDD,$collectedDD,$checkedDD,$enteredDD,$getFormOpen,$formOpen);
        /////////////////////////////////////////////////////////
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Old Plant Form";
        $data['formHeading'] = "";
        $data['formOpen'] = ''; //formOpen for main form echo in addTopPanel2 because this form open get echo before the getFormOpen
        $data['backLink'] = anchor('forms/addcolumn/','Back',array('class'=>'back'));
        $data['checkTabJS'] = $this->_createCheckTab($columnNameA,$checkTabA); //CheckTab Javascript
        //$data['insertRowJS'] = $this->_insertRow($formDetailResult);
        //$data['checkTabJS'] = "";
        $data['insertRowJS'] = "";
        $data['submitButton'] = "";
        $data['hiddenValues'] = $hiddenValues;
        $this->load->view('treeforms/simpleform',$data);
        ///////////
      }
      else
      {
        $quadratA = $this->formmodel->getQuadratNames($plotID);
        $quadratDD = form_dropdown('quadrat',$quadratA,$quadratName);
        $submitButtonA = array('name'=>'getform','id'=>'button','type'=>'submit','content'=>'Submit');
        $submitButton = form_button($submitButtonA);

        $quadTableA = array(array(''),
                     array('Quadrat Name: ',$quadratDD,'&nbsp;&nbsp;&nbsp;',$submitButton)
                    );
        $this->table->set_empty("");
        $quadTable = $this->table->generate($quadTableA);


        $data['table'] = '<br /><br /><div class="error">Unable to extract old data for Quadrat: '.$quadratName.'.</div><br /><h5>Select another quadrat</h5><br />'.$quadTable;
        $data['formOpen'] = form_open("oldplant/createform");
        $data['backLink'] = '';

        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Select a Census ID";
        $data['formHeading'] = "";
       // $data['formOpen'] = "";
        $plotID = $this->session->userdata('configPlotID');
        //$data['table'] = '<br /><br /><div class="error">Unable to get Old Data Extracted!!</div>';
        //$data['backLink'] = "";
        $this->load->view('forms/simpleform',$data);
      }
    }
  }


  function _sortOldFormData($attributes)
  {
    $attributesList = explode("\t",$attributes);
    $attributesArray['columnHeader'] = $attributesList[0];
    $attributesArray['columnName'] = $attributesList[1];
    $attributesArray['columnSize'] = $attributesList[2];
    if($attributesArray['columnName'] == 'subquadrat')
    {
      $attributesArray['startsWith'] = $attributesList[3];
      $attributesArray['maxX'] = $attributesList[4];
      $attributesArray['maxY'] = $attributesList[5];
    }
    elseif($attributesArray['columnName'] == 'nosubTag')
    {
      $attributesArray['maxX'] = $attributesList[3];
      $attributesArray['maxY'] = $attributesList[4];
    }
    elseif($attributesArray['columnName'] == 'stemTag')
    {
      $attributesArray['readOnly'] = $attributesList[3];
    }
    return $attributesArray;
  }

  function _readOnlyAddColumn($value,$columnName,$rowNumber,$columnSize)
  {
    $columnName = $columnName."_".$rowNumber;
    $onKeyStroke = 'return checkTab(event,this);';

    $dataA = array('id'=>$columnName,'name'=>$columnName,'value'=>$value,'size'=>$columnSize,'readonly'=>'readonly','style'=>'background:#CCCCCC; border:0; text-align: center;');
    $columnTbx = form_input($dataA);
    return $columnTbx;
  }

  function _hiddenAddColumn($value,$columnName,$rowNumber)
  {
    $columnName = $columnName."_".$rowNumber;
    $onKeyStroke = 'return checkTab(event,this);';

    $dataA = array('id'=>$columnName,'name'=>$columnName,'value'=>$value,'size'=>$columnSize);
    $columnTbx = form_hidden($dataA);
    return $columnTbx;
  }

  function _notReadOnlyAddColumn($value,$columnName,$rowNumber,$columnSize)
  {
    $columnName = $columnName."_".$rowNumber;
    $onKeyStroke = 'return checkTab(event,this);';

    if($value == "")
    {
      $dataA = array('id'=>$columnName,'name'=>$columnName,'value'=>$value,'size'=>$columnSize,'onkeypress'=>$onKeyStroke, 'style'=>'text-align: center;');
    }
    else
    {
      $dataA = array('id'=>$columnName,'name'=>$columnName,'value'=>$value,'size'=>$columnSize,'readonly'=>'readonly','style'=>'background:#CCCCCC; border:0; text-align: center;');
    }
    $columnTbx = form_input($dataA);
    return $columnTbx;
  }

  function _textAttributes($attributes)
  {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['defaultValue'] = $attributeA[3];
    $array['columnSize'] = $attributeA[4];
    $array['allowNull'] = $attributeA[5];

    return $array;
  }

  function _limitAttributes($attributes)
  {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['upperLimit'] = $attributeA[3];
    $array['lowerLimit'] = $attributeA[4];
    $array['defaultValue'] = $attributeA[5];
    $array['columnSize'] = $attributeA[6];
    $array['allowNull'] = $attributeA[7];

    return $array;
  }

  function _addColumnRow($columnDetailA,$rowNumber)
  {
    if($columnDetailA['columnType'] == 'text')
    {
      $columnName =$columnDetailA['columnName']."_".$rowNumber;
      $columnSize = $columnDetailA['columnSize'];
      $defaultValue = $columnDetailA['defaultValue'];
      if($columnDetailA['allowNull'] == 'no')
      {
        $onBlur = 'validateNotEmpty(this)';
      }
      else
      {
        $onBlur = "";
      }
      $onKeyStroke = 'return checkTab(event,this);';


      $dataA = array('id'=>$columnName,'name'=>$columnName,'size'=>$columnSize,'value'=>$defaultValue,'onblur'=>$onBlur,'onkeypress'=>$onKeyStroke);
      $columnTbx = form_input($dataA);
      return $columnTbx;
    }
    elseif($columnDetailA['columnType'] == 'limit')
    {
      $columnName =$columnDetailA['columnName']."_".$rowNumber;
      $columnSize = $columnDetailA['columnSize'];
      $defaultValue = $columnDetailA['defaultValue'];
      $lowerLimit = $columnDetailA['lowerLimit'];
      $upperLimit = $columnDetailA['upperLimit'];
      if($columnDetailA['allowNull'] == 'no')
      {
        $onBlur = 'validateLimitNotEmpty(this,'.$lowerLimit.','.$upperLimit.')';
      }
      else
      {
        $onBlur = 'validateLimit(this,'.$lowerLimit.','.$upperLimit.')';
      }
      $onKeyStroke = 'return checkTab(event,this);';

      $dataA = array('id'=>$columnName,'name'=>$columnName,'size'=>$columnSize,'value'=>$defaultValue,'onblur'=>$onBlur,'onkeypress'=>$onKeyStroke);
      $columnTbx = form_input($dataA).'<br />';
      return $columnTbx;
    }
  }

//////////////////CheckTab JS/////////////////////////////
  function _createCheckTab($columnNameA,$checkTabA)
  {
    $checkTabAsc = $this->_checkTabAsc($columnNameA,$checkTabA);
    $checkTabDesc = $this->_checkTabDesc($columnNameA,$checkTabA);
    $checkTabJS = '<script type="text/javascript">
                    function checkTab(e, obj) {
                   	var keynum;
                	var keychar;
                	var next;

                	if(window.event) // IE
                  	{
                  		keynum = e.keyCode;
                  	}
                	else if(e.which) // Netscape/Firefox/Opera
                  	{
                 		 keynum = e.which;
                  	}

                   if (keynum == 42) {
                        var id_arr = obj.id.split("_");'
                        .$checkTabAsc.
                        'return false;
                    } else if (keynum == 47) {
                        var id_arr = obj.id.split("_");'
                        .$checkTabDesc.
                        'return false;
                    } else if (keynum == 13) {
                        return false;
                    } else {
                		return true;
                	}
                }
                </script>';
    return $checkTabJS;
  }

  function _checkTabAsc($columnNameA,$checkTabA)
  {
    $checkTabAsc = "";
    $arrayCount = count($columnNameA);
    $a = "";
    $b = "";

    for($i=1;$i <=$arrayCount;$i++)
    {
      if($checkTabA[$i] == 'yes')
      {
        $firstColumn = $columnNameA[$i];
        $a = $i;
        break;
      }
    }
    for($i=1;$i <=$arrayCount;$i++)
    {
      if($checkTabA[$i] == 'yes')
      {
        $lastColumn = $columnNameA[$i];
        $b = $i;
      }
    }

    for($i=1;$i <=$arrayCount;$i++)
    {
     if($checkTabA[$i] == 'yes')
     {
       $columnName1 = $columnNameA[$i];
       for($j=$i+1;$j<=$arrayCount;$j++)
       {
         if($checkTabA[$j] == 'yes')
         {
           $columnName2 = $columnNameA[$j];
           break;
         }
       }
       //$columnName1 = $columnNameA[$i];
       //$columnName2 = $columnNameA[$i+1];
       if($i == $a)
       {
         $checkTabAsc = $checkTabAsc.'if (id_arr[0] == "'.$columnName1.'")
                                  {
                                  document.getElementById("'.$columnName2.'_"+id_arr[1] ).focus();
                                  }';
       }
       elseif($i == $b)
       {
         $checkTabAsc = $checkTabAsc.'else if (id_arr[0] == "'.$columnName1.'")
                                  {
                                   var nextRow = parseInt(id_arr[1]) + 1;
                                   document.getElementById("'.$firstColumn.'_"+nextRow).focus();
                                  }';
       }
       else
       {
          $checkTabAsc = $checkTabAsc.'else if (id_arr[0] == "'.$columnName1.'")
                                  {
                                   document.getElementById("'.$columnName2.'_"+id_arr[1] ).focus();
                                  }';
       }
      }
    }
    return $checkTabAsc;
  }

  function _checkTabDesc($columnNameA,$checkTabA)
  {
    $checkTabDesc = "";
    $arrayCount = count($columnNameA);
    $a = "";
    $b = "";
    for($i=1;$i <=$arrayCount;$i++)
    {
      if($checkTabA[$i] == 'yes')
      {
        $firstColumn = $columnNameA[$i];
        $a = $i;
        break;
      }
    }
    for($i=1;$i <=$arrayCount;$i++)
    {
      if($checkTabA[$i] == 'yes')
      {
        $lastColumn = $columnNameA[$i];
        $b = $i;
      }
    }
    for($i=$arrayCount;$i >= 1;$i--)
    {
     if($checkTabA[$i] == 'yes')
     {
       $columnName1 = $columnNameA[$i];
       for($j=$i-1;$j >= 1;$j--)
       {
         if($checkTabA[$j] == 'yes')
         {
           $columnName2 = $columnNameA[$j];
           break;
         }
       }
       //$columnName1 = $columnNameA[$i];
       //$columnName2 = $columnNameA[$i-1];
       if($i == $b)
       {
        $checkTabDesc = $checkTabDesc.'if (id_arr[0] == "'.$columnName1.'")
                                {
                                 document.getElementById("'.$columnName2.'_"+id_arr[1] ).focus();
                                }';
       }
       elseif($i == $a)
       {
         $checkTabDesc = $checkTabDesc.'else if (id_arr[0] == "'.$firstColumn.'")
                                {
                                 var prevRow = parseInt(id_arr[1]) - 1;
                                 document.getElementById("'.$lastColumn.'_"+prevRow ).focus();
                                }';
       }
       else
       {
         $checkTabDesc = $checkTabDesc.'else if (id_arr[0] == "'.$columnName1.'")
                                {
                                 document.getElementById("'.$columnName2.'_"+id_arr[1] ).focus();
                                }';
       }
      }
    }
    return $checkTabDesc;
  }
/////////////////////////////////////////////////////////////////////



}
