<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Formlibrary
{
  ////////////////////Add Top Panel//////////////////////////////////////
  function addTopPanel($plotID,$quadratDD,$collectedDD,$checkedDD,$enteredDD)
  {
    $table = '<table id="header_table" width="850">
              <tr><td colspan="2">
              <p class="quadrat_label">Quadrat: '.
              $quadratDD.'
              </p></td></tr>
              <tr id="collected_row">
              <td align="right">Data Collected By:</td>
              <td>'.$collectedDD.'<input name="collected_add" id="collected_add" type="button" value="+" onclick="addCollector(\'collected\')" />
              </td>
              <td align="right">Date Collected:</td>
              <td>'.$this->createDate(time(),"collected").'
              </td></tr>
              <tr id="checked_row"><td align="right">Data Checked By:</td>
              <td>'.$checkedDD.'<input id="collected_add" type="button" value="+" onclick="addChecker(\'checked\')" />
              </td><td align="right">Date Checked:</td>
              <td>'.$this->createDate(time(),"checked").'
              </td></tr>
              <tr id="entered_row"><td align="right">Data Entered By:</td>
              <td>'.$enteredDD.'
              </td><td align="right">Date Entered:</td>
              <td>'.$this->createDate(time(),"entered").'
              </td></tr>
              </table>';
    return $table;
  }

  function getDateArray($time)
  {
	$day = date('j',$time);
	$day_lz = date('d',$time);

	$dow = date('w',$time);
	$dow_name = date('D',$time);
	$dow_name_abbr = date('l',$time);

	$month = date('n',$time);
	$month_lz = date('m',$time);

	$month_days = date('t',$time);

	$month_name = date('F',$time);
	$month_name_abbr = date('M',$time);

	$year_4 = date('Y',$time);
	$year_2 = date('y',$time);

	$leap_year = date('L',$time);

	$dateArray = Array("day" => $day, "day_lz" => $day_lz, "dow" => $dow, "dow_name" => $dow_name,
						"dow_name_abbr" => $dow_name_abbr, "month" => $month,
						"month_lz" => $month_lz, "month_days" => $month_days,
						"month_name" => $month_name, "month_name_abbr" => $month_name_abbr,
						"year_4" => $year_4, "year_2" => $year_2, "leap_year" => $leap_year );

	unset($day,$day_lz,$dow,$dow_nam,$dow_name_abbr,$month,$month_lz,$month_days,$month_name,
		  $month_name_abbr,$year_4,$year_2,$leap_year);

	return $dateArray;
  }

  function createDate($time, $name)
  {
    $createDate = "";
    $dateArr = $this->getDateArray($time);
    $month_array = Array ("January","February","March","April","May","June","July","August","September","October","November","December");
    $createDate = "<select id='".$name."_month' name='".$name."_month' onchange='update_day(\"$name\",\"month\")'>";

    for($i = 0; $i < 12; $i++)
    {
      $adj = $i + 1;
      if($adj < 10)
      {
        if($adj == $dateArr['month'])
        {
          $createDate = $createDate."<option value='0".$adj."' selected=true>".$month_array[$i]."</option>";
        }
        else
        {
          $createDate = $createDate."<option value='0".$adj."'>".$month_array[$i]."</option>";
        }
      }
      else
      {
        if($adj == $dateArr['month'])
        {
          $createDate = $createDate."<option value='".$adj."' selected=true>".$month_array[$i]."</option>";
        }
        else
        {
          $createDate = $createDate."<option value='".$adj."'>".$month_array[$i]."</option>";
        }
      }
    }

   $createDate = $createDate. "</select>";
   $createDate = $createDate."<select id='".$name."_day' name='".$name."_day'>";


   for($i = 0; $i < $dateArr['month_days']; $i++)
   {
    $adj = $i + 1;
    if($adj < 10)
    {
   	  if($adj == $dateArr['day'])
      {
   	    $createDate = $createDate."<option value='0".$adj."' selected=true>".$adj."</option>";
      }
      else
      {
   	    $createDate = $createDate."<option value='0".$adj."'>".$adj."</option>";
      }
    }
    else
    {
      if($adj == $dateArr['day'])
      {
        $createDate = $createDate."<option value='".$adj."' selected=true>".$adj."</option>";
      }
      else
      {
        $createDate = $createDate."<option value='".$adj."'>".$adj."</option>";
      }
    }
   }

   $createDate = $createDate."</select>";
   $createDate = $createDate."<select id='".$name."_year' name='".$name."_year' onchange='update_day(\"$name\",\"year\")'>";


   for($i = $dateArr['year_4'] - 10; $i < $dateArr['year_4'] + 20; $i++)
   {
    if($i == $dateArr['year_4'])
    {
      $createDate = $createDate."<option value='".$i."' selected=true>".$i."</option>";
    }
    else
    {
      $createDate = $createDate."<option value='".$i."'>".$i."</option>";
    }
   }

   $createDate = $createDate."</select>";
   unset($month_array,$dateArr);

   return $createDate;
  }
///////////////////////////////////////////////////////////////////////////

//////////////////Add Top Panel 2 with quadrat get form///////////////////////
  function addTopPanel2($plotID,$quadratDD,$collectedDD,$checkedDD,$enteredDD,$getFormOpen,$formOpen)
  {
   $quadratForm = $getFormOpen.'
                   <p class="quadrat_label">Quadrat: '.
                   $quadratDD.'
                   <button type="submit" name="getform">Get Form</button>
                   </p>
                   </form>';
    $personnel = $formOpen.
              '<table id="header_table" width="850">
              <tr><td colspan="2">
              </td></tr>
              <tr id="collected_row">
              <td align="right">Data Collected By:</td>
              <td>'.$collectedDD.'<input name="collected_add" id="collected_add" type="button" value="+" onclick="addCollector(\'collected\')" />
              </td>
              <td align="right">Date Collected:</td>
              <td>'.$this->createDate(time(),"collected").'
              </td></tr>
              <tr id="checked_row"><td align="right">Data Checked By:</td>
              <td>'.$checkedDD.'<input id="collected_add" type="button" value="+" onclick="addChecker(\'checked\')" />
              </td><td align="right">Date Checked:</td>
              <td>'.$this->createDate(time(),"checked").'
              </td></tr>
              <tr id="entered_row"><td align="right">Data Entered By:</td>
              <td>'.$enteredDD.'
              </td><td align="right">Date Entered:</td>
              <td>'.$this->createDate(time(),"entered").'
              </td></tr>
              </table>';
    $table = $quadratForm.$personnel;
    return $table;
  }
///////////////////////////////////////////////////////////////////////////

//////////////////Add Top Panel 3 without quadrat///////////////////////
function addTopPanel3($plotID,$collectedDD,$checkedDD,$enteredDD)
  {
    $table = '<table id="header_table" width="850">
              <tr id="collected_row">
              <td align="right">Data Collected By:</td>
              <td>'.$collectedDD.'<input name="collected_add" id="collected_add" type="button" value="+" onclick="addCollector(\'collected\')" />
              </td>
              <td align="right">Date Collected:</td>
              <td>'.$this->createDate(time(),"collected").'
              </td></tr>
              <tr id="checked_row"><td align="right">Data Checked By:</td>
              <td>'.$checkedDD.'<input id="collected_add" type="button" value="+" onclick="addChecker(\'checked\')" />
              </td><td align="right">Date Checked:</td>
              <td>'.$this->createDate(time(),"checked").'
              </td></tr>
              <tr id="entered_row"><td align="right">Data Entered By:</td>
              <td>'.$enteredDD.'
              </td><td align="right">Date Entered:</td>
              <td>'.$this->createDate(time(),"entered").'
              </td></tr>
              </table>';
    return $table;
  }
///////////////////////////////////////////////////////////////////////

/////////////////////Read and Put Config file data into Array///////////////////////
  function readConfigFile($fileName)
  {
    $maxRows = 4096;
    $delimiter = '$';
    if($this->fileExists($fileName))
    {
      if(($file = fopen($fileName,"r")) !== FALSE)
      {
        $firstRow = fgetcsv($file,$maxRows,$delimiter);
        while(($data = fgetcsv($file,$maxRows,$delimiter)) !== FALSE)
        {
          if( $data[0] != null )
          {
            $numColumns = count($data);
            for($c=0; $c<$numColumns; $c++)
            {
              $row[$firstRow[$c]] = $data[$c];
            }
            $row1 = (object) $row;
            $content[] = $row1;
          }
        }
      }
      fclose($file);
    }
    else
    {
      $content = "Not Found";
    }
    return $content;
  }

  function fileExists($path)
  {
    return (@fopen($path,"r")==true);
  }
////////////////////////////////////////////////////////////////////////////

/////////////////Read the data file and put data in arrays/////////////////
  function readDataFile($fileName)
  {
    $maxRows = 4096;
    $delimiter = "\t";
    if($this->fileExists($fileName))
    {
      if(($file = fopen($fileName,"r")) !== FALSE)
      {
        $firstRow = fgetcsv($file,$maxRows,$delimiter);

        $x = 0;

        $collectedCount = $firstRow[$x];
        $x++;
        for($i=1; $i<=$collectedCount; $i++)
        {
          $collected[] = $firstRow[$x];
          $x++;
        }
        $collected[] = $firstRow[$x];
        $x++;

        $checkedCount = $firstRow[$x];
        $x++;
        for($i=1; $i<=$checkedCount; $i++)
        {
          $checked[] = $firstRow[$x];
          $x++;
        }
        $checked[] = $firstRow[$x];
        $x++;

        $x++; //entered count is also there - which is always one
        $entered[] = $firstRow[$x];
        $x++;
        $entered[] = $firstRow[$x];

        $secondRow = fgetcsv($file,$maxRows,$delimiter);
        while(($data = fgetcsv($file,$maxRows,$delimiter)) !== FALSE)
        {
          if( $data[0] != null )
          {
            $numColumns = count($secondRow);
            for($c=0; $c<$numColumns; $c++)
            {
              $row[$secondRow[$c]] = $data[$c];
            }
            $row1 = (object) $row;
            $content[] = $row1;
          }
        }
      }
      fclose($file);
      $fileNameArray = explode("_",$fileName);
      $fileInfo['plotName'] = $fileNameArray[1];
      $fileInfo['censusNumber'] = $fileNameArray[2];
      $fileInfo['quadratName'] = $fileNameArray[3];

      $fileContent['fileInfo'] = $fileInfo;
      $fileContent['collected'] = $collected;
      $fileContent['checked'] = $checked;
      $fileContent['entered'] = $entered;
      $fileContent['content'] = $content;
    }
    else
    {
      $fileContent = "Not Found";
    }
    return $fileContent;
  }
//////////////////////////////////////////////////////////////


/////////////////Read the data file and put data in arrays/////////////////
  function readDataFileBig($fileName)
  {
    $maxRows = 4096;
    $delimiter = "\t";
    if($this->fileExists($fileName))
    {
      if(($file = fopen($fileName,"r")) !== FALSE)
      {
        $firstRow = fgetcsv($file,$maxRows,$delimiter);

        $x = 0;

        $collectedCount = $firstRow[$x];
        $x++;
        for($i=1; $i<=$collectedCount; $i++)
        {
          $collected[] = $firstRow[$x];
          $x++;
        }
        $collected[] = $firstRow[$x];
        $x++;

        $checkedCount = $firstRow[$x];
        $x++;
        for($i=1; $i<=$checkedCount; $i++)
        {
          $checked[] = $firstRow[$x];
          $x++;
        }
        $checked[] = $firstRow[$x];
        $x++;

        $x++; //entered count is also there - which is always one
        $entered[] = $firstRow[$x];
        $x++;
        $entered[] = $firstRow[$x];

        $secondRow = fgetcsv($file,$maxRows,$delimiter);
        while(($data = fgetcsv($file,$maxRows,$delimiter)) !== FALSE)
        {
          if( $data[0] != null )
          {
            $numColumns = count($secondRow);
            for($c=0; $c<$numColumns; $c++)
            {
              $row[$secondRow[$c]] = $data[$c];
            }
            $row1 = (object) $row;
            $content[] = $row1;
          }
        }
      }
      fclose($file);
      $fileNameArray = explode("_",$fileName);
      $fileInfo['plotName'] = $fileNameArray[1];
      $fileInfo['censusNumber'] = $fileNameArray[2];

      $fileContent['fileInfo'] = $fileInfo;
      $fileContent['collected'] = $collected;
      $fileContent['checked'] = $checked;
      $fileContent['entered'] = $entered;
      $fileContent['content'] = $content;
    }
    else
    {
      $fileContent = "Not Found";
    }
    return $fileContent;
  }
//////////////////////////////////////////////////////////////


///////////List column names in forms and in database temp table////////

////////////////////////////////////////////////////////////////////////

}