<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Oldplantlibrary
{
  function processData($formDetailResult)
  {
    foreach($formDetailResult as $formDetailRow)
      {
        if($formDetailRow->ColumnType == 'oldcolumn')
        {
          $columnDetailA = $this->_sortOldFormData($formDetailRow->Attributes);
          $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
          $columnDetailA['columnType'] = $formDetailRow->ColumnType;
          $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
          $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
          $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
        }
        elseif($formDetailRow->ColumnType == 'text')
        {
          $columnDetailA = $this->_textAttributes($formDetailRow->Attributes);
          $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
          $columnDetailA['columnType'] = $formDetailRow->ColumnType;
          $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
          $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
          $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
        }
        elseif($formDetailRow->ColumnType == 'limit')
        {
          $columnDetailA = $this->_limitAttributes($formDetailRow->Attributes);
          $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
          $columnDetailA['columnType'] = $formDetailRow->ColumnType;
          $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
          $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
          $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];

        }
      }
      $processData['headerListA'] = $headerListA;
      $processData['columnNameA'] = $columnNameA;
      $processData['columnTypeA'] = $columnTypeA;
      return $processData;
  }

  function _sortOldFormData($attributes)
  {
    $attributesList = explode("\t",$attributes);
    $attributesArray['columnHeader'] = $attributesList[0];
    $attributesArray['columnName'] = $attributesList[1];
    $attributesArray['columnSize'] = $attributesList[2];
    if($attributesArray['columnName'] == 'subquadrat')
    {
      $attributesArray['maxX'] = $attributesList[3];
      $attributesArray['maxY'] = $attributesList[4];
    }
    elseif($attributesArray['columnName'] == 'nosubTag')
    {
      $attributesArray['maxX'] = $attributesList[3];
      $attributesArray['maxY'] = $attributesList[4];
    }
    elseif($attributesArray['columnName'] == 'stemTag')
    {
      $attributesArray['readOnly'] = $attributesList[3];
    }
    return $attributesArray;
  }

  function _textAttributes($attributes)
  {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['defaultValue'] = $attributeA[3];
    $array['columnSize'] = $attributeA[4];
    $array['allowNull'] = $attributeA[5];

    return $array;
  }

  function _limitAttributes($attributes)
  {
    $attributeA = explode("\t",$attributes);
    $array['columnHeader'] = $attributeA[0];
    $array['columnName'] = $attributeA[1];
    $array['dataType'] = $attributeA[2];
    $array['upperLimit'] = $attributeA[3];
    $array['lowerLimit'] = $attributeA[4];
    $array['defaultValue'] = $attributeA[5];
    $array['columnSize'] = $attributeA[6];
    $array['allowNull'] = $attributeA[7];

    return $array;
  }
}