<?php

class Datauploadmodel extends Model{

    function Datauploadmodel()
    {
      parent::Model();
      $database = $this->session->userdata('databaseName');
      $this->datauploaddb = $this->load->database($database,TRUE);
    }

    /*function createStemNumberTable()
    {
      $query1 = $this->datauploaddb->query("DROP TABLE IF EXISTS TempStemNumber");


      $query2 = $this->datauploaddb->query("CREATE TABLE `TempStemNumber`(
                                          `TempID` int(10) unsigned NOT NULL auto_increment,
                                          `TreeID` int(10) unsigned,
                                          `MaxStem` int(10) unsigned,
                                          PRIMARY KEY (TempID),
                                          KEY `indexTreeID` (`TreeID`)
                                          )ENGINE=MyISAM DEFAULT CHARSET=latin1");
      $selectMaxStemQuery = $this->_selectMaxStem();
      if($selectMaxStemQuery->num_rows() > 0)
      {
        foreach($selectMaxStemQuery->result() as $selectMaxStemRow)
        {
          $insertArray = array('TreeID'=>$selectMaxStemRow->TreeID,'MaxStem'=>$selectMaxStemRow->MaxStem);
          $this->insertRowIntoTable('TempStemNumber',$insertArray);
        }
      }
    }

    function _selectMaxStem()
    {
      $this->datauploaddb->select('TreeID');
      $this->datauploaddb->select_max('StemNumber','MaxStem');
      $this->datauploaddb->from('Stem');
      $this->datauploaddb->group_by('TreeID');
      $query = $this->datauploaddb->get();

      return $query;
    }*/

    function createTempAllTrees($tempTreeName)
    {
      $query1 = $this->datauploaddb->query("DROP TABLE IF EXISTS ".$tempTreeName);

      $query2 = $this->datauploaddb->query("CREATE TABLE ".$tempTreeName."(
                                          TempID           INT UNSIGNED AUTO_INCREMENT,
                                          QuadratName      VARCHAR(12),
                                          Subquad          INT UNSIGNED,
                                          Tag              VARCHAR(10),
                                          StemTag          VARCHAR(32),
                                          Mnemonic         VARCHAR(10),
                                          DBH              FLOAT(8) DEFAULT NULL,
                                          Codes            VARCHAR(50) DEFAULT NULL,
                                          HOM              FLOAT(8) DEFAULT NULL,
                                          Comments         VARCHAR(256) DEFAULT NULL,
                                          TreeID           INT UNSIGNED,
                                          StemID           INT UNSIGNED,
                                          ExactDate        DATE,
                                          QuadratID        INT UNSIGNED,
                                          X                FLOAT(8),
                                          Y                FLOAT(8),
                                          SpeciesID        INT UNSIGNED,
                                          SubSpeciesID     INT UNSIGNED,
                                          DBHID            INT UNSIGNED,
                                          PlotCensusNumber INT UNSIGNED,
                                          CensusID         INT UNSIGNED,
                                          PrimaryStem      VARCHAR(20),
                                          PlotID           INT UNSIGNED,
                                          Errors           VARCHAR(256),
                                          Tagged           VARCHAR(1),
                                          PRIMARY KEY (TempID),
                                          KEY `indexTagStemTag` (`Tag`,`StemTag`),
                                          KEY `indexTreeIDStemID` (`TreeID`,`StemID`),
                                          KEY `indexQuadratNamePlotID` (`QuadratName`,`PlotID`),
                                          KEY `indexMnemonic` (`Mnemonic`)
                                         )ENGINE=MyISAM");
    }

    function updateTempOldTrees()
    {
      /*$q1 = $this->datauploaddb->query("UPDATE TempOldTrees as a, Tree as b, Stem as c, Quadrat as d
                                       SET a.TreeID=b.TreeID
                                       WHERE a.Tag=b.Tag
                                       AND b.TreeID=c.TreeID
                                       AND c.QuadratID=d.QuadratID
                                       AND a.PlotID=d.PlotID
                                       AND (a.TreeID IS NULL OR a.TreeID=0)");*/

      $q1 = $this->datauploaddb->query("UPDATE TempOldTrees as a, ViewFullTable as b
                                       SET a.TreeID=b.TreeID
                                       WHERE a.Tag=b.Tag
                                       AND a.PlotID=b.PlotID
                                       AND (a.TreeID IS NULL OR a.TreeID=0)");
    }

    function updateTempBigTrees()
    {
      $q1 = $this->datauploaddb->query("UPDATE TempBigTrees as a, ViewFullTable as b
                                       SET a.TreeID=b.TreeID
                                       WHERE a.Tag=b.Tag
                                       AND a.PlotID=b.PlotID
                                       AND (a.TreeID IS NULL OR a.TreeID=0)");
    }

    function updateStemIDs($tempTreeName)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tempTreeName." as a, ViewFullTable as b
                                       SET a.StemID=b.StemID
                                       WHERE a.Tag=b.Tag
                                       AND a.StemTag=b.StemTag
                                       AND a.PlotID=b.PlotID
                                       AND (a.StemID IS NULL OR a.StemID=0)");
    }

    function updateTempMultiStem()
    {
      /*$q1 = $this->datauploaddb->query("UPDATE TempMultiStems SET StemID=NULL");*/

      $q1 = $this->datauploaddb->query("UPDATE TempMultiStems as a, ViewFullTable as b
                                        SET a.TreeID=b.TreeID
                                        WHERE a.Tag=b.Tag
                                        AND a.PlotID=b.PlotID");
    }

    function updateTempNewPlants()
    {
      $q1 = $this->datauploaddb->query("UPDATE TempNewPlants SET OldTrees='n'");

      $q2 = $this->datauploaddb->query("UPDATE TempNewPlants as a, Tree as b, Stem as c, Quadrat as d
                                        SET a.TreeID=b.TreeID, a.OldTrees='y'
                                        WHERE a.Tag=b.Tag
                                        AND b.TreeID=c.TreeID
                                        AND c.QuadratID=d.QuadratID
                                        AND a.PlotID=d.PlotID");
      //$q3 = $this->datauploaddb->query("UPDATE TempNewPlants SET StemID=null");
    }

    function oldTreesinTempNewPlants()
    {
      $q1 = $this->datauploaddb->query("SELECT COUNT(*) as cnt FROM TempNewPlants WHERE OldTrees='y'");

      $row = $q1->row_array();
      return $row['cnt'];
    }


    function updateTempTreesForBigTrees($tempTreeName,$bigCode,$selectQuery)
    {
      if($selectQuery == 'Both')
      {
        $q1 = $this->datauploaddb->query("UPDATE ".$tempTreeName." SET BigTrees='n'");

        $q2 = $this->datauploaddb->query("UPDATE ".$tempTreeName." as a, TempBigTrees as b
                                          Set a.BigTrees='y'
                                          WHERE a.Tag=b.Tag
                                          AND a.StemTag=b.StemTag
                                          AND a.PlotID=b.PlotID
                                          AND a.DBH=0
                                          AND a.codes like '%".$bigCode[0]."%'");
      }
      else
      {
        $q1 = $this->datauploaddb->query("UPDATE ".$tempTreeName." SET BigTrees='n'");
      }
    }

    function getOldTreesNoBigTrees()
    {
      $q1 = $this->datauploaddb->query("SELECT QuadratID,QuadratName,SubQuad,Tag,StemTag,Mnemonic,DBH,Codes,Comments,TreeID,StemID,PlotCensusNumber,CensusID,PrimaryStem,HOM,ExactDate,X,Y,PlotID,Errors
                                        FROM TempOldTrees WHERE BigTrees<>'y' OR BigTrees IS NULL");
      return $q1;
    }

    function checkIfStemTagsUsed($plotID)
    {
      $q1 = $this->datauploaddb->query("SELECT count(DBHID) AS cnt FROM ViewFullTable
                                        WHERE StemTag is not null
                                        AND StemTag<>''
                                        AND PlotID=".$plotID);
      $row = $q1->row_array();
      return $row['cnt'];
    }

    /*function updateStemIDFromStemTable($tableName)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tableName." as a, Stem as b
                                        SET a.StemID=b.StemID
                                        WHERE a.TreeID=b.TreeID
                                        AND a.StemTag=b.StemTag");
    }*/

    function getDataForTempAllTrees($tableName)
    {
      $q1 = $this->datauploaddb->query("SELECT TempID,QuadratID,QuadratName,SubQuad,Tag,StemTag,Mnemonic,DBH,Codes,Comments,TreeID,StemID,PlotCensusNumber,CensusID,PrimaryStem,HOM,ExactDate,X,Y,PlotID,Errors
                                        FROM ".$tableName);
      return $q1;
    }

    function getMaxStemTag($treeID)
    {
      $q1 = $this->datauploaddb->query("Select MAX(StemTag) AS maxStemTag FROM Stem WHERE TreeID=".$treeID);
      if($q1->num_rows() > 0)
      {
        $row = $q1->row_array();
        $max = $row['maxStemTag'];
      }
      else
      {
        $max = "No";
      }
      return $max;
    }

    function updTempTreeStemTag($tempTreeName,$tempID,$stemTag)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tempTreeName." SET StemTag=".$stemTag." WHERE TempID=".$tempID);
    }

    function getOldTreesInTempNewPlants()
    {
      $q1 = $this->datauploaddb->query("SELECT QuadratID,QuadratName,SubQuad,Tag,StemTag,Mnemonic,DBH,Codes,Comments,TreeID,StemID,PlotCensusNumber,CensusID,PrimaryStem,HOM,ExactDate,X,Y,PlotID,Errors
                                        FROM TempNewPlants WHERE OldTrees='y'");
      return $q1;
    }

    function setStemIDsToNull($tableName)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tableName." SET StemID=NULL");
    }

    function setTreeIDsToNull($tableName)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tableName." SET TreeID=NULL");
    }

    function getCensusID($plotID,$censusNumber)
    {
      $q1 = $this->datauploaddb->query("SELECT CensusID FROM Census
                                        WHERE PlotID=".$plotID.
                                        " AND PlotCensusNumber=".$censusNumber);
      $row = $q1->row_array();
      return $row['CensusID'];
    }

    function updateLocationTempAllTrees($tempTreeName)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tempTreeName." as a, ViewFullTable as b
                                        SET a.X=b.QX, a.Y=b.QY
                                        WHERE a.TreeID=b.TreeID
                                        AND a.StemID=b.StemID
                                        AND (a.X IS NULL OR a.X = '')
                                        AND (a.Y IS NULL OR a.Y = '')");

      $q2 = $this->datauploaddb->query("UPDATE ".$tempTreeName." as a, ViewFullTable as b
                                        SET a.X=b.QX, a.Y=b.QY
                                        WHERE a.TreeID=b.TreeID
                                        AND (a.StemID='' OR a.StemID IS NULL)
                                        AND (a.X IS NULL OR a.X = '')
                                        AND (a.Y IS NULL OR a.Y = '')");
    }

    function createTempTree1($tempTrees1)
    {
      $q1 = $this->datauploaddb->query("DROP TABLE IF EXISTS ".$tempTrees1);
      $q2 = $this->datauploaddb->query("CREATE TABLE ".$tempTrees1."(
                                       TreeID           INT UNSIGNED,
                                       StemID           INT UNSIGNED,
                                       Cnt              INT UNSIGNED,
                                       PRIMARY KEY (TreeID)
                                       )ENGINE=MyISAM");
    }

    /*function createTempTree2($tempTrees2)
    {
      $q1 = $this->datauploaddb->query("DROP TABLE IF EXISTS ".$tempTrees2);
      $q2 = $this->datauploaddb->query("CREATE TABLE ".$tempTrees2."(
                                       TreeID           INT UNSIGNED,
                                       StemID           INT UNSIGNED,
                                       Codes	         VARCHAR(50) DEFAULT NULL,
                                       Cnt              INT UNSIGNED,
                                       PRIMARY KEY (TreeID)
                                       )ENGINE=MyISAM");
    }

    function insertOneStemIntoTempTree1($tempTrees1,$censusID)
    {
      $q1 = $this->datauploaddb->query("INSERT INTO ".$tempTrees1." (TreeID,StemID,Cnt)
                                        SELECT TreeID, StemID, COUNT(DISTINCT StemID) as Cnt FROM ViewFullTable
                                        WHERE censusID = ".$censusid.
                                        " GROUP BY TreeID
                                        HAVING Cnt=1");
    }*/

   /* function updTempAllTreesTagged($tempAllTrees,$taggedValue)
    {
      $q1 = $this->datauploaddb->query("Update ".$tempAllTrees." SET Tagged=".$taggedValue);
    }

    function insertOneStemIntoTempTree2($tempTrees2,$tempAllTrees)
    {
      $q1 = $this->datauploaddb->query("INSERT INTO ".$tempTrees2." (TreeID, Codes, Cnt)
                                        SELECT TreeID, Codes, count(TreeID) as Cnt FROM ".$tempAllTrees.
                                        " GROUP BY TreeID
                                        HAVING Cnt=1");
    }

    function deleteRecordsWithCode($tempTrees2,$codeArr)
    {
      $q1 = $this->datauploaddb->query('DELETE FROM '.$tempTrees2.
                                       ' WHERE Codes LIKE "'.$codeArr[0].
                                       '" OR Codes LIKE "%;'.$codeArr[0].
                                       '" OR Codes LIKE "'.$codeArr[0].
                                       ';%" OR Codes LIKE "%;'.$codeArr[0].';%"');
    }*/

    /*function updTempAllTreesTaggedCompare($tempAllTrees,$tempTrees2,$taggedValue)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tempAllTrees." AS a, ".$tempTrees2." AS b
                                        SET Tagged=".$taggedValue.
                                        " WHERE a.TreeID=b.TreeID");
    }

    function updTempAllTreesTaggedJoin($tempAllTrees,$tempTrees1)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tempAllTrees." t1
                                        JOIN ".$tempTrees1." t2 ON t1.TreeID=t2.TreeID
                                        SET t1.StemID=t2.StemID
                                        WHERE t1.Tagged = ".$taggedValue);
    }

    function getMainStem($tempTrees,$censusID)
    {
      $q1 = $this->datauploaddb->query('DROP TABLE IF EXISTS '.$tempTrees);
      $q2 = $this->datauploaddb->query("CREATE TABLE ".$tempTrees."(
                                        TreeID           INT UNSIGNED,
                                        StemID           INT UNSIGNED,
                                        PRIMARY KEY (TreeID,StemID)
                                        )ENGINE=MyISAM");
      $q3 = $this->datauploaddb->query('INSERT INTO '.$tempTrees.' (TreeID,StemID)
                                        SELECT TreeID, StemID FROM ViewFullTable
                                        WHERE censusID = '.$censusID.'
                                        AND PrimaryStem="main"
                                        GROUP BY TreeID,StemID');
    }

    function insertTempTree2Dead($tempTrees2,$tempAllTrees,$codeArr)
    {
      $q1 = $this->datauploaddb->query('INSERT INTO '.$tempTrees2.' (TreeID,Cnt)
                                        SELECT TreeID, count(TreeID) as cnt from '.$tempAllTrees.
                                        ' where Codes like "'.$codeArr[0].
                                        '" or Codes like "%;'.$codeArr[0].
                                        '" or codes like "'.$codeArr[0].
                                        ';%" or Codes like "%;'.$codeArr[0].
                                        ';%" GROUP BY TreeID
                                        HAVING cnt=1');
    }*/

    function getTempNewPlantsSingleStem($tempNewPlants)
    {
      $q1 = $this->datauploaddb->query("SELECT TreeID, TempID, count(TreeID) as cnt FROM ".$tempNewPlants."
                                        WHERE OldTrees='y'
                                        GROUP BY TreeID
                                        HAVING cnt = 1");
      return $q1;
    }

    function getTempNewPlantsCodes($tempNewPlants,$tempID)
    {
      $q1 = $this->datauploaddb->query("SELECT Codes FROM ".$tempNewPlants."
                                        WHERE tempID=".$tempID."
                                        AND !ISNULL(Codes)
                                        AND Codes<>'*'
                                        AND Codes<>''");
      return $q1;
    }

    function getListOfTSM($prevCensusID,$treeID)
    {
      $q1 = $this->datauploaddb->query('SELECT TreeID, StemID, DBH, ListOfTSM from ViewFullTable
                                        WHERE CensusID = '.$prevCensusID.'
                                        AND TreeID = '.$treeID.'
                                        GROUP BY TreeID,StemID');
      return $q1;
    }

    function updateTempNewPlantStemID($tempNewPlants,$stemID,$tempID)
    {
      $q1 = $this->datauploaddb->query('UPDATE '.$tempNewPlants.' SET StemID = '.$stemID.' WHERE tempID = '.$tempID);
    }

    function dropTableIfExist($tableName)
    {
      $q1 = $this->datauploaddb->query("DROP TABLE IF EXISTS ".$tableName);
    }

    function updQuadratTempTrees($tempTreeName)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tempTreeName." as a, Quadrat
                                        SET a.QuadratID=Quadrat.QuadratID
                                        WHERE a.QuadratName=Quadrat.QuadratName
                                        AND a.PlotID=Quadrat.PlotID");
      $q2 = $this->datauploaddb->query("UPDATE ".$tempTreeName."
                                        SET QuadratID=9999
                                        WHERE QuadratID=0
                                        OR QuadratID IS NULL");
    }

    function updSpeciesTempTrees($tempTreeName)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tempTreeName." as a, Species
                                        SET a.SpeciesID=Species.SpeciesID
                                        WHERE a.Mnemonic=Species.Mnemonic
                                        AND CurrentTaxonFlag=1");
    }

    function updDBHNullTempTrees($tempTreeName)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tempTreeName." SET DBH = NULL WHERE DBH = 0");
    }

    function updPrimaryTempTrees($tempTreeName,$code,$description)
    {
      $q1 = $this->datauploaddb->query('UPDATE '.$tempTreeName.'
                                        SET PrimaryStem = "'.$description.'"
                                        WHERE codes like "'.$code.';%"
                                        or codes like "'.$code.'"
                                        or codes like "%;'.$code.'"
                                        or codes like "%;'.$code.';%"');
    }

    function updLocationTempTrees($tempTreeName)
    {
      $q1 = $this->datauploaddb->query("UPDATE ".$tempTreeName." as a, TempLocations as b SET a.X=b.X, a.Y=b.Y WHERE a.Tag=b.Tag
                                                                                                               AND (a.X IS NULL OR a.X = '')
                                                                                                               AND (a.Y IS NULL OR a.Y = '')");
      return $q1;
    }

    function getNullTreeID($tempAllTrees)
    {
      $q1 = $this->datauploaddb->query("SELECT COUNT(*) as Cnt FROM ".$tempAllTrees." WHERE TreeID = 0 OR TreeID IS NULL");

      return $q1;
    }

    function getTsmCodeDesc($code)
    {
      $q1 = $this->datauploaddb->query("SELECT TSMCode,Description FROM TSMAttributes WHERE LOWER(DESCRIPTION)='".$code."'");

      return $q1;
    }

    function getTempAllTreesStemData($tempAllTrees)
    {
      $q1 = $this->datauploaddb->query('SELECT StemID, TreeID, StemTag, QuadratID FROM '.$tempAllTrees);

      return $q1;
    }

    function getStemData($tempStemID)
    {
      $q1 = $this->datauploaddb->query("SELECT StemID, TreeID, StemTag from Stem where StemID=".$tempStemID);

      return $q1;
    }

    function updateStemStemTag($stemID,$stemTag)
    {
      $q1 = $this->datauploaddb->query("UPDATE Stem SET StemTag = '".$stemTag."' WHERE StemID=".$stemID);
    }

    /*function insertIntoStemTreeIDStemID($treeID,$quadratID,$stemTag)
    {
      $q1 = $this->datauploaddb->query("Insert INTO Stem (TreeID, QuadratID, StemTag)
                                        VALUES (".$treeID.",".$quadratID.",'".$stemTag."')");
    }*/

    function getTempAllTreesDBHData($tempAllTrees)
    {
      $q1 = $this->datauploaddb->query('SELECT CensusID, StemID, DBH, HOM, PrimaryStem, ExactDate, Codes FROM '.$tempAllTrees);
      return $q1;
    }

    function getTSMID($code)
    {
      $q1 = $this->datauploaddb->query("SELECT TSMID FROM TSMAttributes WHERE TSMCode='".$code."'");
      return $q1;
    }

    function getTempNewPlantPrimaryNull($tempTreeName)
    {
      $q1 = $this->datauploaddb->query('SELECT TreeID, Tag, TempID from '.$tempTreeName.'
                                        WHERE OldTrees<>"y" and BigTrees<>"y"
                                        AND (PrimaryStem = "" or PrimaryStem IS NULL)
                                        GROUP BY TreeID, Tag');
      return $q1;
    }

    function getAllStemsOfTreeID($tempTreeName,$treeID)
    {
      $q1 = $this->datauploaddb->query("SELECT TreeID, TempID, Codes, HOM, DBH, PrimaryStem from ".$tempTreeName." WHERE TreeID = ".$treeID);
      return $q1;
    }

    function updStemToSecondary($tempTreeName,$code,$treeID)
    {
      $q1 = $this->datauploaddb->query('UPDATE '.$tempTreeName.'
                                        SET PrimaryStem = "'.$code.'"
                                        WHERE TreeID = '.$treeID.'
                                        AND (PrimaryStem = "" or PrimaryStem IS NULL)');
    }

    function updLargestStemPrimary($tempTreeName,$code,$tempID)
    {
       $q1 = $this->datauploaddb->query('UPDATE '.$tempTreeName.' SET PrimaryStem = "'.$code.'" WHERE TempID = '.$tempID);
    }

    function updOtherStemsSecondary($tempTreeName,$code,$treeID,$tempID)
    {
      $q1 = $this->datauploaddb->query('UPDATE '.$tempTreeName.' SET PrimaryStem = "'.$code.'" WHERE TreeID = '.$treeID.' and TempID <> '.$tempID.' and (PrimaryStem = "" or PrimaryStem IS NULL)');
    }

    function getMinStemIDTempTrees($tempTreeName,$treeID)
    {
      $q1 = $this->datauploaddb->query('SELECT min(StemID) as minStem, TempID FROM '.$tempTreeName.' WHERE TreeID = '.$treeID.' GROUP BY TreeID');
      return $q1;
    }

    function checkNewPlantsRequiredFields($tempTreeName)
    {
      $q1 = $this->datauploaddb->query("SELECT COUNT(*) as Cnt FROM ".$tempTreeName." WHERE QuadratID IS NULL OR SpeciesID IS NULL");
      $row = $q1->row_array();
      return $row['Cnt'];
    }

    function getTempTreesTreeData($tempTreeName)
    {
      $q1 = $this->datauploaddb->query("SELECT Tag, StemTag, SpeciesID FROM ".$tempTreeName." WHERE (OldTrees<>'y' OR OldTrees IS NULL) AND (BigTrees<>'y' OR BigTrees IS NULL) GROUP BY Tag,StemTag");
      return $q1;
    }

    function getTempNewPlantsStemData($tempTreeName,$tag,$stemTag)
    {
      if($stemTag == NULL || $stemTag == '')
      {
         $q1 = $this->datauploaddb->query("SELECT TempID, QuadratID, StemTag, X, Y FROM ".$tempTreeName." WHERE (OldTrees<>'y' OR OldTrees IS NULL) AND (BigTrees<>'y' OR BigTrees IS NULL) AND Tag='".$tag."'");
      }
      else
      {
         $q1 = $this->datauploaddb->query("SELECT TempID, QuadratID, StemTag, X, Y FROM ".$tempTreeName." WHERE (OldTrees<>'y' OR OldTrees IS NULL) AND (BigTrees<>'y' OR BigTrees IS NULL) AND Tag='".$tag."' AND StemTag='".$stemTag."'");
      }
      return $q1;
    }

    function getTempNewPlantsDBHData($tempTreeName,$tempID)
    {
      $q1 = $this->datauploaddb->query('SELECT CensusID, StemID, DBH, HOM, PrimaryStem, ExactDate, Codes FROM '.$tempTreeName.'
                                        WHERE TempID='.$tempID);
      return $q1;
    }

    function updTempNewPlantsSinglePrimary($tempTreeName,$tempTrees1,$main)
    {
      $q1 = $this->datauploaddb->query('UPDATE '.$tempTreeName.' t1 join '.$tempTrees1.' t2 ON t1.TreeID=t2.TreeID
                                        SET t1.PrimaryStem="'.$main.'"
                                        WHERE t1.OldTrees<>"y"
                                        AND t1.BigTrees<>"y"
                                        AND (t1.PrimaryStem = "" or t1.PrimaryStem IS NULL)');
    }

    function getTempBigTreesTreeData($tempTreeName)
    {
      $q1 = $this->datauploaddb->query("SELECT TreeID, Tag, StemTag, SpeciesID, SubSpeciesID FROM ".$tempTreeName." GROUP BY TreeID, Tag, StemTag");
      return $q1;
    }

    function getTempBigTreesStemData($tempTreeName,$tag,$stemTag)
    {
      $q1 = $this->datauploaddb->query("SELECT TempID, StemID, QuadratID, StemTag, X, Y FROM ".$tempTreeName." WHERE Tag='".$tag."' AND StemTag='".$stemTag."'");
      return $q1;
    }

    function getTempBigTreesDBHData($tempTreeName,$tempID)
    {
      $q1 = $this->datauploaddb->query('SELECT CensusID, StemID, DBH, HOM, PrimaryStem, ExactDate, Codes FROM '.$tempTreeName.'
                                        WHERE TempID='.$tempID);
      return $q1;
    }

    function getDBHRow($stemID,$censusID)
    {
      $this->datauploaddb->select('*');
      $this->datauploaddb->where('StemID',$stemID);
      $this->datauploaddb->where('CensusID',$censusID);
      $query = $this->datauploaddb->get('DBH');

      return $query;
    }

    function getCodes($description)
    {
      $this->datauploaddb->select('TSMCode');
      $this->datauploaddb->like('Description',$description);
      $query = $this->datauploaddb->get('TSMAttributes');

      $codesarr = array();

      if($query->num_rows() > 0)
      {
        $j = 0;
        foreach($query->result() as $row)
        $codesarr[$j++] = $row->TSMCode;
      }
      else
      {
        $codesarr[0] = 'none';
      }

      return $codesarr;
    }

    function insertRowIntoTable($tableName,$insertArray)
    {
      $query = $this->datauploaddb->insert($tableName,$insertArray);
      return $query;
    }

    function getLastInsertedID()
    {
      $id = $this->datauploaddb->insert_id();
      return $id;
    }

    function ifTableExist($tableName)
    {
      if($this->datauploaddb->table_exists($tableName))
      {
        $exist = TRUE;
      }
      else
      {
        $exist = FALSE;
      }
      return $exist;
    }

     function startTransaction()
    {
      $this->datauploaddb->trans_start();
    }

    function completeTransaction()
    {
      $this->datauploaddb->trans_complete();
      $status = 'Success';
      if ($this->datauploaddb->trans_status() === FALSE)
      {
        $status = 'Error';
      }
      return $status;
    }
}